# AdaptivePredicates

A Julia port of "Routines for Arbitrary Precision Floating-point Arithmetic and Fast Robust Geometric Predicates"
by Jonathan Richard Shewchuk. https://www.cs.cmu.edu/~quake/robust.html

The package provides four predicates. In the functions below, all the inputs should be `NTuple`s with either `Float64` or `Float32` coordinates; complex inputs can be used for `orient2` and `incircle`.

- `orient2(pa, pb, pc)`: Given three points `pa`, `pb`, and `pc` in two dimensions, returns a positive value if the points are in counter-clockwise order; a negative value if they occur in clockwise order; and zero if they are collinear. Equivalently, returns a positive value if `pc` is left of the oriented line from `pa` to `pb`; a negative value if `pc` is right of this line; and zero if they are collinear.
- `orient3(pa, pb, pc, pd)`: Given four points `pa`, `pb`, `pc`, and `pd` in three dimensions, define the oriented plane on which the triangle `(pa, pb, pc)` is positively oriented. Returns a positive value if `pd` is below this plane; a negative value if `pd` is above this plane; and zero if the points are coplanar.
- `incircle(pa, pb, pc, pd)`: Given four points `pa`, `pb`, `pc`, and `pd` in two dimensions, returns a positive value if `pd` is inside the circle through `pa`, `pb`, and `pc`; a negative value if `pd` is outside this circle; and zero if `pd` is on the circle.
- `insphere(pa, pb, pc, pd, pe)`: Given five points `pa`, `pb`, `pc`, `pd`, and `pe` in three dimensions, returns a positive value if `pe` inside of the sphere through `pa`, `pb`, `pc`, and `pd`; a negative value if `pe` is outside this sphere; and zero if `pe` is on the sphere.

We also define the functions `orient2p`, `orient3p`, `incirclep`, and `inspherep` which simply return the sign of the corresponding predicate. For example,
```julia-repl
julia> using AdaptivePredicates

julia> pa, pb, pc = (0.2, 0.3), (0.1, -0.5), (0.7, 0.3);

julia> orient2(pa, pb, pc)
0.39999999999999997

julia> orient2p(pa, pb, pc)
1

julia> pa, pb, pc, pd, pe = (0.3f0, 0.3f0, 0.17f0), (-0.3f0, 1.71f0, 0.0f0), (0.0f0, 0.0f0, 5.0f0), (1.1f0, -0.53f0, 1.2f0), (0.5f0, 0.50f0, 0.5f0);

julia> insphere(pa, pb, pc, pd, pe)
-5.021922f0

julia> inspherep(pa, pb, pc, pd, pe)
-1
```

## Installation

If you want to use the package, you can do
```julia
using Pkg
Pkg.add("AdaptivePredicates")
using AdaptivePredicates
```

## Other Functions 

All the functions from the `predicates.c` file from Shewchuk's original code have been included in this package. This includes,

- All macros have been implemented as functions, e.g. `Fast_Two_Sum` and `Four_Four_Sum`.
- All arithmetic functions have been implemented, e.g. `grow_expansion` and `scale_expansion_zeroelim`.
- All the predicates have been implemented. In particular, not only have `orient2`, `orient3`, `incircle`, and `insphere` been implemented, but also the forms with the suffixes `fast`, `exact`, and `slow` (and `adapt`, but this is what `orient2`, `orient3`, `incircle`, and `insphere` use anyway).

Only the functions `orient2`, `orient3`, `incircle`, and `insphere` have been marked as `public`, as well as their `p` and `fast` counterparts.

## Caveats

Shewchuk's original paper gives no analysis in the presence of underflow or overflow. The only mention of it is:

> This article does not address issues of overflow and underflow, so I allow the exponent to be an integer in the range  $[-\infty, \infty]$. (Fortunately, many applications have inputs whose exponents fall within a circumscribed range. The four predicates implemented for this article will not overflow nor underflow if their inputs have exponents in the range $[-142, 201]$ and IEEE 754 double precision arithmetic is used.)

- Richard Shewchuk, J. Adaptive Precision Floating-Point Arithmetic and Fast Robust Geometric Predicates. Discrete Comput Geom 18(3), 305–363 (1997)

Note that this range comes from the `insphere` predicate. The number range is much wider for `orient2`, for example, since it requires far fewer additions, subtractions, and multiplications.

Thus, for some numbers, the values returned from these predicates may be invalid due to underflow or overflow. In ranges where this is a concern, you should use [ExactPredicates.jl](https://github.com/lairez/ExactPredicates.jl) instead. If you need the values of the predicates and not just their signs, but are outside of the range valid for AdaptivePredicates.jl, you are unfortunately out of luck.

If you need more information about how these predicates work, you should refer to Shewchuk's paper.

## License

The original code is in the public domain and this Julia port is under the MIT License.

function inspherefast(pa, pb, pc, pd, pe)
    @inbounds begin
        aex = pa[1] - pe[1]
        bex = pb[1] - pe[1]
        cex = pc[1] - pe[1]
        dex = pd[1] - pe[1]
        aey = pa[2] - pe[2]
        bey = pb[2] - pe[2]
        cey = pc[2] - pe[2]
        dey = pd[2] - pe[2]
        aez = pa[3] - pe[3]
        bez = pb[3] - pe[3]
        cez = pc[3] - pe[3]
        dez = pd[3] - pe[3]

        ab = aex * bey - bex * aey
        bc = bex * cey - cex * bey
        cd = cex * dey - dex * cey
        da = dex * aey - aex * dey

        ac = aex * cey - cex * aey
        bd = bex * dey - dex * bey

        abc = aez * bc - bez * ac + cez * ab
        bcd = bez * cd - cez * bd + dez * bc
        cda = cez * da + dez * ac + aez * cd
        dab = dez * ab + aez * bd + bez * da

        alift = aex * aex + aey * aey + aez * aez
        blift = bex * bex + bey * bey + bez * bez
        clift = cex * cex + cey * cey + cez * cez
        dlift = dex * dex + dey * dey + dez * dez

        return (dlift * abc - clift * dab) + (blift * cda - alift * bcd)
    end
end

function insphereexact(pa, pb, pc, pd, pe, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h16 = ntuple(_ -> zero(T), Val(16))
        h24 = ntuple(_ -> zero(T), Val(24))
        h32 = ntuple(_ -> zero(T), Val(32))

        axby1, axby0 = Two_Product(pa[1], pb[2])
        bxay1, bxay0 = Two_Product(pb[1], pa[2])
        ab3, ab2, ab1, ab0 = Two_Two_Diff(axby1, axby0, bxay1, bxay0)
        ab = (ab0, ab1, ab2, ab3)

        bxcy1, bxcy0 = Two_Product(pb[1], pc[2])
        cxby1, cxby0 = Two_Product(pc[1], pb[2])
        bc3, bc2, bc1, bc0 = Two_Two_Diff(bxcy1, bxcy0, cxby1, cxby0)
        bc = (bc0, bc1, bc2, bc3)

        cxdy1, cxdy0 = Two_Product(pc[1], pd[2])
        dxcy1, dxcy0 = Two_Product(pd[1], pc[2])
        cd3, cd2, cd1, cd0 = Two_Two_Diff(cxdy1, cxdy0, dxcy1, dxcy0)
        cd = (cd0, cd1, cd2, cd3)

        dxey1, dxey0 = Two_Product(pd[1], pe[2])
        exdy1, exdy0 = Two_Product(pe[1], pd[2])
        de3, de2, de1, de0 = Two_Two_Diff(dxey1, dxey0, exdy1, exdy0)
        de = (de0, de1, de2, de3)

        exay1, exay0 = Two_Product(pe[1], pa[2])
        axey1, axey0 = Two_Product(pa[1], pe[2])
        ea3, ea2, ea1, ea0 = Two_Two_Diff(exay1, exay0, axey1, axey0)
        ea = (ea0, ea1, ea2, ea3)

        axcy1, axcy0 = Two_Product(pa[1], pc[2])
        cxay1, cxay0 = Two_Product(pc[1], pa[2])
        ac3, ac2, ac1, ac0 = Two_Two_Diff(axcy1, axcy0, cxay1, cxay0)
        ac = (ac0, ac1, ac2, ac3)

        bxdy1, bxdy0 = Two_Product(pb[1], pd[2])
        dxby1, dxby0 = Two_Product(pd[1], pb[2])
        bd3, bd2, bd1, bd0 = Two_Two_Diff(bxdy1, bxdy0, dxby1, dxby0)
        bd = (bd0, bd1, bd2, bd3)

        cxey1, cxey0 = Two_Product(pc[1], pe[2])
        excy1, excy0 = Two_Product(pe[1], pc[2])
        ce3, ce2, ce1, ce0 = Two_Two_Diff(cxey1, cxey0, excy1, excy0)
        ce = (ce0, ce1, ce2, ce3)

        dxay1, dxay0 = Two_Product(pd[1], pa[2])
        axdy1, axdy0 = Two_Product(pa[1], pd[2])
        da3, da2, da1, da0 = Two_Two_Diff(dxay1, dxay0, axdy1, axdy0)
        da = (da0, da1, da2, da3)

        exby1, exby0 = Two_Product(pe[1], pb[2])
        bxey1, bxey0 = Two_Product(pb[1], pe[2])
        eb3, eb2, eb1, eb0 = Two_Two_Diff(exby1, exby0, bxey1, bxey0)
        eb = (eb0, eb1, eb2, eb3)

        temp8a, temp8alen = scale_expansion_zeroelim(4, bc, pa[3], h8)
        temp8b, temp8blen = scale_expansion_zeroelim(4, ac, -pb[3], h8)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, h16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, ab, pc[3], temp8a)
        abc, abclen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, cd, pb[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, bd, -pc[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, bc, pd[3], temp8a)
        bcd, bcdlen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, de, pc[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, ce, -pd[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, cd, pe[3], temp8a)
        cde, cdelen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, ea, pd[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, da, -pe[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, de, pa[3], temp8a)
        dea, dealen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, ab, pe[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, eb, -pa[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, ea, pb[3], temp8a)
        eab, eablen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, bd, pa[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, da, pb[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, ab, pd[3], temp8a)
        abd, abdlen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, ce, pb[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, eb, pc[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, bc, pe[3], temp8a)
        bce, bcelen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, da, pc[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, ac, pd[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, cd, pa[3], temp8a)
        cda, cdalen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, eb, pd[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, bd, pe[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, de, pb[3], temp8a)
        deb, deblen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        temp8a, temp8alen = scale_expansion_zeroelim(4, ac, pe[3], temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, ce, pa[3], temp8b)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp8a, temp8alen = scale_expansion_zeroelim(4, ea, pc[3], temp8a)
        eac, eaclen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, h24)

        args = pa, pb, pc, pd, pe, abc, abclen, bcd, bcdlen, cde, cdelen, dea, dealen, eab, eablen, abd, abdlen, bce, bcelen, cda, cdalen, deb, deblen, eac, eaclen, cache

        @check_length _insphereexact args temp48a, temp48alen = fast_expansion_sum_zeroelim(cdelen, cde, bcelen, bce, h32) # temp48a, temp48alen = fast_expansion_sum_zeroelim(cdelen, cde, bcelen, bce, h48_1)
        @check_length _insphereexact args temp48b, temp48blen = fast_expansion_sum_zeroelim(deblen, deb, bcdlen, bcd, h32) # temp48b, temp48blen = fast_expansion_sum_zeroelim(deblen, deb, bcdlen, bcd, h48_2)
        temp48b = .-temp48b
        @check_length _insphereexact args bcde, bcdelen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h32) # bcde, bcdelen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_1)
        @check_length _insphereexact args temp192, xlen = scale_expansion_zeroelim(bcdelen, bcde, pa[1], h32) # temp192, xlen = scale_expansion_zeroelim(bcdelen, bcde, pa[1], h192)
        @check_length _insphereexact args det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pa[1], h32) # det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pa[1], h384_1)
        @check_length _insphereexact args temp192, ylen = scale_expansion_zeroelim(bcdelen, bcde, pa[2], temp192)
        @check_length _insphereexact args det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pa[2], h32) # det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pa[2], h384_2)
        @check_length _insphereexact args temp192, zlen = scale_expansion_zeroelim(bcdelen, bcde, pa[3], temp192)
        @check_length _insphereexact args det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pa[3], h32) # det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pa[3], h384_3)
        @check_length _insphereexact args detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, h32) # detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, h768_1)
        @check_length _insphereexact args adet, alen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h32) # adet, alen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_1)

        @check_length _insphereexact args temp48a, temp48alen = fast_expansion_sum_zeroelim(dealen, dea, cdalen, cda, temp48a)
        @check_length _insphereexact args temp48b, temp48blen = fast_expansion_sum_zeroelim(eaclen, eac, cdelen, cde, temp48b)
        temp48b = .-temp48b
        @check_length _insphereexact args cdea, cdealen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h32) # cdea, cdealen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_2)
        @check_length _insphereexact args temp192, xlen = scale_expansion_zeroelim(cdealen, cdea, pb[1], temp192)
        @check_length _insphereexact args det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pb[1], det384x)
        @check_length _insphereexact args temp192, ylen = scale_expansion_zeroelim(cdealen, cdea, pb[2], temp192)
        @check_length _insphereexact args det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pb[2], det384y)
        @check_length _insphereexact args temp192, zlen = scale_expansion_zeroelim(cdealen, cdea, pb[3], temp192)
        @check_length _insphereexact args det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pb[3], det384z)
        @check_length _insphereexact args detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy)
        @check_length _insphereexact args bdet, blen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h32) # bdet, blen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_2)

        @check_length _insphereexact args temp48a, temp48alen = fast_expansion_sum_zeroelim(eablen, eab, deblen, deb, temp48a)
        @check_length _insphereexact args temp48b, temp48blen = fast_expansion_sum_zeroelim(abdlen, abd, dealen, dea, temp48b)
        temp48b = .-temp48b
        @check_length _insphereexact args deab, deablen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h32) # deab, deablen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_3)
        @check_length _insphereexact args temp192, xlen = scale_expansion_zeroelim(deablen, deab, pc[1], temp192)
        @check_length _insphereexact args det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pc[1], det384x)
        @check_length _insphereexact args temp192, ylen = scale_expansion_zeroelim(deablen, deab, pc[2], temp192)
        @check_length _insphereexact args det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pc[2], det384y)
        @check_length _insphereexact args temp192, zlen = scale_expansion_zeroelim(deablen, deab, pc[3], temp192)
        @check_length _insphereexact args det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pc[3], det384z)
        @check_length _insphereexact args detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy)
        @check_length _insphereexact args cdet, clen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h32) # cdet, clen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_3)

        @check_length _insphereexact args temp48a, temp48alen = fast_expansion_sum_zeroelim(abclen, abc, eaclen, eac, temp48a)
        @check_length _insphereexact args temp48b, temp48blen = fast_expansion_sum_zeroelim(bcelen, bce, eablen, eab, temp48b)
        temp48b = .-temp48b
        @check_length _insphereexact args eabc, eabclen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h32) # eabc, eabclen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_4)
        @check_length _insphereexact args temp192, xlen = scale_expansion_zeroelim(eabclen, eabc, pd[1], temp192)
        @check_length _insphereexact args det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pd[1], det384x)
        @check_length _insphereexact args temp192, ylen = scale_expansion_zeroelim(eabclen, eabc, pd[2], temp192)
        @check_length _insphereexact args det384y, ylen, = scale_expansion_zeroelim(ylen, temp192, pd[2], det384y)
        @check_length _insphereexact args temp192, zlen = scale_expansion_zeroelim(eabclen, eabc, pd[3], temp192)
        @check_length _insphereexact args det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pd[3], det384z)
        @check_length _insphereexact args detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy)
        @check_length _insphereexact args ddet, dlen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h32) # ddet, dlen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_4)

        @check_length _insphereexact args temp48a, temp48alen = fast_expansion_sum_zeroelim(bcdlen, bcd, abdlen, abd, temp48a)
        @check_length _insphereexact args temp48b, temp48blen = fast_expansion_sum_zeroelim(cdalen, cda, abclen, abc, temp48b)
        temp48b = .-temp48b
        @check_length _insphereexact args abcd, abcdlen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h32) # abcd, abcdlen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_5)
        @check_length _insphereexact args temp192, xlen = scale_expansion_zeroelim(abcdlen, abcd, pe[1], temp192)
        @check_length _insphereexact args det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pe[1], det384x)
        @check_length _insphereexact args temp192, ylen = scale_expansion_zeroelim(abcdlen, abcd, pe[2], temp192)
        @check_length _insphereexact args det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pe[2], det384y)
        @check_length _insphereexact args temp192, zlen = scale_expansion_zeroelim(abcdlen, abcd, pe[3], temp192)
        @check_length _insphereexact args det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pe[3], det384z)
        @check_length _insphereexact args detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy)
        @check_length _insphereexact args edet, elen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h32) # edet, elen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_5)

        @check_length _insphereexact args abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h32) # abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h2304_1)
        @check_length _insphereexact args cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h32) # cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h2304_2)
        @check_length _insphereexact args cdedet, cdelen = fast_expansion_sum_zeroelim(cdlen, cddet, elen, edet, h32) # cdedet, cdelen = fast_expansion_sum_zeroelim(cdlen, cddet, elen, edet, h3456)
        @check_length _insphereexact args deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdelen, cdedet, h32) # deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdelen, cdedet, h5760)

        return deter[deterlen]
    end
end
function _insphereexact(pa, pb, pc, pd, pe, abc, abclen, bcd, bcdlen, cde, cdelen, dea, dealen, eab, eablen, abd, abdlen, bce, bcelen, cda, cdalen, deb, deblen, eac, eaclen, cache)
    @inbounds begin
        T = eltype(pa)
        h48_1, h48_2, h96_1, h96_2, h96_3, h96_4, h96_5, h192, _, _, _, _, h384_1, h384_2, h384_3, _, _, h768_1, h1152_1, h1152_2, h1152_3, h1152_4, h1152_5, h2304_1, h2304_2, h3456, h5760 = insphereexact_cache(T, cache)

        temp48a, temp48alen = fast_expansion_sum_zeroelim(cdelen, cde, bcelen, bce, h48_1)
        temp48b, temp48blen = fast_expansion_sum_zeroelim(deblen, deb, bcdlen, bcd, h48_2)
        for i in 1:temp48blen
            temp48b[i] = -temp48b[i]
        end
        bcde, bcdelen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_1)
        temp192, xlen = scale_expansion_zeroelim(bcdelen, bcde, pa[1], h192)
        det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pa[1], h384_1)
        temp192, ylen = scale_expansion_zeroelim(bcdelen, bcde, pa[2], temp192)
        det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pa[2], h384_2)
        temp192, zlen = scale_expansion_zeroelim(bcdelen, bcde, pa[3], temp192)
        det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pa[3], h384_3)
        detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, h768_1)
        adet, alen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_1)

        temp48a, temp48alen = fast_expansion_sum_zeroelim(dealen, dea, cdalen, cda, temp48a)
        temp48b, temp48blen = fast_expansion_sum_zeroelim(eaclen, eac, cdelen, cde, temp48b)
        for i in 1:temp48blen
            temp48b[i] = -temp48b[i]
        end
        cdea, cdealen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_2)
        temp192, xlen = scale_expansion_zeroelim(cdealen, cdea, pb[1], temp192)
        det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pb[1], det384x)
        temp192, ylen = scale_expansion_zeroelim(cdealen, cdea, pb[2], temp192)
        det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pb[2], det384y)
        temp192, zlen = scale_expansion_zeroelim(cdealen, cdea, pb[3], temp192)
        det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pb[3], det384z)
        detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy)
        bdet, blen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_2)

        temp48a, temp48alen = fast_expansion_sum_zeroelim(eablen, eab, deblen, deb, temp48a)
        temp48b, temp48blen = fast_expansion_sum_zeroelim(abdlen, abd, dealen, dea, temp48b)
        for i in 1:temp48blen
            temp48b[i] = -temp48b[i]
        end
        deab, deablen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_3)
        temp192, xlen = scale_expansion_zeroelim(deablen, deab, pc[1], temp192)
        det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pc[1], det384x)
        temp192, ylen = scale_expansion_zeroelim(deablen, deab, pc[2], temp192)
        det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pc[2], det384y)
        temp192, zlen = scale_expansion_zeroelim(deablen, deab, pc[3], temp192)
        det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pc[3], det384z)
        detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy)
        cdet, clen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_3)

        temp48a, temp48alen = fast_expansion_sum_zeroelim(abclen, abc, eaclen, eac, temp48a)
        temp48b, temp48blen = fast_expansion_sum_zeroelim(bcelen, bce, eablen, eab, temp48b)
        for i in 1:temp48blen
            temp48b[i] = -temp48b[i]
        end
        eabc, eabclen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_4)
        temp192, xlen = scale_expansion_zeroelim(eabclen, eabc, pd[1], temp192)
        det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pd[1], det384x)
        temp192, ylen = scale_expansion_zeroelim(eabclen, eabc, pd[2], temp192)
        det384y, ylen, = scale_expansion_zeroelim(ylen, temp192, pd[2], det384y)
        temp192, zlen = scale_expansion_zeroelim(eabclen, eabc, pd[3], temp192)
        det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pd[3], det384z)
        detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy)
        ddet, dlen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_4)

        temp48a, temp48alen = fast_expansion_sum_zeroelim(bcdlen, bcd, abdlen, abd, temp48a)
        temp48b, temp48blen = fast_expansion_sum_zeroelim(cdalen, cda, abclen, abc, temp48b)
        for i in 1:temp48blen
            temp48b[i] = -temp48b[i]
        end
        abcd, abcdlen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, h96_5)
        temp192, xlen = scale_expansion_zeroelim(abcdlen, abcd, pe[1], temp192)
        det384x, xlen = scale_expansion_zeroelim(xlen, temp192, pe[1], det384x)
        temp192, ylen = scale_expansion_zeroelim(abcdlen, abcd, pe[2], temp192)
        det384y, ylen = scale_expansion_zeroelim(ylen, temp192, pe[2], det384y)
        temp192, zlen = scale_expansion_zeroelim(abcdlen, abcd, pe[3], temp192)
        det384z, zlen = scale_expansion_zeroelim(zlen, temp192, pe[3], det384z)
        detxy, xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy)
        edet, elen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, h1152_5)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h2304_1)
        cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h2304_2)
        cdedet, cdelen = fast_expansion_sum_zeroelim(cdlen, cddet, elen, edet, h3456)
        deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdelen, cdedet, h5760)

        return deter[deterlen]
    end
end

function insphereslow(pa, pb, pc, pd, pe, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h16 = ntuple(_ -> zero(T), Val(16))
        h32 = ntuple(_ -> zero(T), Val(32))

        aex, aextail = Two_Diff(pa[1], pe[1])
        aey, aeytail = Two_Diff(pa[2], pe[2])
        aez, aeztail = Two_Diff(pa[3], pe[3])
        bex, bextail = Two_Diff(pb[1], pe[1])
        bey, beytail = Two_Diff(pb[2], pe[2])
        bez, beztail = Two_Diff(pb[3], pe[3])
        cex, cextail = Two_Diff(pc[1], pe[1])
        cey, ceytail = Two_Diff(pc[2], pe[2])
        cez, ceztail = Two_Diff(pc[3], pe[3])
        dex, dextail = Two_Diff(pd[1], pe[1])
        dey, deytail = Two_Diff(pd[2], pe[2])
        dez, deztail = Two_Diff(pd[3], pe[3])

        axby7, axby6, axby5, axby4, axby3, axby2, axby1, axby0 = Two_Two_Product(aex, aextail, bey, beytail)
        axby = (axby0, axby1, axby2, axby3, axby4, axby5, axby6, axby7)
        negate = -aey
        negatetail = -aeytail
        bxay7, bxay6, bxay5, bxay4, bxay3, bxay2, bxay1, bxay0 = Two_Two_Product(bex, bextail, negate, negatetail)
        bxay = (bxay0, bxay1, bxay2, bxay3, bxay4, bxay5, bxay6, bxay7)
        ab, ablen = fast_expansion_sum_zeroelim(8, axby, 8, bxay, h16)
        bxcy7, bxcy6, bxcy5, bxcy4, bxcy3, bxcy2, bxcy1, bxcy0 = Two_Two_Product(bex, bextail, cey, ceytail)
        bxcy = (bxcy0, bxcy1, bxcy2, bxcy3, bxcy4, bxcy5, bxcy6, bxcy7)
        negate = -bey
        negatetail = -beytail
        cxby7, cxby6, cxby5, cxby4, cxby3, cxby2, cxby1, cxby0 = Two_Two_Product(cex, cextail, negate, negatetail)
        cxby = (cxby0, cxby1, cxby2, cxby3, cxby4, cxby5, cxby6, cxby7)
        bc, bclen = fast_expansion_sum_zeroelim(8, bxcy, 8, cxby, h16)
        cxdy7, cxdy6, cxdy5, cxdy4, cxdy3, cxdy2, cxdy1, cxdy0 = Two_Two_Product(cex, cextail, dey, deytail)
        cxdy = (cxdy0, cxdy1, cxdy2, cxdy3, cxdy4, cxdy5, cxdy6, cxdy7)
        negate = -cey
        negatetail = -ceytail
        dxcy7, dxcy6, dxcy5, dxcy4, dxcy3, dxcy2, dxcy1, dxcy0 = Two_Two_Product(dex, dextail, negate, negatetail)
        dxcy = (dxcy0, dxcy1, dxcy2, dxcy3, dxcy4, dxcy5, dxcy6, dxcy7)
        cd, cdlen = fast_expansion_sum_zeroelim(8, cxdy, 8, dxcy, h16)
        dxay7, dxay6, dxay5, dxay4, dxay3, dxay2, dxay1, dxay0 = Two_Two_Product(dex, dextail, aey, aeytail)
        dxay = (dxay0, dxay1, dxay2, dxay3, dxay4, dxay5, dxay6, dxay7)
        negate = -dey
        negatetail = -deytail
        axdy7, axdy6, axdy5, axdy4, axdy3, axdy2, axdy1, axdy0 = Two_Two_Product(aex, aextail, negate, negatetail)
        axdy = (axdy0, axdy1, axdy2, axdy3, axdy4, axdy5, axdy6, axdy7)
        da, dalen = fast_expansion_sum_zeroelim(8, dxay, 8, axdy, h16)
        axcy7, axcy6, axcy5, axcy4, axcy3, axcy2, axcy1, axcy0 = Two_Two_Product(aex, aextail, cey, ceytail)
        axcy = (axcy0, axcy1, axcy2, axcy3, axcy4, axcy5, axcy6, axcy7)
        negate = -aey
        negatetail = -aeytail
        cxay7, cxay6, cxay5, cxay4, cxay3, cxay2, cxay1, cxay0 = Two_Two_Product(cex, cextail, negate, negatetail)
        cxay = (cxay0, cxay1, cxay2, cxay3, cxay4, cxay5, cxay6, cxay7)
        ac, aclen = fast_expansion_sum_zeroelim(8, axcy, 8, cxay, h16)
        bxdy7, bxdy6, bxdy5, bxdy4, bxdy3, bxdy2, bxdy1, bxdy0 = Two_Two_Product(bex, bextail, dey, deytail)
        bxdy = (bxdy0, bxdy1, bxdy2, bxdy3, bxdy4, bxdy5, bxdy6, bxdy7)
        negate = -bey
        negatetail = -beytail
        dxby7, dxby6, dxby5, dxby4, dxby3, dxby2, dxby1, dxby0 = Two_Two_Product(dex, dextail, negate, negatetail)
        dxby = (dxby0, dxby1, dxby2, dxby3, dxby4, dxby5, dxby6, dxby7)
        bd, bdlen = fast_expansion_sum_zeroelim(8, bxdy, 8, dxby, h16)

        args = pa, aex, aextail, aey, aeytail, aez, aeztail, bex, bextail, bey, beytail, bez, beztail, cex, cextail, cey, ceytail, cez, ceztail, dex, dextail, dey, deytail, dez, deztail, ab, ablen, bc, bclen, cd, cdlen, da, dalen, ac, aclen, bd, bdlen, cache

        temp32a, temp32alen = scale_expansion_zeroelim(cdlen, cd, -bez, h32)
        temp32b, temp32blen = scale_expansion_zeroelim(cdlen, cd, -beztail, h32)
        @check_length _insphereslow args temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
        temp32a, temp32alen = scale_expansion_zeroelim(bdlen, bd, cez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(bdlen, bd, ceztail, temp32b)
        @check_length _insphereslow args temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_2)
        temp32a, temp32alen = scale_expansion_zeroelim(bclen, bc, -dez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(bclen, bc, -deztail, temp32b)
        @check_length _insphereslow args temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_3)
        @check_length _insphereslow args temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, h32) # temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, h128)
        @check_length _insphereslow args temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, h32) # temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, h192)
        @check_length _insphereslow args detx, xlen = scale_expansion_zeroelim(temp192len, temp192, aex, h32) # detx, xlen = scale_expansion_zeroelim(temp192len, temp192, aex, h384_1)
        @check_length _insphereslow args detxx, xxlen = scale_expansion_zeroelim(xlen, detx, aex, h32) # detxx, xxlen = scale_expansion_zeroelim(xlen, detx, aex, h768_1)
        @check_length _insphereslow args detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, aextail, h32) # detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, aextail, h384_2)
        @check_length _insphereslow args detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, aex, h32) # detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, aex, h768_2)
        detxxt = @. T(detxxt * 2.0)
        @check_length _insphereslow args detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, aextail, h32) # detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, aextail, h768_3)
        @check_length _insphereslow args x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, h32) #x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, h1536_1)
        @check_length _insphereslow args x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, h32) # x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, h2304_1)
        @check_length _insphereslow args dety, ylen = scale_expansion_zeroelim(temp192len, temp192, aey, h32) # dety, ylen = scale_expansion_zeroelim(temp192len, temp192, aey, h384_3)
        @check_length _insphereslow args detyy, yylen = scale_expansion_zeroelim(ylen, dety, aey, h32) # detyy, yylen = scale_expansion_zeroelim(ylen, dety, aey, h768_4)
        @check_length _insphereslow args detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, aeytail, h32) # detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, aeytail, h384_4)
        @check_length _insphereslow args detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, aey, h32) # detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, aey, h768_5)
        detyyt = @. T(detyyt * 2.0)
        @check_length _insphereslow args detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, aeytail, h32) # detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, aeytail, h768_6)
        @check_length _insphereslow args y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, h32) # y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, h1536_2)
        @check_length _insphereslow args y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, h32) # y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, h2304_2)
        @check_length _insphereslow args detz, zlen = scale_expansion_zeroelim(temp192len, temp192, aez, h32) # detz, zlen = scale_expansion_zeroelim(temp192len, temp192, aez, h384_5)
        @check_length _insphereslow args detzz, zzlen = scale_expansion_zeroelim(zlen, detz, aez, h32) # detzz, zzlen = scale_expansion_zeroelim(zlen, detz, aez, h768_7)
        @check_length _insphereslow args detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, aeztail, h32) # detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, aeztail, h384_6)
        @check_length _insphereslow args detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, aez, h32) # detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, aez, h768_8)
        detzzt = @. T(detzzt * 2.0)
        @check_length _insphereslow args detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, aeztail, h32) # detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, aeztail, h768_9)
        @check_length _insphereslow args z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, h32) # z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, h1536_3)
        @check_length _insphereslow args z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, h32) # z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, h2304_3)
        @check_length _insphereslow args detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h32) # detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h4608)
        @check_length _insphereslow args adet, alen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h32) # adet, alen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h6912_1)

        temp32a, temp32alen = scale_expansion_zeroelim(dalen, da, cez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(dalen, da, ceztail, temp32b)
        @check_length _insphereslow args temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64a)
        temp32a, temp32alen = scale_expansion_zeroelim(aclen, ac, dez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(aclen, ac, deztail, temp32b)
        @check_length _insphereslow args temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64b)
        temp32a, temp32alen = scale_expansion_zeroelim(cdlen, cd, aez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(cdlen, cd, aeztail, temp32b)
        @check_length _insphereslow args temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64c)
        @check_length _insphereslow args temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, temp128)
        @check_length _insphereslow args temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, temp192)
        @check_length _insphereslow args detx, xlen = scale_expansion_zeroelim(temp192len, temp192, bex, detx)
        @check_length _insphereslow args detxx, xxlen = scale_expansion_zeroelim(xlen, detx, bex, detxx)
        @check_length _insphereslow args detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, bextail, detxt)
        @check_length _insphereslow args detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, bex, detxxt)
        detxxt = @. T(detxxt * 2.0)
        @check_length _insphereslow args detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, bextail, detxtxt)
        @check_length _insphereslow args x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        @check_length _insphereslow args x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)
        @check_length _insphereslow args dety, ylen = scale_expansion_zeroelim(temp192len, temp192, bey, dety)
        @check_length _insphereslow args detyy, yylen = scale_expansion_zeroelim(ylen, dety, bey, detyy)
        @check_length _insphereslow args detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, beytail, detyt)
        @check_length _insphereslow args detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, bey, detyyt)
        detyyt = @. T(detyyt * 2.0)
        @check_length _insphereslow args detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, beytail, detytyt)
        @check_length _insphereslow args y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        @check_length _insphereslow args y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)
        @check_length _insphereslow args detz, zlen = scale_expansion_zeroelim(temp192len, temp192, bez, detz)
        @check_length _insphereslow args detzz, zzlen = scale_expansion_zeroelim(zlen, detz, bez, detzz)
        @check_length _insphereslow args detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, beztail, detzt)
        @check_length _insphereslow args detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, bez, detzzt)
        detzzt = @. T(detzzt * 2.0)
        @check_length _insphereslow args detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, beztail, detztzt)
        @check_length _insphereslow args z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, z1)
        @check_length _insphereslow args z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, z2)
        @check_length _insphereslow args detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, detxy)
        @check_length _insphereslow args bdet, blen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h32) # bdet, blen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h6912_2)

        temp32a, temp32alen = scale_expansion_zeroelim(ablen, ab, -dez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(ablen, ab, -deztail, temp32b)
        @check_length _insphereslow args temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64a)
        temp32a, temp32alen = scale_expansion_zeroelim(bdlen, bd, -aez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(bdlen, bd, -aeztail, temp32b)
        @check_length _insphereslow args temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64b)
        temp32a, temp32alen = scale_expansion_zeroelim(dalen, da, -bez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(dalen, da, -beztail, temp32b) 
        @check_length _insphereslow args temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64c)
        @check_length _insphereslow args temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, temp128)
        @check_length _insphereslow args temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, temp192)
        @check_length _insphereslow args detx, xlen = scale_expansion_zeroelim(temp192len, temp192, cex, detx)
        @check_length _insphereslow args detxx, xxlen = scale_expansion_zeroelim(xlen, detx, cex, detxx)
        @check_length _insphereslow args detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, cextail, detxt)
        @check_length _insphereslow args detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, cex, detxxt)
        detxxt = @. T(detxxt * 2.0)
        @check_length _insphereslow args detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, cextail, detxtxt)
        @check_length _insphereslow args x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        @check_length _insphereslow args x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)
        @check_length _insphereslow args dety, ylen = scale_expansion_zeroelim(temp192len, temp192, cey, dety)
        @check_length _insphereslow args detyy, yylen = scale_expansion_zeroelim(ylen, dety, cey, detyy)
        @check_length _insphereslow args detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, ceytail, detyt)
        @check_length _insphereslow args detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, cey, detyyt)
        detyyt = @. T(detyyt * 2.0)
        @check_length _insphereslow args detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, ceytail, detytyt)
        @check_length _insphereslow args y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        @check_length _insphereslow args y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)
        @check_length _insphereslow args detz, zlen = scale_expansion_zeroelim(temp192len, temp192, cez, detz)
        @check_length _insphereslow args detzz, zzlen = scale_expansion_zeroelim(zlen, detz, cez, detzz)
        @check_length _insphereslow args detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, ceztail, detzt)
        @check_length _insphereslow args detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, cez, detzzt)
        detzzt = @. T(detzzt * 2.0)
        @check_length _insphereslow args detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, ceztail, detztzt)
        @check_length _insphereslow args z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, z1)
        @check_length _insphereslow args z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, z2)
        @check_length _insphereslow args detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, detxy)
        @check_length _insphereslow args cdet, clen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h32) # cdet, clen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h6912_3)

        temp32a, temp32alen = scale_expansion_zeroelim(bclen, bc, aez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(bclen, bc, aeztail, temp32b)
        @check_length _insphereslow args temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64a)
        temp32a, temp32alen = scale_expansion_zeroelim(aclen, ac, -bez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(aclen, ac, -beztail, temp32b)
        @check_length _insphereslow args temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64b)
        temp32a, temp32alen = scale_expansion_zeroelim(ablen, ab, cez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(ablen, ab, ceztail, temp32b)
        @check_length _insphereslow args temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64c)
        @check_length _insphereslow args temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, temp128)
        @check_length _insphereslow args temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, temp192)
        @check_length _insphereslow args detx, xlen = scale_expansion_zeroelim(temp192len, temp192, dex, detx)
        @check_length _insphereslow args detxx, xxlen = scale_expansion_zeroelim(xlen, detx, dex, detxx)
        @check_length _insphereslow args detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, dextail, detxt)
        @check_length _insphereslow args detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, dex, detxxt)
        detxxt = @. T(detxxt * 2.0)
        @check_length _insphereslow args detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, dextail, detxtxt)
        @check_length _insphereslow args x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        @check_length _insphereslow args x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)
        @check_length _insphereslow args dety, ylen = scale_expansion_zeroelim(temp192len, temp192, dey, dety)
        @check_length _insphereslow args detyy, yylen = scale_expansion_zeroelim(ylen, dety, dey, detyy)
        @check_length _insphereslow args detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, deytail, detyt)
        @check_length _insphereslow args detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, dey, detyyt)
        detyyt = @. T(detyyt * 2.0)
        @check_length _insphereslow args detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, deytail, detytyt)
        @check_length _insphereslow args y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        @check_length _insphereslow args y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)
        @check_length _insphereslow args detz, zlen = scale_expansion_zeroelim(temp192len, temp192, dez, detz)
        @check_length _insphereslow args detzz, zzlen = scale_expansion_zeroelim(zlen, detz, dez, detzz)
        @check_length _insphereslow args detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, deztail, detzt)
        @check_length _insphereslow args detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, dez, detzzt)
        detzzt = @. T(detzzt * 2.0)
        @check_length _insphereslow args detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, deztail, detztzt)
        @check_length _insphereslow args z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, z1)
        @check_length _insphereslow args z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, z2)
        @check_length _insphereslow args detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, detxy)
        @check_length _insphereslow args ddet, dlen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h32) # ddet, dlen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h6912_4)

        @check_length _insphereslow args abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h32) # abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h13824_1)
        @check_length _insphereslow args cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h32) # cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h13824_2)
        @check_length _insphereslow args deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h32) # deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h27648)

        return deter[deterlen]
    end
end
function _insphereslow(pa, aex, aextail, aey, aeytail, aez, aeztail, bex, bextail, bey, beytail, bez, beztail, cex, cextail, cey, ceytail, cez, ceztail, dex, dextail, dey, deytail, dez, deztail, ab, ablen, bc, bclen, cd, cdlen, da, dalen, ac, aclen, bd, bdlen, cache)
    @inbounds begin
        T = eltype(pa)
        h32 = ntuple(_ -> zero(T), Val(32))
        h64_1, h64_2, h64_3, h128, h192, h384_1, h384_2, h384_3, h384_4, h384_5, h384_6, h768_1, h768_2, h768_3, h768_4, h768_5, h768_6, h768_7, h768_8, h768_9, h1536_1, h1536_2, h1536_3, h2304_1, h2304_2, h2304_3, h4608, h6912_1, h6912_2, h6912_3, h6912_4, h13824_1, h13824_2, h27648 = insphereslow_cache(T, cache)

        temp32a, temp32alen = scale_expansion_zeroelim(cdlen, cd, -bez, h32)
        temp32b, temp32blen = scale_expansion_zeroelim(cdlen, cd, -beztail, h32)
        temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
        temp32a, temp32alen = scale_expansion_zeroelim(bdlen, bd, cez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(bdlen, bd, ceztail, temp32b)
        temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_2)
        temp32a, temp32alen = scale_expansion_zeroelim(bclen, bc, -dez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(bclen, bc, -deztail, temp32b)
        temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_3)
        temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, h128)
        temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, h192)
        detx, xlen = scale_expansion_zeroelim(temp192len, temp192, aex, h384_1)
        detxx, xxlen = scale_expansion_zeroelim(xlen, detx, aex, h768_1)
        detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, aextail, h384_2)
        detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, aex, h768_2)
        for i in 1:xxtlen
            detxxt[i] *= 2.0
        end
        detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, aextail, h768_3)
        x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, h1536_1)
        x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, h2304_1)
        dety, ylen = scale_expansion_zeroelim(temp192len, temp192, aey, h384_3)
        detyy, yylen = scale_expansion_zeroelim(ylen, dety, aey, h768_4)
        detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, aeytail, h384_4)
        detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, aey, h768_5)
        for i in 1:yytlen
            detyyt[i] *= 2.0
        end
        detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, aeytail, h768_6)
        y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, h1536_2)
        y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, h2304_2)
        detz, zlen = scale_expansion_zeroelim(temp192len, temp192, aez, h384_5)
        detzz, zzlen = scale_expansion_zeroelim(zlen, detz, aez, h768_7)
        detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, aeztail, h384_6)
        detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, aez, h768_8)
        for i in 1:zztlen
            detzzt[i] *= 2.0
        end
        detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, aeztail, h768_9)
        z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, h1536_3)
        z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, h2304_3)
        detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h4608)
        adet, alen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h6912_1)

        temp32a, temp32alen = scale_expansion_zeroelim(dalen, da, cez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(dalen, da, ceztail, temp32b)
        temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64a)
        temp32a, temp32alen = scale_expansion_zeroelim(aclen, ac, dez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(aclen, ac, deztail, temp32b)
        temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64b)
        temp32a, temp32alen = scale_expansion_zeroelim(cdlen, cd, aez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(cdlen, cd, aeztail, temp32b)
        temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64c)
        temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, temp128)
        temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, temp192)
        detx, xlen = scale_expansion_zeroelim(temp192len, temp192, bex, detx)
        detxx, xxlen = scale_expansion_zeroelim(xlen, detx, bex, detxx)
        detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, bextail, detxt)
        detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, bex, detxxt)
        for i in 1:xxtlen
            detxxt[i] *= 2.0
        end
        detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, bextail, detxtxt)
        x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)
        dety, ylen = scale_expansion_zeroelim(temp192len, temp192, bey, dety)
        detyy, yylen = scale_expansion_zeroelim(ylen, dety, bey, detyy)
        detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, beytail, detyt)
        detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, bey, detyyt)
        for i in 1:yytlen
            detyyt[i] *= 2.0
        end
        detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, beytail, detytyt)
        y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)
        detz, zlen = scale_expansion_zeroelim(temp192len, temp192, bez, detz)
        detzz, zzlen = scale_expansion_zeroelim(zlen, detz, bez, detzz)
        detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, beztail, detzt)
        detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, bez, detzzt)
        for i in 1:zztlen
            detzzt[i] *= 2.0
        end
        detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, beztail, detztzt)
        z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, z1)
        z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, z2)
        detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, detxy)
        bdet, blen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h6912_2)

        temp32a, temp32alen = scale_expansion_zeroelim(ablen, ab, -dez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(ablen, ab, -deztail, temp32b)
        temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64a)
        temp32a, temp32alen = scale_expansion_zeroelim(bdlen, bd, -aez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(bdlen, bd, -aeztail, temp32b)
        temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64b)
        temp32a, temp32alen = scale_expansion_zeroelim(dalen, da, -bez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(dalen, da, -beztail, temp32b)
        temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64c)
        temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, temp128)
        temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, temp192)
        detx, xlen = scale_expansion_zeroelim(temp192len, temp192, cex, detx)
        detxx, xxlen = scale_expansion_zeroelim(xlen, detx, cex, detxx)
        detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, cextail, detxt)
        detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, cex, detxxt)
        for i in 1:xxtlen
            detxxt[i] *= 2.0
        end
        detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, cextail, detxtxt)
        x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)
        dety, ylen = scale_expansion_zeroelim(temp192len, temp192, cey, dety)
        detyy, yylen = scale_expansion_zeroelim(ylen, dety, cey, detyy)
        detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, ceytail, detyt)
        detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, cey, detyyt)
        for i in 1:yytlen
            detyyt[i] *= 2.0
        end
        detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, ceytail, detytyt)
        y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)
        detz, zlen = scale_expansion_zeroelim(temp192len, temp192, cez, detz)
        detzz, zzlen = scale_expansion_zeroelim(zlen, detz, cez, detzz)
        detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, ceztail, detzt)
        detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, cez, detzzt)
        for i in 1:zztlen
            detzzt[i] *= 2.0
        end
        detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, ceztail, detztzt)
        z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, z1)
        z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, z2)
        detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, detxy)
        cdet, clen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h6912_3)

        temp32a, temp32alen = scale_expansion_zeroelim(bclen, bc, aez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(bclen, bc, aeztail, temp32b)
        temp64a, temp64alen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64a)
        temp32a, temp32alen = scale_expansion_zeroelim(aclen, ac, -bez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(aclen, ac, -beztail, temp32b)
        temp64b, temp64blen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64b)
        temp32a, temp32alen = scale_expansion_zeroelim(ablen, ab, cez, temp32a)
        temp32b, temp32blen = scale_expansion_zeroelim(ablen, ab, ceztail, temp32b)
        temp64c, temp64clen = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64c)
        temp128, temp128len = fast_expansion_sum_zeroelim(temp64alen, temp64a, temp64blen, temp64b, temp128)
        temp192, temp192len = fast_expansion_sum_zeroelim(temp64clen, temp64c, temp128len, temp128, temp192)
        detx, xlen = scale_expansion_zeroelim(temp192len, temp192, dex, detx)
        detxx, xxlen = scale_expansion_zeroelim(xlen, detx, dex, detxx)
        detxt, xtlen = scale_expansion_zeroelim(temp192len, temp192, dextail, detxt)
        detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, dex, detxxt)
        for i in 1:xxtlen
            detxxt[i] *= 2.0
        end
        detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, dextail, detxtxt)
        x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)
        dety, ylen = scale_expansion_zeroelim(temp192len, temp192, dey, dety)
        detyy, yylen = scale_expansion_zeroelim(ylen, dety, dey, detyy)
        detyt, ytlen = scale_expansion_zeroelim(temp192len, temp192, deytail, detyt)
        detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, dey, detyyt)
        for i in 1:yytlen
            detyyt[i] *= 2.0
        end
        detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, deytail, detytyt)
        y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)
        detz, zlen = scale_expansion_zeroelim(temp192len, temp192, dez, detz)
        detzz, zzlen = scale_expansion_zeroelim(zlen, detz, dez, detzz)
        detzt, ztlen = scale_expansion_zeroelim(temp192len, temp192, deztail, detzt)
        detzzt, zztlen = scale_expansion_zeroelim(ztlen, detzt, dez, detzzt)
        for i in 1:zztlen
            detzzt[i] *= 2.0
        end
        detztzt, ztztlen = scale_expansion_zeroelim(ztlen, detzt, deztail, detztzt)
        z1, z1len = fast_expansion_sum_zeroelim(zzlen, detzz, zztlen, detzzt, z1)
        z2, z2len = fast_expansion_sum_zeroelim(z1len, z1, ztztlen, detztzt, z2)
        detxy, xylen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, detxy)
        ddet, dlen = fast_expansion_sum_zeroelim(z2len, z2, xylen, detxy, h6912_4)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h13824_1)
        cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h13824_2)
        deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h27648)

        return deter[deterlen]
    end
end

function insphereadapt(pa, pb, pc, pd, pe, permanent, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h16 = ntuple(_ -> zero(T), Val(16))
        h24 = ntuple(_ -> zero(T), Val(24))
        h32 = ntuple(_ -> zero(T), Val(32))

        aex = pa[1] - pe[1]
        bex = pb[1] - pe[1]
        cex = pc[1] - pe[1]
        dex = pd[1] - pe[1]
        aey = pa[2] - pe[2]
        bey = pb[2] - pe[2]
        cey = pc[2] - pe[2]
        dey = pd[2] - pe[2]
        aez = pa[3] - pe[3]
        bez = pb[3] - pe[3]
        cez = pc[3] - pe[3]
        dez = pd[3] - pe[3]

        aexbey1, aexbey0 = Two_Product(aex, bey)
        bexaey1, bexaey0 = Two_Product(bex, aey)
        ab3, ab2, ab1, ab0 = Two_Two_Diff(aexbey1, aexbey0, bexaey1, bexaey0)
        ab = (ab0, ab1, ab2, ab3)

        bexcey1, bexcey0 = Two_Product(bex, cey)
        cexbey1, cexbey0 = Two_Product(cex, bey)
        bc3, bc2, bc1, bc0 = Two_Two_Diff(bexcey1, bexcey0, cexbey1, cexbey0)
        bc = (bc0, bc1, bc2, bc3)

        cexdey1, cexdey0 = Two_Product(cex, dey)
        dexcey1, dexcey0 = Two_Product(dex, cey)
        cd3, cd2, cd1, cd0 = Two_Two_Diff(cexdey1, cexdey0, dexcey1, dexcey0)
        cd = (cd0, cd1, cd2, cd3)

        dexaey1, dexaey0 = Two_Product(dex, aey)
        aexdey1, aexdey0 = Two_Product(aex, dey)
        da3, da2, da1, da0 = Two_Two_Diff(dexaey1, dexaey0, aexdey1, aexdey0)
        da = (da0, da1, da2, da3)

        aexcey1, aexcey0 = Two_Product(aex, cey)
        cexaey1, cexaey0 = Two_Product(cex, aey)
        ac3, ac2, ac1, ac0 = Two_Two_Diff(aexcey1, aexcey0, cexaey1, cexaey0)
        ac = (ac0, ac1, ac2, ac3)

        bexdey1, bexdey0 = Two_Product(bex, dey)
        dexbey1, dexbey0 = Two_Product(dex, bey)
        bd3, bd2, bd1, bd0 = Two_Two_Diff(bexdey1, bexdey0, dexbey1, dexbey0)
        bd = (bd0, bd1, bd2, bd3)

        args = pa, pb, pc, pd, pe, permanent, aex, bex, cex, dex, aey, bey, cey, dey, aez, bez, cez, dez, ab, bc, cd, da, ac, bd, ab3, bc3, cd3, da3, ac3, bd3, cache

        temp8a, temp8alen = scale_expansion_zeroelim(4, cd, bez, h8)
        temp8b, temp8blen = scale_expansion_zeroelim(4, bd, -cez, h8)
        temp8c, temp8clen = scale_expansion_zeroelim(4, bc, dez, h8)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, h16)
        temp24, temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, h24)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aex, h32) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aex, h48_1)
        @check_length _insphereadapt args xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, -aex, h32) # xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, -aex, h96_1)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aey, h32) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aey, temp48)
        @check_length _insphereadapt args ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, -aey, h32) # ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, -aey, h96_2)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aez, h32) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aez, temp48)
        @check_length _insphereadapt args zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, -aez, h32) # zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, -aez, h96_3)
        @check_length _insphereadapt args xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, h32) # xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, h192)
        @check_length _insphereadapt args adet, alen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h32) # adet, alen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h288_1)

        temp8a, temp8alen = scale_expansion_zeroelim(4, da, cez, temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, ac, dez, temp8b)
        temp8c, temp8clen = scale_expansion_zeroelim(4, cd, aez, temp8c)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp24, temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bex, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bex, temp48)
        @check_length _insphereadapt args xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, bex, xdet) # xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, bex, xdet)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bey, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bey, temp48)
        @check_length _insphereadapt args ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, bey, ydet) # ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, bey, ydet)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bez, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bez, temp48)
        @check_length _insphereadapt args zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, bez, zdet) # zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, bez, zdet)
        @check_length _insphereadapt args xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet) # xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet)
        @check_length _insphereadapt args bdet, blen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h32) # bdet, blen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h288_2)

        temp8a, temp8alen = scale_expansion_zeroelim(4, ab, dez, temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, bd, aez, temp8b)
        temp8c, temp8clen = scale_expansion_zeroelim(4, da, bez, temp8c)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp24, temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cex, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cex, temp48)
        @check_length _insphereadapt args xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, -cex, xdet) # xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, -cex, xdet)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cey, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cey, temp48)
        @check_length _insphereadapt args ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, -cey, ydet) # ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, -cey, ydet)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cez, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cez, temp48)
        @check_length _insphereadapt args zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, -cez, zdet) # zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, -cez, zdet)
        @check_length _insphereadapt args xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet) # xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet)
        @check_length _insphereadapt args cdet, clen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h32) # cdet, clen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h288_3)

        temp8a, temp8alen = scale_expansion_zeroelim(4, bc, aez, temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, ac, -bez, temp8b)
        temp8c, temp8clen = scale_expansion_zeroelim(4, ab, cez, temp8c)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp24, temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dex, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dex, temp48)
        @check_length _insphereadapt args xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, dex, xdet) # xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, dex, xdet)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dey, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dey, temp48)
        @check_length _insphereadapt args ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, dey, ydet) # ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, dey, ydet)
        @check_length _insphereadapt args temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dez, temp48) # temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dez, temp48)
        @check_length _insphereadapt args zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, dez, zdet) # zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, dez, zdet)
        @check_length _insphereadapt args xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet) # xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet)
        @check_length _insphereadapt args ddet, dlen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h32) # ddet, dlen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h288_4)

        @check_length _insphereadapt args abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h32) # abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h576_1)
        @check_length _insphereadapt args cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h32) # cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h576_2)
        @check_length _insphereadapt args fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h32) # fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h1152_1)

        det = estimate(finlength, fin1)
        errbound = isperrboundB(T) * permanent
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        aextail = Two_Diff_Tail(pa[1], pe[1], aex)
        aeytail = Two_Diff_Tail(pa[2], pe[2], aey)
        aeztail = Two_Diff_Tail(pa[3], pe[3], aez)
        bextail = Two_Diff_Tail(pb[1], pe[1], bex)
        beytail = Two_Diff_Tail(pb[2], pe[2], bey)
        beztail = Two_Diff_Tail(pb[3], pe[3], bez)
        cextail = Two_Diff_Tail(pc[1], pe[1], cex)
        ceytail = Two_Diff_Tail(pc[2], pe[2], cey)
        ceztail = Two_Diff_Tail(pc[3], pe[3], cez)
        dextail = Two_Diff_Tail(pd[1], pe[1], dex)
        deytail = Two_Diff_Tail(pd[2], pe[2], dey)
        deztail = Two_Diff_Tail(pd[3], pe[3], dez)
        if iszero(aextail) && iszero(aeytail) && iszero(aeztail) &&
           iszero(bextail) && iszero(beytail) && iszero(beztail) &&
           iszero(cextail) && iszero(ceytail) && iszero(ceztail) &&
           iszero(dextail) && iszero(deytail) && iszero(deztail)
            return det
        end

        errbound = isperrboundC(T) * permanent + resulterrbound(T) * Absolute(det)
        abeps = (aex * beytail + bey * aextail) -
                (aey * bextail + bex * aeytail)
        bceps = (bex * ceytail + cey * bextail) -
                (bey * cextail + cex * beytail)
        cdeps = (cex * deytail + dey * cextail) -
                (cey * dextail + dex * ceytail)
        daeps = (dex * aeytail + aey * dextail) -
                (dey * aextail + aex * deytail)
        aceps = (aex * ceytail + cey * aextail) -
                (aey * cextail + cex * aeytail)
        bdeps = (bex * deytail + dey * bextail) -
                (bey * dextail + dex * beytail)
        detadd = (((bex * bex + bey * bey + bez * bez) *
                   ((cez * daeps + dez * aceps + aez * cdeps) +
                    (ceztail * da3 + deztail * ac3 + aeztail * cd3)) +
                   (dex * dex + dey * dey + dez * dez) *
                   ((aez * bceps - bez * aceps + cez * abeps) +
                    (aeztail * bc3 - beztail * ac3 + ceztail * ab3))) -
                  ((aex * aex + aey * aey + aez * aez) *
                   ((bez * cdeps - cez * bdeps + dez * bceps) +
                    (beztail * cd3 - ceztail * bd3 + deztail * bc3)) +
                   (cex * cex + cey * cey + cez * cez) *
                   ((dez * abeps + aez * bdeps + bez * daeps) +
                    (deztail * ab3 + aeztail * bd3 + beztail * da3)))) +
                 2.0 * (((bex * bextail + bey * beytail + bez * beztail) *
                         (cez * da3 + dez * ac3 + aez * cd3) +
                         (dex * dextail + dey * deytail + dez * deztail) *
                         (aez * bc3 - bez * ac3 + cez * ab3)) -
                        ((aex * aextail + aey * aeytail + aez * aeztail) *
                         (bez * cd3 - cez * bd3 + dez * bc3) +
                         (cex * cextail + cey * ceytail + cez * ceztail) *
                         (dez * ab3 + aez * bd3 + bez * da3)))
        det = T(det + detadd) # Had to change this to match how C handles the 2.0 multiplication with Float32
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        return insphereexact(pa, pb, pc, pd, pe, cache)
        #=
        Interesting note: Shewchuk's paper on p. 352 says
            This implementation differs from the other
            tests in that, due to programmer laziness, D is not computed incrementally from B;
            rather, if C is not accurate enough, D is computed from scratch. Fortunately, C is usually
            accurate enough.    
        This is why this is the only one of the four predicates that just uses the exact computation 
        when the result is not known yet - laziness. Neat.
        =#
    end
end
function _insphereadapt(pa, pb, pc, pd, pe, permanent, aex, bex, cex, dex, aey, bey, cey, dey, aez, bez, cez, dez, ab, bc, cd, da, ac, bd,  ab3, bc3, cd3, da3, ac3, bd3, cache)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h16 = ntuple(_ -> zero(T), Val(16))
        h24 = ntuple(_ -> zero(T), Val(24))
        h48_1, _, h96_1, h96_2, h96_3, _, _, h192, h288_1, h288_2, h288_3, h288_4, _, _, _, h576_1, h576_2, _, h1152_1, _, _, _, _, _, _, _, _ = insphereexact_cache(T, cache)

        temp8a, temp8alen = scale_expansion_zeroelim(4, cd, bez, h8)
        temp8b, temp8blen = scale_expansion_zeroelim(4, bd, -cez, h8)
        temp8c, temp8clen = scale_expansion_zeroelim(4, bc, dez, h8)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, h16)
        temp24, temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, h24)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aex, h48_1)
        xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, -aex, h96_1)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aey, temp48)
        ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, -aey, h96_2)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, aez, temp48)
        zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, -aez, h96_3)
        xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, h192)
        adet, alen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h288_1)

        temp8a, temp8alen = scale_expansion_zeroelim(4, da, cez, temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, ac, dez, temp8b)
        temp8c, temp8clen = scale_expansion_zeroelim(4, cd, aez, temp8c)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp24, temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bex, temp48)
        xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, bex, xdet)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bey, temp48)
        ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, bey, ydet)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, bez, temp48)
        zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, bez, zdet)
        xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet)
        bdet, blen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h288_2)

        temp8a, temp8alen = scale_expansion_zeroelim(4, ab, dez, temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, bd, aez, temp8b)
        temp8c, temp8clen = scale_expansion_zeroelim(4, da, bez, temp8c)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp24, temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cex, temp48)
        xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, -cex, xdet)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cey, temp48)
        ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, -cey, ydet)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, cez, temp48)
        zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, -cez, zdet)
        xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet)
        cdet, clen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h288_3)

        temp8a, temp8alen = scale_expansion_zeroelim(4, bc, aez, temp8a)
        temp8b, temp8blen = scale_expansion_zeroelim(4, ac, -bez, temp8b)
        temp8c, temp8clen = scale_expansion_zeroelim(4, ab, cez, temp8c)
        temp16, temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16)
        temp24, temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dex, temp48)
        xdet, xlen = scale_expansion_zeroelim(temp48len, temp48, dex, xdet)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dey, temp48)
        ydet, ylen = scale_expansion_zeroelim(temp48len, temp48, dey, ydet)
        temp48, temp48len = scale_expansion_zeroelim(temp24len, temp24, dez, temp48)
        zdet, zlen = scale_expansion_zeroelim(temp48len, temp48, dez, zdet)
        xydet, xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet)
        ddet, dlen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, h288_4)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h576_1)
        cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h576_2)
        fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h1152_1)

        det = estimate(finlength, fin1)
        errbound = isperrboundB(T) * permanent
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        aextail = Two_Diff_Tail(pa[1], pe[1], aex)
        aeytail = Two_Diff_Tail(pa[2], pe[2], aey)
        aeztail = Two_Diff_Tail(pa[3], pe[3], aez)
        bextail = Two_Diff_Tail(pb[1], pe[1], bex)
        beytail = Two_Diff_Tail(pb[2], pe[2], bey)
        beztail = Two_Diff_Tail(pb[3], pe[3], bez)
        cextail = Two_Diff_Tail(pc[1], pe[1], cex)
        ceytail = Two_Diff_Tail(pc[2], pe[2], cey)
        ceztail = Two_Diff_Tail(pc[3], pe[3], cez)
        dextail = Two_Diff_Tail(pd[1], pe[1], dex)
        deytail = Two_Diff_Tail(pd[2], pe[2], dey)
        deztail = Two_Diff_Tail(pd[3], pe[3], dez)
        if iszero(aextail) && iszero(aeytail) && iszero(aeztail) &&
           iszero(bextail) && iszero(beytail) && iszero(beztail) &&
           iszero(cextail) && iszero(ceytail) && iszero(ceztail) &&
           iszero(dextail) && iszero(deytail) && iszero(deztail)
            return det
        end

        errbound = isperrboundC(T) * permanent + resulterrbound(T) * Absolute(det)
        abeps = (aex * beytail + bey * aextail) -
                (aey * bextail + bex * aeytail)
        bceps = (bex * ceytail + cey * bextail) -
                (bey * cextail + cex * beytail)
        cdeps = (cex * deytail + dey * cextail) -
                (cey * dextail + dex * ceytail)
        daeps = (dex * aeytail + aey * dextail) -
                (dey * aextail + aex * deytail)
        aceps = (aex * ceytail + cey * aextail) -
                (aey * cextail + cex * aeytail)
        bdeps = (bex * deytail + dey * bextail) -
                (bey * dextail + dex * beytail)

        detadd = (((bex * bex + bey * bey + bez * bez) *
                   ((cez * daeps + dez * aceps + aez * cdeps) +
                    (ceztail * da3 + deztail * ac3 + aeztail * cd3)) +
                   (dex * dex + dey * dey + dez * dez) *
                   ((aez * bceps - bez * aceps + cez * abeps) +
                    (aeztail * bc3 - beztail * ac3 + ceztail * ab3))) -
                  ((aex * aex + aey * aey + aez * aez) *
                   ((bez * cdeps - cez * bdeps + dez * bceps) +
                    (beztail * cd3 - ceztail * bd3 + deztail * bc3)) +
                   (cex * cex + cey * cey + cez * cez) *
                   ((dez * abeps + aez * bdeps + bez * daeps) +
                    (deztail * ab3 + aeztail * bd3 + beztail * da3)))) +
                 2.0 * (((bex * bextail + bey * beytail + bez * beztail) *
                         (cez * da3 + dez * ac3 + aez * cd3) +
                         (dex * dextail + dey * deytail + dez * deztail) *
                         (aez * bc3 - bez * ac3 + cez * ab3)) -
                        ((aex * aextail + aey * aeytail + aez * aeztail) *
                         (bez * cd3 - cez * bd3 + dez * bc3) +
                         (cex * cextail + cey * ceytail + cez * ceztail) *
                         (dez * ab3 + aez * bd3 + bez * da3)))
        det = T(det + detadd) # Had to change this to match how C handles the 2.0 multiplication with Float32
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        return insphereexact(pa, pb, pc, pd, pe, cache)
    end
end

function insphere(pa, pb, pc, pd, pe, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        aex = pa[1] - pe[1]
        bex = pb[1] - pe[1]
        cex = pc[1] - pe[1]
        dex = pd[1] - pe[1]
        aey = pa[2] - pe[2]
        bey = pb[2] - pe[2]
        cey = pc[2] - pe[2]
        dey = pd[2] - pe[2]
        aez = pa[3] - pe[3]
        bez = pb[3] - pe[3]
        cez = pc[3] - pe[3]
        dez = pd[3] - pe[3]

        aexbey = aex * bey
        bexaey = bex * aey
        ab = aexbey - bexaey
        bexcey = bex * cey
        cexbey = cex * bey
        bc = bexcey - cexbey
        cexdey = cex * dey
        dexcey = dex * cey
        cd = cexdey - dexcey
        dexaey = dex * aey
        aexdey = aex * dey
        da = dexaey - aexdey

        aexcey = aex * cey
        cexaey = cex * aey
        ac = aexcey - cexaey
        bexdey = bex * dey
        dexbey = dex * bey
        bd = bexdey - dexbey

        abc = aez * bc - bez * ac + cez * ab
        bcd = bez * cd - cez * bd + dez * bc
        cda = cez * da + dez * ac + aez * cd
        dab = dez * ab + aez * bd + bez * da

        alift = aex * aex + aey * aey + aez * aez
        blift = bex * bex + bey * bey + bez * bez
        clift = cex * cex + cey * cey + cez * cez
        dlift = dex * dex + dey * dey + dez * dez

        det = (dlift * abc - clift * dab) + (blift * cda - alift * bcd)

        aezplus = Absolute(aez)
        bezplus = Absolute(bez)
        cezplus = Absolute(cez)
        dezplus = Absolute(dez)
        aexbeyplus = Absolute(aexbey)
        bexaeyplus = Absolute(bexaey)
        bexceyplus = Absolute(bexcey)
        cexbeyplus = Absolute(cexbey)
        cexdeyplus = Absolute(cexdey)
        dexceyplus = Absolute(dexcey)
        dexaeyplus = Absolute(dexaey)
        aexdeyplus = Absolute(aexdey)
        aexceyplus = Absolute(aexcey)
        cexaeyplus = Absolute(cexaey)
        bexdeyplus = Absolute(bexdey)
        dexbeyplus = Absolute(dexbey)
        permanent = ((cexdeyplus + dexceyplus) * bezplus +
                     (dexbeyplus + bexdeyplus) * cezplus +
                     (bexceyplus + cexbeyplus) * dezplus) *
                    alift +
                    ((dexaeyplus + aexdeyplus) * cezplus +
                     (aexceyplus + cexaeyplus) * dezplus +
                     (cexdeyplus + dexceyplus) * aezplus) *
                    blift +
                    ((aexbeyplus + bexaeyplus) * dezplus +
                     (bexdeyplus + dexbeyplus) * aezplus +
                     (dexaeyplus + aexdeyplus) * bezplus) *
                    clift +
                    ((bexceyplus + cexbeyplus) * aezplus +
                     (cexaeyplus + aexceyplus) * bezplus +
                     (aexbeyplus + bexaeyplus) * cezplus) *
                    dlift
        errbound = isperrboundA(T) * permanent
        if (det > errbound) || (-det > errbound)
            return det
        end

        return insphereadapt(pa, pb, pc, pd, pe, permanent, cache)
    end
end

insphereexact_cache(_, cache) = cache
insphereexact_cache(::Type{T}, ::Nothing) where {T} = insphereexact_cache(T)
function insphereexact_cache(::Type{T}) where {T}
    cache = Vec{T}(undef, 24896)        # cache_size = (64 + 64) + (128 + 128 + 128 + 128 + 128) + (192) + (320 + 320 + 320 + 320) + (384 + 384 + 384) + (576 + 576) + (768) + (1152 + 1152 + 1152 + 1152 + 1152) + (2304 + 2304) + (3456) + (5760)
    h48_1 = view(cache, 1:48)           # 0 .+ (1:48)
    h48_2 = view(cache, 65:112)         # 64 .+ (1:48)
    h96_1 = view(cache, 129:224)        # 128 .+ (1:96)
    h96_2 = view(cache, 257:352)        # 256 .+ (1:96)
    h96_3 = view(cache, 385:480)        # 384 .+ (1:96)
    h96_4 = view(cache, 513:608)        # 512 .+ (1:96)
    h96_5 = view(cache, 641:736)        # 640 .+ (1:96)
    h192 = view(cache, 769:960)         # 768 .+ (1:192)
    h288_1 = view(cache, 961:1248)      # 960 .+ (1:288)
    h288_2 = view(cache, 1281:1568)     # 1280 .+ (1:288)
    h288_3 = view(cache, 1601:1888)     # 1600 .+ (1:288)
    h288_4 = view(cache, 1921:2208)     # 1920 .+ (1:288)
    h384_1 = view(cache, 2241:2624)     # 2240 .+ (1:384)
    h384_2 = view(cache, 2625:3008)     # 2624 .+ (1:384)
    h384_3 = view(cache, 3009:3392)     # 3008 .+ (1:384)
    h576_1 = view(cache, 3393:3968)     # 3392 .+ (1:576)
    h576_2 = view(cache, 3969:4544)     # 3968 .+ (1:576)
    h768_1 = view(cache, 4545:5312)     # 4544 .+ (1:768)
    h1152_1 = view(cache, 5313:6464)    # 5312 .+ (1:1152)
    h1152_2 = view(cache, 6465:7616)    # 6464 .+ (1:1152)
    h1152_3 = view(cache, 7617:8768)    # 7616 .+ (1:1152)
    h1152_4 = view(cache, 8769:9920)    # 8768 .+ (1:1152)
    h1152_5 = view(cache, 9921:11072)   # 9920 .+ (1:1152)
    h2304_1 = view(cache, 11073:13376)  # 11072 .+ (1:2304)
    h2304_2 = view(cache, 13377:15680)  # 13376 .+ (1:2304)
    h3456 = view(cache, 15681:19136)    # 15680 .+ (1:3456)
    h5760 = view(cache, 19137:24896)    # 19136 .+ (1:5760)
    return h48_1, h48_2, h96_1, h96_2, h96_3, h96_4, h96_5, h192, h288_1, h288_2, h288_3, h288_4, h384_1, h384_2, h384_3, h576_1, h576_2, h768_1, h1152_1, h1152_2, h1152_3, h1152_4, h1152_5, h2304_1, h2304_2, h3456, h5760
end
insphereslow_cache(_, cache) = cache
insphereslow_cache(::Type{T}, ::Nothing) where {T} = insphereslow_cache(T)
function insphereslow_cache(::Type{T}) where {T}
    cache = Vec{T}(undef, 108800)       # cache_size = (64 + 64 + 64) + (128) + (192) + (384 + 384 + 384 + 384 + 384 + 384) + (768 + 768 + 768 + 768 + 768 + 768 + 768 + 768 + 768) + (1536 + 1536 + 1536) + (2304 + 2304 + 2304) + (4608) + (6912 + 6912 + 6912 + 6912) + (13824 + 13824) + (27648)
    h64_1 = view(cache, 1:64)           # 0 .+ (1:64)
    h64_2 = view(cache, 65:128)         # 64 .+ (1:64)
    h64_3 = view(cache, 129:192)        # 128 .+ (1:64)
    h128 = view(cache, 193:320)         # 192 .+ (1:128)
    h192 = view(cache, 321:512)         # 320 .+ (1:192)
    h384_1 = view(cache, 513:896)       # 512 .+ (1:384)
    h384_2 = view(cache, 897:1280)      # 896 .+ (1:384)
    h384_3 = view(cache, 1281:1664)     # 1280 .+ (1:384)
    h384_4 = view(cache, 1665:2048)     # 1664 .+ (1:384)
    h384_5 = view(cache, 2049:2432)     # 2048 .+ (1:384)
    h384_6 = view(cache, 2433:2816)     # 2432 .+ (1:384)
    h768_1 = view(cache, 2817:3584)     # 2816 .+ (1:768)
    h768_2 = view(cache, 3585:4352)     # 3584 .+ (1:768)
    h768_3 = view(cache, 4353:5120)     # 4352 .+ (1:768)
    h768_4 = view(cache, 5121:5888)     # 5120 .+ (1:768)
    h768_5 = view(cache, 5889:6656)     # 5888 .+ (1:768)
    h768_6 = view(cache, 6657:7424)     # 6656 .+ (1:768)
    h768_7 = view(cache, 7425:8192)     # 7424 .+ (1:768)
    h768_8 = view(cache, 8193:8960)     # 8192 .+ (1:768)
    h768_9 = view(cache, 8961:9728)     # 8960 .+ (1:768)
    h1536_1 = view(cache, 9729:11264)   # 9728 .+ (1:1536)
    h1536_2 = view(cache, 11265:12800)  # 11264 .+ (1:1536)
    h1536_3 = view(cache, 12801:14336)  # 12800 .+ (1:1536)
    h2304_1 = view(cache, 14337:16640)  # 14336 .+ (1:2304)
    h2304_2 = view(cache, 16641:18944)  # 16640 .+ (1:2304)
    h2304_3 = view(cache, 18945:21248)  # 18944 .+ (1:2304)
    h4608 = view(cache, 21249:25856)    # 21248 .+ (1:4608)
    h6912_1 = view(cache, 25857:32768)  # 25856 .+ (1:6912)
    h6912_2 = view(cache, 32769:39680)  # 32768 .+ (1:6912)
    h6912_3 = view(cache, 39681:46592)  # 39680 .+ (1:6912)
    h6912_4 = view(cache, 46593:53504)  # 46592 .+ (1:6912)
    h13824_1 = view(cache, 53505:67328) # 53504 .+ (1:13824)
    h13824_2 = view(cache, 67329:81152) # 67328 .+ (1:13824)
    h27648 = view(cache, 81153:108800)  # 81152 .+ (1:27648)
    return h64_1, h64_2, h64_3, h128, h192, h384_1, h384_2, h384_3, h384_4, h384_5, h384_6, h768_1, h768_2, h768_3, h768_4, h768_5, h768_6, h768_7, h768_8, h768_9, h1536_1, h1536_2, h1536_3, h2304_1, h2304_2, h2304_3, h4608, h6912_1, h6912_2, h6912_3, h6912_4, h13824_1, h13824_2, h27648
end

function define_forward_declarations(pred)
    declarations = raw"""
    double doublerand(void);
    double narrowdoublerand(void);
    double uniformdoublerand(void);
    float floatrand(void);
    float narrowfloatrand(void);
    float uniformfloatrand(void);
    void exactinit(void);
    int grow_expansion(int elen, REAL *e, REAL b, REAL *h);
    int grow_expansion_zeroelim(int elen, REAL *e, REAL b, REAL *h);
    int expansion_sum(int elen, REAL *e, int flen, REAL *f, REAL *h);
    int expansion_sum_zeroelim1(int elen, REAL *e, int flen, REAL *f, REAL *h);
    int expansion_sum_zeroelim2(int elen, REAL *e, int flen, REAL *f, REAL *h);
    int fast_expansion_sum(int elen, REAL *e, int flen, REAL *f, REAL *h);
    int fast_expansion_sum_zeroelim(int elen, REAL *e, int flen, REAL *f, REAL *h);
    int linear_expansion_sum(int elen, REAL *e, int flen, REAL *f, REAL *h);
    int linear_expansion_sum_zeroelim(int elen, REAL *e, int flen, REAL *f, REAL *h);
    int scale_expansion(int elen, REAL *e, REAL b, REAL *h);
    int scale_expansion_zeroelim(int elen, REAL *e, REAL b, REAL *h);
    int compress(int elen, REAL *e, REAL *h);
    REAL estimate(int elen, REAL *e);
    REAL orient2dfast(REAL *pa, REAL *pb, REAL *pc);
    REAL orient2dexact(REAL *pa, REAL *pb, REAL *pc);
    REAL orient2dslow(REAL *pa, REAL *pb, REAL *pc);
    REAL orient2dadapt(REAL *pa, REAL *pb, REAL *pc, REAL detsum);
    REAL orient2d(REAL *pa, REAL *pb, REAL *pc);
    REAL orient3dfast(REAL *pa, REAL *pb, REAL *pc, REAL *pd);
    REAL orient3dexact(REAL *pa, REAL *pb, REAL *pc, REAL *pd);
    REAL orient3dslow(REAL *pa, REAL *pb, REAL *pc, REAL *pd);
    REAL orient3dadapt(REAL *pa, REAL *pb, REAL *pc, REAL *pd, REAL permanent);
    REAL orient3d(REAL *pa, REAL *pb, REAL *pc, REAL *pd);
    REAL incirclefast(REAL *pa, REAL*pb, REAL *pc, REAL *pd);
    REAL incircleexact(REAL *pa, REAL*pb, REAL *pc, REAL *pd);
    REAL incircleslow(REAL *pa, REAL*pb, REAL *pc, REAL *pd);
    REAL incircleadapt(REAL *pa, REAL*pb, REAL *pc, REAL *pd, REAL permanent);
    REAL incirclefast(REAL *pa, REAL *pb, REAL *pc, REAL *pd);
    REAL incircle(REAL *pa, REAL *pb, REAL *pc, REAL *pd);
    REAL inspherefast(REAL *pa, REAL *pb, REAL *pc, REAL *pd, REAL *pe);
    REAL insphereexact(REAL *pa, REAL *pb, REAL *pc, REAL *pd, REAL *pe);
    REAL insphereslow(REAL *pa, REAL *pb, REAL *pc, REAL *pd, REAL *pe);
    REAL insphereadapt(REAL *pa, REAL *pb, REAL *pc, REAL *pd, REAL *pe, REAL permanent);
    REAL insphere(REAL *pa, REAL *pb, REAL *pc, REAL *pd, REAL *pe);
    """
    # We put the declarations in some arbitrary place (after REAL has been defined, of course)
    return replace(pred,
        "#define UNIFORMRAND uniformdoublerand" => "#define UNIFORMRAND uniformdoublerand\n" * declarations
    )
end

function fix_windows(pred)
    if Sys.iswindows()
        # random(), being a POSIX function, is not available on Windows. We need to use rand().
        return replace(pred, "random()" => "rand()")
    else
        return pred
    end
end

function fix_two_square(pred)
    return replace(pred, "#define Two_Square" => "#define Old_Two_Square")
end

function convert_macros(pred)
    converted_macros = read("macro_defs.txt", String)
    return pred * "\n" * converted_macros
end

function convert_float(pred)
    return replace(
        pred,
        "REAL double" => "REAL float",
        "1.793662034335766e-43" => "1.793662034335766e-17",
        "3.2138760885179806e60" => "3.2138760885179806e12"
    )
end

function compile(pred)
    write("predicates64.c", pred)
    write("predicates32.c", convert_float(pred))
    if !isfile("libpredicates64.so")
        run(`gcc -shared -fPIC -g2 predicates64.c -o libpredicates64.so`)
    end
    if !isfile("libpredicates32.so")
        run(`gcc -shared -fPIC -g2 predicates32.c -o libpredicates32.so`)
    end
end

function test_macros()
    run(`gcc -o macro_tests macro_defs.c`)
    macro32 = read("macro_defs.c", String) |> convert_float
    write("macro_defs32.c", macro32)
    run(`gcc -o macro_tests32 macro_defs32.c`)
    @test success(run(ignorestatus(`./macro_tests`)))
    @test success(run(ignorestatus(`./macro_tests32`)))
end

function cleanup()
    rm("predicates32.c")
    rm("predicates64.c")
    rm("macro_defs32.c")
    rm("./macro_tests" * (Sys.iswindows() ? ".exe" : ""))
    rm("./macro_tests32" * (Sys.iswindows() ? ".exe" : ""))
end

function compile()
    read("predicates.c", String) |>
    define_forward_declarations |>
    fix_windows |>
    fix_two_square |>
    convert_macros |>
    compile
    test_macros()
    cleanup()
end

compile()

function orient3fast(pa, pb, pc, pd)
    @inbounds begin
        adx = pa[1] - pd[1]
        bdx = pb[1] - pd[1]
        cdx = pc[1] - pd[1]
        ady = pa[2] - pd[2]
        bdy = pb[2] - pd[2]
        cdy = pc[2] - pd[2]
        adz = pa[3] - pd[3]
        bdz = pb[3] - pd[3]
        cdz = pc[3] - pd[3]

        return adx * (bdy * cdz - bdz * cdy) +
               bdx * (cdy * adz - cdz * ady) +
               cdx * (ady * bdz - adz * bdy)
    end
end

function orient3exact(pa, pb, pc, pd, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h12 = ntuple(_ -> zero(T), Val(12))
        h24 = ntuple(_ -> zero(T), Val(24))
        h32 = ntuple(_ -> zero(T), Val(32))

        axby1, axby0 = Two_Product(pa[1], pb[2])
        bxay1, bxay0 = Two_Product(pb[1], pa[2])
        ab3, ab2, ab1, ab0 = Two_Two_Diff(axby1, axby0, bxay1, bxay0)
        ab = (ab0, ab1, ab2, ab3)

        bxcy1, bxcy0 = Two_Product(pb[1], pc[2])
        cxby1, cxby0 = Two_Product(pc[1], pb[2])
        bc3, bc2, bc1, bc0 = Two_Two_Diff(bxcy1, bxcy0, cxby1, cxby0)
        bc = (bc0, bc1, bc2, bc3)

        cxdy1, cxdy0 = Two_Product(pc[1], pd[2])
        dxcy1, dxcy0 = Two_Product(pd[1], pc[2])
        cd3, cd2, cd1, cd0 = Two_Two_Diff(cxdy1, cxdy0, dxcy1, dxcy0)
        cd = (cd0, cd1, cd2, cd3)

        dxay1, dxay0 = Two_Product(pd[1], pa[2])
        axdy1, axdy0 = Two_Product(pa[1], pd[2])
        da3, da2, da1, da0 = Two_Two_Diff(dxay1, dxay0, axdy1, axdy0)
        da = (da0, da1, da2, da3)

        axcy1, axcy0 = Two_Product(pa[1], pc[2])
        cxay1, cxay0 = Two_Product(pc[1], pa[2])
        ac3, ac2, ac1, ac0 = Two_Two_Diff(axcy1, axcy0, cxay1, cxay0)
        ac = (ac0, ac1, ac2, ac3)

        bxdy1, bxdy0 = Two_Product(pb[1], pd[2])
        dxby1, dxby0 = Two_Product(pd[1], pb[2])
        bd3, bd2, bd1, bd0 = Two_Two_Diff(bxdy1, bxdy0, dxby1, dxby0)
        bd = (bd0, bd1, bd2, bd3)

        temp8, templen = fast_expansion_sum_zeroelim(4, cd, 4, da, h8)
        cda, cdalen = fast_expansion_sum_zeroelim(templen, temp8, 4, ac, h12)
        temp8, templen = fast_expansion_sum_zeroelim(4, da, 4, ab, h8)
        dab, dablen = fast_expansion_sum_zeroelim(templen, temp8, 4, bd, h12)
        bd = (-bd[1], -bd[2], -bd[3], -bd[4])
        ac = (-ac[1], -ac[2], -ac[3], -ac[4])
        temp8, templen = fast_expansion_sum_zeroelim(4, ab, 4, bc, h8)
        abc, abclen = fast_expansion_sum_zeroelim(templen, temp8, 4, ac, h12)
        temp8, templen = fast_expansion_sum_zeroelim(4, bc, 4, cd, h8)
        bcd, bcdlen = fast_expansion_sum_zeroelim(templen, temp8, 4, bd, h12)

        adet, alen = scale_expansion_zeroelim(bcdlen, bcd, pa[3], h24)
        bdet, blen = scale_expansion_zeroelim(cdalen, cda, -pb[3], h24)
        cdet, clen = scale_expansion_zeroelim(dablen, dab, pc[3], h24)
        ddet, dlen = scale_expansion_zeroelim(abclen, abc, -pd[3], h24)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h32) # abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h48_1)
        cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h32) # cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h48_2)
        deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h32) # deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h96)

        if ablen < 32 && cdlen < 32 && deterlen < 32
            return deter[deterlen]
        else
            h48_1, h48_2, h96 = orient3exact_cache(T, cache)

            abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h48_1)
            cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h48_2)
            deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h96)

            return deter[deterlen]
        end
    end
end

function orient3slow(pa, pb, pc, pd, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h16 = ntuple(_ -> zero(T), Val(16))
        h32 = ntuple(_ -> zero(T), Val(32))

        adx, adxtail = Two_Diff(pa[1], pd[1])
        ady, adytail = Two_Diff(pa[2], pd[2])
        adz, adztail = Two_Diff(pa[3], pd[3])
        bdx, bdxtail = Two_Diff(pb[1], pd[1])
        bdy, bdytail = Two_Diff(pb[2], pd[2])
        bdz, bdztail = Two_Diff(pb[3], pd[3])
        cdx, cdxtail = Two_Diff(pc[1], pd[1])
        cdy, cdytail = Two_Diff(pc[2], pd[2])
        cdz, cdztail = Two_Diff(pc[3], pd[3])

        axby7, axby6, axby5, axby4, axby3, axby2, axby1, axby0 = Two_Two_Product(adx, adxtail, bdy, bdytail)
        axby = (axby0, axby1, axby2, axby3, axby4, axby5, axby6, axby7)
        negate = -ady
        negatetail = -adytail
        bxay7, bxay6, bxay5, bxay4, bxay3, bxay2, bxay1, bxay0 = Two_Two_Product(bdx, bdxtail, negate, negatetail)
        bxay = (bxay0, bxay1, bxay2, bxay3, bxay4, bxay5, bxay6, bxay7)
        bxcy7, bxcy6, bxcy5, bxcy4, bxcy3, bxcy2, bxcy1, bxcy0 = Two_Two_Product(bdx, bdxtail, cdy, cdytail)
        bxcy = (bxcy0, bxcy1, bxcy2, bxcy3, bxcy4, bxcy5, bxcy6, bxcy7)
        negate = -bdy
        negatetail = -bdytail
        cxby7, cxby6, cxby5, cxby4, cxby3, cxby2, cxby1, cxby0 = Two_Two_Product(cdx, cdxtail, negate, negatetail)
        cxby = (cxby0, cxby1, cxby2, cxby3, cxby4, cxby5, cxby6, cxby7)
        cxay7, cxay6, cxay5, cxay4, cxay3, cxay2, cxay1, cxay0 = Two_Two_Product(cdx, cdxtail, ady, adytail)
        cxay = (cxay0, cxay1, cxay2, cxay3, cxay4, cxay5, cxay6, cxay7)
        negate = -cdy
        negatetail = -cdytail
        axcy7, axcy6, axcy5, axcy4, axcy3, axcy2, axcy1, axcy0 = Two_Two_Product(adx, adxtail, negate, negatetail)
        axcy = (axcy0, axcy1, axcy2, axcy3, axcy4, axcy5, axcy6, axcy7)

        temp16, temp16len = fast_expansion_sum_zeroelim(8, bxcy, 8, cxby, h16)
        temp32, temp32len = scale_expansion_zeroelim(temp16len, temp16, adz, h32)
        temp32t, temp32tlen = scale_expansion_zeroelim(temp16len, temp16, adztail, h32)
        adet, alen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h32) # adet, alen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h64_1)

        temp16, temp16len = fast_expansion_sum_zeroelim(8, cxay, 8, axcy, h16)
        temp32, temp32len = scale_expansion_zeroelim(temp16len, temp16, bdz, h32)
        temp32t, temp32tlen = scale_expansion_zeroelim(temp16len, temp16, bdztail, h32)
        bdet, blen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h32) # bdet, blen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h64_2)

        temp16, temp16len = fast_expansion_sum_zeroelim(8, axby, 8, bxay, h16)
        temp32, temp32len = scale_expansion_zeroelim(temp16len, temp16, cdz, h32)
        temp32t, temp32tlen = scale_expansion_zeroelim(temp16len, temp16, cdztail, h32)
        cdet, clen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h32) # cdet, clen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h64_3)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h32) # abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h128)
        deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h32) # deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h192_1)

        if alen < 32 && blen < 32 && clen < 32 && ablen < 32 && deterlen < 32
            return deter[deterlen]
        else
            h64_1, h64_2, h64_3, h128, h192_1 = orient3slow_cache(T, cache)

            temp16, temp16len = fast_expansion_sum_zeroelim(8, bxcy, 8, cxby, h16)
            temp32, temp32len = scale_expansion_zeroelim(temp16len, temp16, adz, h32)
            temp32t, temp32tlen = scale_expansion_zeroelim(temp16len, temp16, adztail, h32)
            adet, alen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h64_1)

            temp16, temp16len = fast_expansion_sum_zeroelim(8, cxay, 8, axcy, h16)
            temp32, temp32len = scale_expansion_zeroelim(temp16len, temp16, bdz, h32)
            temp32t, temp32tlen = scale_expansion_zeroelim(temp16len, temp16, bdztail, h32)
            bdet, blen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h64_2)

            temp16, temp16len = fast_expansion_sum_zeroelim(8, axby, 8, bxay, h16)
            temp32, temp32len = scale_expansion_zeroelim(temp16len, temp16, cdz, h32)
            temp32t, temp32tlen = scale_expansion_zeroelim(temp16len, temp16, cdztail, h32)
            cdet, clen = fast_expansion_sum_zeroelim(temp32len, temp32, temp32tlen, temp32t, h64_3)

            abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h128)
            deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h192_1)

            return deter[deterlen]
        end
    end
end

function orient3adapt(pa, pb, pc, pd, permanent, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h12 = ntuple(_ -> zero(T), Val(12))
        h16 = ntuple(_ -> zero(T), Val(16))
        h32 = ntuple(_ -> zero(T), Val(32))

        adx = pa[1] - pd[1]
        bdx = pb[1] - pd[1]
        cdx = pc[1] - pd[1]
        ady = pa[2] - pd[2]
        bdy = pb[2] - pd[2]
        cdy = pc[2] - pd[2]
        adz = pa[3] - pd[3]
        bdz = pb[3] - pd[3]
        cdz = pc[3] - pd[3]

        bdxcdy1, bdxcdy0 = Two_Product(bdx, cdy)
        cdxbdy1, cdxbdy0 = Two_Product(cdx, bdy)
        bc3, bc2, bc1, bc0 = Two_Two_Diff(bdxcdy1, bdxcdy0, cdxbdy1, cdxbdy0)
        bc = (bc0, bc1, bc2, bc3)
        adet, alen = scale_expansion_zeroelim(4, bc, adz, h8)

        cdxady1, cdxady0 = Two_Product(cdx, ady)
        adxcdy1, adxcdy0 = Two_Product(adx, cdy)
        ca3, ca2, ca1, ca0 = Two_Two_Diff(cdxady1, cdxady0, adxcdy1, adxcdy0)
        ca = (ca0, ca1, ca2, ca3)
        bdet, blen = scale_expansion_zeroelim(4, ca, bdz, h8)

        adxbdy1, adxbdy0 = Two_Product(adx, bdy)
        bdxady1, bdxady0 = Two_Product(bdx, ady)
        ab3, ab2, ab1, ab0 = Two_Two_Diff(adxbdy1, adxbdy0, bdxady1, bdxady0)
        ab = (ab0, ab1, ab2, ab3)
        cdet, clen = scale_expansion_zeroelim(4, ab, cdz, h8)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h16)

        args = pa, pb, pc, pd, permanent, adx, bdx, cdx, ady, bdy, cdy, adz, bdz, cdz, bc, adet, alen, ca, bdet, blen, ab, cdet, clen, abdet, ablen, cache

        @check_length _orient3dadapt args fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h32) # fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h192_1)

        det = estimate(finlength, fin1)
        errbound = o3derrboundB(T) * permanent
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        adxtail = Two_Diff_Tail(pa[1], pd[1], adx)
        bdxtail = Two_Diff_Tail(pb[1], pd[1], bdx)
        cdxtail = Two_Diff_Tail(pc[1], pd[1], cdx)
        adytail = Two_Diff_Tail(pa[2], pd[2], ady)
        bdytail = Two_Diff_Tail(pb[2], pd[2], bdy)
        cdytail = Two_Diff_Tail(pc[2], pd[2], cdy)
        adztail = Two_Diff_Tail(pa[3], pd[3], adz)
        bdztail = Two_Diff_Tail(pb[3], pd[3], bdz)
        cdztail = Two_Diff_Tail(pc[3], pd[3], cdz)

        if iszero(adxtail) && iszero(bdxtail) && iszero(cdxtail) &&
           iszero(adytail) && iszero(bdytail) && iszero(cdytail) &&
           iszero(adztail) && iszero(bdztail) && iszero(cdztail)
            return det
        end

        errbound = o3derrboundC(T) * permanent + resulterrbound(T) * Absolute(det)
        det += (adz * ((bdx * cdytail + cdy * bdxtail) - (bdy * cdxtail + cdx * bdytail)) +
                adztail * (bdx * cdy - bdy * cdx)) +
               (bdz * ((cdx * adytail + ady * cdxtail) - (cdy * adxtail + adx * cdytail)) +
                bdztail * (cdx * ady - cdy * adx)) +
               (cdz * ((adx * bdytail + bdy * adxtail) - (ady * bdxtail + bdx * adytail)) +
                cdztail * (adx * bdy - ady * bdx))
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        finnow = fin1
        finother = h32 # finother = h192_2

        if iszero(adxtail)
            if iszero(adytail)
                at_b = (zero(T), zero(T), zero(T), zero(T))
                at_blen = 1
                at_c = (zero(T), zero(T), zero(T), zero(T))
                at_clen = 1
            else
                negate = -adytail
                at_blarge, at_b0 = Two_Product(negate, bdx)
                at_b = (at_b0, at_blarge, zero(T), zero(T))
                at_blen = 2
                at_clarge, at_c0 = Two_Product(adytail, cdx)
                at_c = (at_c0, at_clarge, zero(T), zero(T))
                at_clen = 2
            end
        else
            if iszero(adytail)
                at_blarge, at_b0 = Two_Product(adxtail, bdy)
                at_b = (at_b0, at_blarge, zero(T), zero(T))
                at_blen = 2
                negate = -adxtail
                at_clarge, at_c0 = Two_Product(negate, cdy)
                at_c = (at_c0, at_clarge, zero(T), zero(T))
                at_clen = 2
            else
                adxt_bdy1, adxt_bdy0 = Two_Product(adxtail, bdy)
                adyt_bdx1, adyt_bdx0 = Two_Product(adytail, bdx)
                at_blarge, at_b2, at_b1, at_b0 = Two_Two_Diff(adxt_bdy1, adxt_bdy0, adyt_bdx1, adyt_bdx0)
                at_b = (at_b0, at_b1, at_b2, at_blarge)
                at_blen = 4
                adyt_cdx1, adyt_cdx0 = Two_Product(adytail, cdx)
                adxt_cdy1, adxt_cdy0 = Two_Product(adxtail, cdy)
                at_clarge, at_c2, at_c1, at_c0 = Two_Two_Diff(adyt_cdx1, adyt_cdx0, adxt_cdy1, adxt_cdy0)
                at_c = (at_c0, at_c1, at_c2, at_clarge)
                at_clen = 4
            end
        end
        if iszero(bdxtail)
            if iszero(bdytail)
                bt_c = (zero(T), zero(T), zero(T), zero(T))
                bt_clen = 1
                bt_a = (zero(T), zero(T), zero(T), zero(T))
                bt_alen = 1
            else
                negate = -bdytail
                bt_clarge, bt_c0 = Two_Product(negate, cdx)
                bt_c = (bt_c0, bt_clarge, zero(T), zero(T))
                bt_clen = 2
                bt_alarge, bt_a0 = Two_Product(bdytail, adx)
                bt_a = (bt_a0, bt_alarge, zero(T), zero(T))
                bt_alen = 2
            end
        else
            if iszero(bdytail)
                bt_clarge, bt_c0 = Two_Product(bdxtail, cdy)
                bt_c = (bt_c0, bt_clarge, zero(T), zero(T))
                bt_clen = 2
                negate = -bdxtail
                bt_alarge, bt_a0 = Two_Product(negate, ady)
                bt_a = (bt_a0, bt_alarge, zero(T), zero(T))
                bt_alen = 2
            else
                bdxt_cdy1, bdxt_cdy0 = Two_Product(bdxtail, cdy)
                bdyt_cdx1, bdyt_cdx0 = Two_Product(bdytail, cdx)
                bt_clarge, bt_c2, bt_c1, bt_c0 = Two_Two_Diff(bdxt_cdy1, bdxt_cdy0, bdyt_cdx1, bdyt_cdx0)
                bt_c = (bt_c0, bt_c1, bt_c2, bt_clarge)
                bt_clen = 4
                bdyt_adx1, bdyt_adx0 = Two_Product(bdytail, adx)
                bdxt_ady1, bdxt_ady0 = Two_Product(bdxtail, ady)
                bt_alarge, bt_a2, bt_a1, bt_a0 = Two_Two_Diff(bdyt_adx1, bdyt_adx0, bdxt_ady1, bdxt_ady0)
                bt_a = (bt_a0, bt_a1, bt_a2, bt_alarge)
                bt_alen = 4
            end
        end
        if iszero(cdxtail)
            if iszero(cdytail)
                ct_a = (zero(T), zero(T), zero(T), zero(T))
                ct_alen = 1
                ct_b = (zero(T), zero(T), zero(T), zero(T))
                ct_blen = 1
            else
                negate = -cdytail
                ct_alarge, ct_a0 = Two_Product(negate, adx)
                ct_a = (ct_a0, ct_alarge, zero(T), zero(T))
                ct_alen = 2
                ct_blarge, ct_b0 = Two_Product(cdytail, bdx)
                ct_b = (ct_b0, ct_blarge, zero(T), zero(T))
                ct_blen = 2
            end
        else
            if iszero(cdytail)
                ct_alarge, ct_a0 = Two_Product(cdxtail, ady)
                ct_a = (ct_a0, ct_alarge, zero(T), zero(T))
                ct_alen = 2
                negate = -cdxtail
                ct_blarge, ct_b0 = Two_Product(negate, bdy)
                ct_b = (ct_b0, ct_blarge, zero(T), zero(T))
                ct_blen = 2
            else
                cdxt_ady1, cdxt_ady0 = Two_Product(cdxtail, ady)
                cdyt_adx1, cdyt_adx0 = Two_Product(cdytail, adx)
                ct_alarge, ct_a2, ct_a1, ct_a0 = Two_Two_Diff(cdxt_ady1, cdxt_ady0, cdyt_adx1, cdyt_adx0)
                ct_a = (ct_a0, ct_a1, ct_a2, ct_alarge)
                ct_alen = 4
                cdyt_bdx1, cdyt_bdx0 = Two_Product(cdytail, bdx)
                cdxt_bdy1, cdxt_bdy0 = Two_Product(cdxtail, bdy)
                ct_blarge, ct_b2, ct_b1, ct_b0 = Two_Two_Diff(cdyt_bdx1, cdyt_bdx0, cdxt_bdy1, cdxt_bdy0)
                ct_b = (ct_b0, ct_b1, ct_b2, ct_blarge)
                ct_blen = 4
            end
        end
        bct, bctlen = fast_expansion_sum_zeroelim(bt_clen, bt_c, ct_blen, ct_b, h8)
        w, wlength = scale_expansion_zeroelim(bctlen, bct, adz, h16)
        @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
        finnow, finother = finother, finnow

        cat, catlen = fast_expansion_sum_zeroelim(ct_alen, ct_a, at_clen, at_c, h8)
        w, wlength = scale_expansion_zeroelim(catlen, cat, bdz, w)
        @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
        finnow, finother = finother, finnow

        abt, abtlen = fast_expansion_sum_zeroelim(at_blen, at_b, bt_alen, bt_a, h8)
        w, wlength = scale_expansion_zeroelim(abtlen, abt, cdz, w)
        @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
        finnow, finother = finother, finnow

        if !iszero(adztail)
            v, vlength = scale_expansion_zeroelim(4, bc, adztail, h12)
            @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, vlength, v, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(bdztail)
            v, vlength = scale_expansion_zeroelim(4, ca, bdztail, h12)
            @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, vlength, v, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(cdztail)
            v, vlength = scale_expansion_zeroelim(4, ab, cdztail, h12)
            @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, vlength, v, finother)
            finnow, finother = finother, finnow
        end

        if !iszero(adxtail)
            if !iszero(bdytail)
                adxt_bdyt1, adxt_bdyt0 = Two_Product(adxtail, bdytail)
                u3, u2, u1, u0 = Two_One_Product(adxt_bdyt1, adxt_bdyt0, cdz)
                u = (u0, u1, u2, u3)
                @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(cdztail)
                    u3, u2, u1, u0 = Two_One_Product(adxt_bdyt1, adxt_bdyt0, cdztail)
                    u = (u0, u1, u2, u3)
                    @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
            if !iszero(cdytail)
                negate = -adxtail
                adxt_cdyt1, adxt_cdyt0 = Two_Product(negate, cdytail)
                u3, u2, u1, u0 = Two_One_Product(adxt_cdyt1, adxt_cdyt0, bdz)
                u = (u0, u1, u2, u3)
                @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(bdztail)
                    u3, u2, u1, u0 = Two_One_Product(adxt_cdyt1, adxt_cdyt0, bdztail)
                    u = (u0, u1, u2, u3)
                    @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
        end
        if !iszero(bdxtail)
            if !iszero(cdytail)
                bdxt_cdyt1, bdxt_cdyt0 = Two_Product(bdxtail, cdytail)
                u3, u2, u1, u0 = Two_One_Product(bdxt_cdyt1, bdxt_cdyt0, adz)
                u = (u0, u1, u2, u3)
                @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(adztail)
                    u3, u2, u1, u0 = Two_One_Product(bdxt_cdyt1, bdxt_cdyt0, adztail)
                    u = (u0, u1, u2, u3)
                    @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
            if !iszero(adytail)
                negate = -bdxtail
                bdxt_adyt1, bdxt_adyt0 = Two_Product(negate, adytail)
                u3, u2, u1, u0 = Two_One_Product(bdxt_adyt1, bdxt_adyt0, cdz)
                u = (u0, u1, u2, u3)
                @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(cdztail)
                    u3, u2, u1, u0 = Two_One_Product(bdxt_adyt1, bdxt_adyt0, cdztail)
                    u = (u0, u1, u2, u3)
                    @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
        end
        if !iszero(cdxtail)
            if !iszero(adytail)
                cdxt_adyt1, cdxt_adyt0 = Two_Product(cdxtail, adytail)
                u3, u2, u1, u0 = Two_One_Product(cdxt_adyt1, cdxt_adyt0, bdz)
                u = (u0, u1, u2, u3)
                @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(bdztail)
                    u3, u2, u1, u0 = Two_One_Product(cdxt_adyt1, cdxt_adyt0, bdztail)
                    u = (u0, u1, u2, u3)
                    @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
            if !iszero(bdytail)
                negate = -cdxtail
                cdxt_bdyt1, cdxt_bdyt0 = Two_Product(negate, bdytail)
                u3, u2, u1, u0 = Two_One_Product(cdxt_bdyt1, cdxt_bdyt0, adz)
                u = (u0, u1, u2, u3)
                @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(adztail)
                    u3, u2, u1, u0 = Two_One_Product(cdxt_bdyt1, cdxt_bdyt0, adztail)
                    u = (u0, u1, u2, u3)
                    @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
        end

        if !iszero(adztail)
            w, wlength = scale_expansion_zeroelim(bctlen, bct, adztail, w)
            @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(bdztail)
            w, wlength = scale_expansion_zeroelim(catlen, cat, bdztail, w)
            @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(cdztail)
            w, wlength = scale_expansion_zeroelim(abtlen, abt, cdztail, w)
            @check_length _orient3dadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
            finnow, finother = finother, finnow
        end

        return finnow[finlength]
    end
end
function _orient3dadapt(pa, pb, pc, pd, permanent, adx, bdx, cdx, ady, bdy, cdy, adz, bdz, cdz, bc, adet, alen, ca, bdet, blen, ab, cdet, clen, abdet, ablen, cache)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h12 = ntuple(_ -> zero(T), Val(12))
        h16 = ntuple(_ -> zero(T), Val(16))
        h192_1, h192_2 = orient3adapt_cache(T, cache)

        fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h192_1) 

        det = estimate(finlength, fin1)
        errbound = o3derrboundB(T) * permanent
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        adxtail = Two_Diff_Tail(pa[1], pd[1], adx)
        bdxtail = Two_Diff_Tail(pb[1], pd[1], bdx)
        cdxtail = Two_Diff_Tail(pc[1], pd[1], cdx)
        adytail = Two_Diff_Tail(pa[2], pd[2], ady)
        bdytail = Two_Diff_Tail(pb[2], pd[2], bdy)
        cdytail = Two_Diff_Tail(pc[2], pd[2], cdy)
        adztail = Two_Diff_Tail(pa[3], pd[3], adz)
        bdztail = Two_Diff_Tail(pb[3], pd[3], bdz)
        cdztail = Two_Diff_Tail(pc[3], pd[3], cdz)

        if iszero(adxtail) && iszero(bdxtail) && iszero(cdxtail) &&
           iszero(adytail) && iszero(bdytail) && iszero(cdytail) &&
           iszero(adztail) && iszero(bdztail) && iszero(cdztail)
            return det
        end

        errbound = o3derrboundC(T) * permanent + resulterrbound(T) * Absolute(det)
        det += (adz * ((bdx * cdytail + cdy * bdxtail) - (bdy * cdxtail + cdx * bdytail)) +
                adztail * (bdx * cdy - bdy * cdx)) +
               (bdz * ((cdx * adytail + ady * cdxtail) - (cdy * adxtail + adx * cdytail)) +
                bdztail * (cdx * ady - cdy * adx)) +
               (cdz * ((adx * bdytail + bdy * adxtail) - (ady * bdxtail + bdx * adytail)) +
                cdztail * (adx * bdy - ady * bdx))
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        finnow = fin1
        finother = h192_2

        if iszero(adxtail)
            if iszero(adytail)
                at_b = (zero(T), zero(T), zero(T), zero(T))
                at_blen = 1
                at_c = (zero(T), zero(T), zero(T), zero(T))
                at_clen = 1
            else
                negate = -adytail
                at_blarge, at_b0 = Two_Product(negate, bdx)
                at_b = (at_b0, at_blarge, zero(T), zero(T))
                at_blen = 2
                at_clarge, at_c0 = Two_Product(adytail, cdx)
                at_c = (at_c0, at_clarge, zero(T), zero(T))
                at_clen = 2
            end
        else
            if iszero(adytail)
                at_blarge, at_b0 = Two_Product(adxtail, bdy)
                at_b = (at_b0, at_blarge, zero(T), zero(T))
                at_blen = 2
                negate = -adxtail
                at_clarge, at_c0 = Two_Product(negate, cdy)
                at_c = (at_c0, at_clarge, zero(T), zero(T))
                at_clen = 2
            else
                adxt_bdy1, adxt_bdy0 = Two_Product(adxtail, bdy)
                adyt_bdx1, adyt_bdx0 = Two_Product(adytail, bdx)
                at_blarge, at_b2, at_b1, at_b0 = Two_Two_Diff(adxt_bdy1, adxt_bdy0, adyt_bdx1, adyt_bdx0)
                at_b = (at_b0, at_b1, at_b2, at_blarge)
                at_blen = 4
                adyt_cdx1, adyt_cdx0 = Two_Product(adytail, cdx)
                adxt_cdy1, adxt_cdy0 = Two_Product(adxtail, cdy)
                at_clarge, at_c2, at_c1, at_c0 = Two_Two_Diff(adyt_cdx1, adyt_cdx0, adxt_cdy1, adxt_cdy0)
                at_c = (at_c0, at_c1, at_c2, at_clarge)
                at_clen = 4
            end
        end
        if iszero(bdxtail)
            if iszero(bdytail)
                bt_c = (zero(T), zero(T), zero(T), zero(T))
                bt_clen = 1
                bt_a = (zero(T), zero(T), zero(T), zero(T))
                bt_alen = 1
            else
                negate = -bdytail
                bt_clarge, bt_c0 = Two_Product(negate, cdx)
                bt_c = (bt_c0, bt_clarge, zero(T), zero(T))
                bt_clen = 2
                bt_alarge, bt_a0 = Two_Product(bdytail, adx)
                bt_a = (bt_a0, bt_alarge, zero(T), zero(T))
                bt_alen = 2
            end
        else
            if iszero(bdytail)
                bt_clarge, bt_c0 = Two_Product(bdxtail, cdy)
                bt_c = (bt_c0, bt_clarge, zero(T), zero(T))
                bt_clen = 2
                negate = -bdxtail
                bt_alarge, bt_a0 = Two_Product(negate, ady)
                bt_a = (bt_a0, bt_alarge, zero(T), zero(T))
                bt_alen = 2
            else
                bdxt_cdy1, bdxt_cdy0 = Two_Product(bdxtail, cdy)
                bdyt_cdx1, bdyt_cdx0 = Two_Product(bdytail, cdx)
                bt_clarge, bt_c2, bt_c1, bt_c0 = Two_Two_Diff(bdxt_cdy1, bdxt_cdy0, bdyt_cdx1, bdyt_cdx0)
                bt_c = (bt_c0, bt_c1, bt_c2, bt_clarge)
                bt_clen = 4
                bdyt_adx1, bdyt_adx0 = Two_Product(bdytail, adx)
                bdxt_ady1, bdxt_ady0 = Two_Product(bdxtail, ady)
                bt_alarge, bt_a2, bt_a1, bt_a0 = Two_Two_Diff(bdyt_adx1, bdyt_adx0, bdxt_ady1, bdxt_ady0)
                bt_a = (bt_a0, bt_a1, bt_a2, bt_alarge)
                bt_alen = 4
            end
        end
        if iszero(cdxtail)
            if iszero(cdytail)
                ct_a = (zero(T), zero(T), zero(T), zero(T))
                ct_alen = 1
                ct_b = (zero(T), zero(T), zero(T), zero(T))
                ct_blen = 1
            else
                negate = -cdytail
                ct_alarge, ct_a0 = Two_Product(negate, adx)
                ct_a = (ct_a0, ct_alarge, zero(T), zero(T))
                ct_alen = 2
                ct_blarge, ct_b0 = Two_Product(cdytail, bdx)
                ct_b = (ct_b0, ct_blarge, zero(T), zero(T))
                ct_blen = 2
            end
        else
            if iszero(cdytail)
                ct_alarge, ct_a0 = Two_Product(cdxtail, ady)
                ct_a = (ct_a0, ct_alarge, zero(T), zero(T))
                ct_alen = 2
                negate = -cdxtail
                ct_blarge, ct_b0 = Two_Product(negate, bdy)
                ct_b = (ct_b0, ct_blarge, zero(T), zero(T))
                ct_blen = 2
            else
                cdxt_ady1, cdxt_ady0 = Two_Product(cdxtail, ady)
                cdyt_adx1, cdyt_adx0 = Two_Product(cdytail, adx)
                ct_alarge, ct_a2, ct_a1, ct_a0 = Two_Two_Diff(cdxt_ady1, cdxt_ady0, cdyt_adx1, cdyt_adx0)
                ct_a = (ct_a0, ct_a1, ct_a2, ct_alarge)
                ct_alen = 4
                cdyt_bdx1, cdyt_bdx0 = Two_Product(cdytail, bdx)
                cdxt_bdy1, cdxt_bdy0 = Two_Product(cdxtail, bdy)
                ct_blarge, ct_b2, ct_b1, ct_b0 = Two_Two_Diff(cdyt_bdx1, cdyt_bdx0, cdxt_bdy1, cdxt_bdy0)
                ct_b = (ct_b0, ct_b1, ct_b2, ct_blarge)
                ct_blen = 4
            end
        end
        bct, bctlen = fast_expansion_sum_zeroelim(bt_clen, bt_c, ct_blen, ct_b, h8)
        w, wlength = scale_expansion_zeroelim(bctlen, bct, adz, h16)
        finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
        finnow, finother = finother, finnow

        cat, catlen = fast_expansion_sum_zeroelim(ct_alen, ct_a, at_clen, at_c, h8)
        w, wlength = scale_expansion_zeroelim(catlen, cat, bdz, w)
        finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
        finnow, finother = finother, finnow

        abt, abtlen = fast_expansion_sum_zeroelim(at_blen, at_b, bt_alen, bt_a, h8)
        w, wlength = scale_expansion_zeroelim(abtlen, abt, cdz, w)
        finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
        finnow, finother = finother, finnow

        if !iszero(adztail)
            v, vlength = scale_expansion_zeroelim(4, bc, adztail, h12)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, vlength, v, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(bdztail)
            v, vlength = scale_expansion_zeroelim(4, ca, bdztail, h12)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, vlength, v, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(cdztail)
            v, vlength = scale_expansion_zeroelim(4, ab, cdztail, h12)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, vlength, v, finother)
            finnow, finother = finother, finnow
        end

        if !iszero(adxtail)
            if !iszero(bdytail)
                adxt_bdyt1, adxt_bdyt0 = Two_Product(adxtail, bdytail)
                u3, u2, u1, u0 = Two_One_Product(adxt_bdyt1, adxt_bdyt0, cdz)
                u = (u0, u1, u2, u3)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(cdztail)
                    u3, u2, u1, u0 = Two_One_Product(adxt_bdyt1, adxt_bdyt0, cdztail)
                    u = (u0, u1, u2, u3)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
            if !iszero(cdytail)
                negate = -adxtail
                adxt_cdyt1, adxt_cdyt0 = Two_Product(negate, cdytail)
                u3, u2, u1, u0 = Two_One_Product(adxt_cdyt1, adxt_cdyt0, bdz)
                u = (u0, u1, u2, u3)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(bdztail)
                    u3, u2, u1, u0 = Two_One_Product(adxt_cdyt1, adxt_cdyt0, bdztail)
                    u = (u0, u1, u2, u3)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
        end
        if !iszero(bdxtail)
            if !iszero(cdytail)
                bdxt_cdyt1, bdxt_cdyt0 = Two_Product(bdxtail, cdytail)
                u3, u2, u1, u0 = Two_One_Product(bdxt_cdyt1, bdxt_cdyt0, adz)
                u = (u0, u1, u2, u3)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(adztail)
                    u3, u2, u1, u0 = Two_One_Product(bdxt_cdyt1, bdxt_cdyt0, adztail)
                    u = (u0, u1, u2, u3)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
            if !iszero(adytail)
                negate = -bdxtail
                bdxt_adyt1, bdxt_adyt0 = Two_Product(negate, adytail)
                u3, u2, u1, u0 = Two_One_Product(bdxt_adyt1, bdxt_adyt0, cdz)
                u = (u0, u1, u2, u3)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(cdztail)
                    u3, u2, u1, u0 = Two_One_Product(bdxt_adyt1, bdxt_adyt0, cdztail)
                    u = (u0, u1, u2, u3)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
        end
        if !iszero(cdxtail)
            if !iszero(adytail)
                cdxt_adyt1, cdxt_adyt0 = Two_Product(cdxtail, adytail)
                u3, u2, u1, u0 = Two_One_Product(cdxt_adyt1, cdxt_adyt0, bdz)
                u = (u0, u1, u2, u3)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(bdztail)
                    u3, u2, u1, u0 = Two_One_Product(cdxt_adyt1, cdxt_adyt0, bdztail)
                    u = (u0, u1, u2, u3)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
            if !iszero(bdytail)
                negate = -cdxtail
                cdxt_bdyt1, cdxt_bdyt0 = Two_Product(negate, bdytail)
                u3, u2, u1, u0 = Two_One_Product(cdxt_bdyt1, cdxt_bdyt0, adz)
                u = (u0, u1, u2, u3)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                finnow, finother = finother, finnow
                if !iszero(adztail)
                    u3, u2, u1, u0 = Two_One_Product(cdxt_bdyt1, cdxt_bdyt0, adztail)
                    u = (u0, u1, u2, u3)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, 4, u, finother)
                    finnow, finother = finother, finnow
                end
            end
        end

        if !iszero(adztail)
            w, wlength = scale_expansion_zeroelim(bctlen, bct, adztail, w)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(bdztail)
            w, wlength = scale_expansion_zeroelim(catlen, cat, bdztail, w)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(cdztail)
            w, wlength = scale_expansion_zeroelim(abtlen, abt, cdztail, w)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, wlength, w, finother)
            finnow, finother = finother, finnow
        end

        return finnow[finlength]
    end
end

function orient3(pa, pb, pc, pd, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        adx = pa[1] - pd[1]
        bdx = pb[1] - pd[1]
        cdx = pc[1] - pd[1]
        ady = pa[2] - pd[2]
        bdy = pb[2] - pd[2]
        cdy = pc[2] - pd[2]
        adz = pa[3] - pd[3]
        bdz = pb[3] - pd[3]
        cdz = pc[3] - pd[3]

        bdxcdy = bdx * cdy
        cdxbdy = cdx * bdy

        cdxady = cdx * ady
        adxcdy = adx * cdy

        adxbdy = adx * bdy
        bdxady = bdx * ady

        det = adz * (bdxcdy - cdxbdy) +
              bdz * (cdxady - adxcdy) +
              cdz * (adxbdy - bdxady)

        permanent = (Absolute(bdxcdy) + Absolute(cdxbdy)) * Absolute(adz) +
                    (Absolute(cdxady) + Absolute(adxcdy)) * Absolute(bdz) +
                    (Absolute(adxbdy) + Absolute(bdxady)) * Absolute(cdz)
        errbound = o3derrboundA(T) * permanent
        if (det > errbound) || (-det > errbound)
            return det
        end

        return orient3adapt(pa, pb, pc, pd, permanent, cache)
    end
end

orient3exact_cache(_, cache) = cache
orient3exact_cache(::Type{T}, ::Nothing) where {T} = orient3exact_cache(T)
function orient3exact_cache(::Type{T}) where {T}
    cache = Vec{T}(undef, 256)          # cache_size = (64 + 64) + (128)
    h48_1 = view(cache, 1:48)           # 0 .+ (1:48)
    h48_2 = view(cache, 65:112)         # 64 .+ (1:48)
    h96 = view(cache, 129:224)          # 128 .+ (1:96)
    return h48_1, h48_2, h96
end
orient3slow_cache(_, cache) = cache
orient3slow_cache(::Type{T}, ::Nothing) where {T} = orient3slow_cache(T)
function orient3slow_cache(::Type{T}) where {T}
    cache = Vec{T}(undef, 512)          # cache_size = (64 + 64 + 64) + (128) + (192)
    h64_1 = view(cache, 1:64)           # 0 .+ (1:64)
    h64_2 = view(cache, 65:128)         # 64 .+ (1:64)
    h64_3 = view(cache, 129:192)        # 128 .+ (1:64)
    h128 = view(cache, 193:320)         # 192 .+ (1:128)
    h192_1 = view(cache, 321:512)       # 320 .+ (1:192)
    return h64_1, h64_2, h64_3, h128, h192_1
end
orient3adapt_cache(_, cache) = cache
orient3adapt_cache(::Type{T}, ::Nothing) where {T} = orient3adapt_cache(T)
function orient3adapt_cache(::Type{T}) where {T}
    cache = Vec{T}(undef, 384)          # cache_size = (192 + 192)
    h192_1 = view(cache, 1:192)         # 0 .+ (1:192)
    h192_2 = view(cache, 193:384)       # 192 .+ (1:192)
    return h192_1, h192_2
end

function incirclefast(pa, pb, pc, pd)
    @inbounds begin
        adx = pa[1] - pd[1]
        ady = pa[2] - pd[2]
        bdx = pb[1] - pd[1]
        bdy = pb[2] - pd[2]
        cdx = pc[1] - pd[1]
        cdy = pc[2] - pd[2]

        abdet = adx * bdy - bdx * ady
        bcdet = bdx * cdy - cdx * bdy
        cadet = cdx * ady - adx * cdy
        alift = adx * adx + ady * ady
        blift = bdx * bdx + bdy * bdy
        clift = cdx * cdx + cdy * cdy

        return alift * bcdet + blift * cadet + clift * abdet
    end
end

function incircleexact(pa, pb, pc, pd, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h12 = ntuple(_ -> zero(T), Val(12))
        h24 = ntuple(_ -> zero(T), Val(24))
        h32 = ntuple(_ -> zero(T), Val(32))

        axby1, axby0 = Two_Product(pa[1], pb[2])
        bxay1, bxay0 = Two_Product(pb[1], pa[2])
        ab3, ab2, ab1, ab0 = Two_Two_Diff(axby1, axby0, bxay1, bxay0)
        ab = (ab0, ab1, ab2, ab3)

        bxcy1, bxcy0 = Two_Product(pb[1], pc[2])
        cxby1, cxby0 = Two_Product(pc[1], pb[2])
        bc3, bc2, bc1, bc0 = Two_Two_Diff(bxcy1, bxcy0, cxby1, cxby0)
        bc = (bc0, bc1, bc2, bc3)

        cxdy1, cxdy0 = Two_Product(pc[1], pd[2])
        dxcy1, dxcy0 = Two_Product(pd[1], pc[2])
        cd3, cd2, cd1, cd0 = Two_Two_Diff(cxdy1, cxdy0, dxcy1, dxcy0)
        cd = (cd0, cd1, cd2, cd3)

        dxay1, dxay0 = Two_Product(pd[1], pa[2])
        axdy1, axdy0 = Two_Product(pa[1], pd[2])
        da3, da2, da1, da0 = Two_Two_Diff(dxay1, dxay0, axdy1, axdy0)
        da = (da0, da1, da2, da3)

        axcy1, axcy0 = Two_Product(pa[1], pc[2])
        cxay1, cxay0 = Two_Product(pc[1], pa[2])
        ac3, ac2, ac1, ac0 = Two_Two_Diff(axcy1, axcy0, cxay1, cxay0)
        ac = (ac0, ac1, ac2, ac3)

        bxdy1, bxdy0 = Two_Product(pb[1], pd[2])
        dxby1, dxby0 = Two_Product(pd[1], pb[2])
        bd3, bd2, bd1, bd0 = Two_Two_Diff(bxdy1, bxdy0, dxby1, dxby0)
        bd = (bd0, bd1, bd2, bd3)

        temp8, templen = fast_expansion_sum_zeroelim(4, cd, 4, da, h8)
        cda, cdalen = fast_expansion_sum_zeroelim(templen, temp8, 4, ac, h12)
        temp8, templen = fast_expansion_sum_zeroelim(4, da, 4, ab, temp8)
        dab, dablen = fast_expansion_sum_zeroelim(templen, temp8, 4, bd, h12)
        bd = (-bd[1], -bd[2], -bd[3], -bd[4])
        ac = (-ac[1], -ac[2], -ac[3], -ac[4])
        temp8, templen = fast_expansion_sum_zeroelim(4, ab, 4, bc, temp8)
        abc, abclen = fast_expansion_sum_zeroelim(templen, temp8, 4, ac, h12)
        temp8, templen = fast_expansion_sum_zeroelim(4, bc, 4, cd, temp8)
        bcd, bcdlen = fast_expansion_sum_zeroelim(templen, temp8, 4, bd, h12)

        args = pa, pb, pc, pd, cda, cdalen, dab, dablen, abc, abclen, bcd, bcdlen, cache

        det24x, xlen = scale_expansion_zeroelim(bcdlen, bcd, pa[1], h24)
        @check_length _incircleexact args det48x, xlen = scale_expansion_zeroelim(xlen, det24x, pa[1], h32) # det48x, xlen = scale_expansion_zeroelim(xlen, det24x, pa[1], h48_1)
        det24y, ylen = scale_expansion_zeroelim(bcdlen, bcd, pa[2], h24)
        @check_length _incircleexact args det48y, ylen = scale_expansion_zeroelim(ylen, det24y, pa[2], h32) # det48y, ylen = scale_expansion_zeroelim(ylen, det24y, pa[2], h48_2)
        @check_length _incircleexact args adet, alen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h32) # adet, alen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h96_1)

        det24x, xlen = scale_expansion_zeroelim(cdalen, cda, pb[1], h24)
        @check_length _incircleexact args det48x, xlen = scale_expansion_zeroelim(xlen, det24x, -pb[1], h32) # det48x, xlen = scale_expansion_zeroelim(xlen, det24x, -pb[1], h48_1)
        det24y, ylen = scale_expansion_zeroelim(cdalen, cda, pb[2], h24)
        @check_length _incircleexact args det48y, ylen = scale_expansion_zeroelim(ylen, det24y, -pb[2], h32) # det48y, ylen = scale_expansion_zeroelim(ylen, det24y, -pb[2], h48_2)
        @check_length _incircleexact args bdet, blen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h32) # bdet, blen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h96_2)

        det24x, xlen = scale_expansion_zeroelim(dablen, dab, pc[1], h24)
        @check_length _incircleexact args det48x, xlen = scale_expansion_zeroelim(xlen, det24x, pc[1], h32) # det48x, xlen = scale_expansion_zeroelim(xlen, det24x, pc[1], h48_1)
        det24y, ylen = scale_expansion_zeroelim(dablen, dab, pc[2], h24)
        @check_length _incircleexact args det48y, ylen = scale_expansion_zeroelim(ylen, det24y, pc[2], h32) # det48y, ylen = scale_expansion_zeroelim(ylen, det24y, pc[2], h48_2)
        @check_length _incircleexact args cdet, clen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h32) # cdet, clen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h96_3)

        det24x, xlen = scale_expansion_zeroelim(abclen, abc, pd[1], h24)
        @check_length _incircleexact args det48x, xlen = scale_expansion_zeroelim(xlen, det24x, -pd[1], h32) # det48x, xlen = scale_expansion_zeroelim(xlen, det24x, -pd[1], h48_1)
        det24y, ylen = scale_expansion_zeroelim(abclen, abc, pd[2], h24)
        @check_length _incircleexact args det48y, ylen = scale_expansion_zeroelim(ylen, det24y, -pd[2], h32) # det48y, ylen = scale_expansion_zeroelim(ylen, det24y, -pd[2], h48_2)
        @check_length _incircleexact args ddet, dlen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h32) # ddet, dlen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h96_4)

        @check_length _incircleexact args abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h32) # abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h192_1)
        @check_length _incircleexact args cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h32) # cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h192_2)
        @check_length _incircleexact args deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h32) # deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h384_1)

        return deter[deterlen]
    end
end
function _incircleexact(pa, pb, pc, pd, cda, cdalen, dab, dablen, abc, abclen, bcd, bcdlen, cache)
    @inbounds begin
        T = eltype(pa)
        h24 = ntuple(_ -> zero(T), Val(24))
        h48_1, h48_2, h96_1, h96_2, h96_3, h96_4, h192_1, h192_2, h384_1 = incircleexact_cache(T, cache)

        det24x, xlen = scale_expansion_zeroelim(bcdlen, bcd, pa[1], h24)
        det48x, xlen = scale_expansion_zeroelim(xlen, det24x, pa[1], h48_1)
        det24y, ylen = scale_expansion_zeroelim(bcdlen, bcd, pa[2], h24)
        det48y, ylen = scale_expansion_zeroelim(ylen, det24y, pa[2], h48_2)
        adet, alen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h96_1)

        det24x, xlen = scale_expansion_zeroelim(cdalen, cda, pb[1], h24)
        det48x, xlen = scale_expansion_zeroelim(xlen, det24x, -pb[1], h48_1)
        det24y, ylen = scale_expansion_zeroelim(cdalen, cda, pb[2], h24)
        det48y, ylen = scale_expansion_zeroelim(ylen, det24y, -pb[2], h48_2)
        bdet, blen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h96_2)

        det24x, xlen = scale_expansion_zeroelim(dablen, dab, pc[1], h24)
        det48x, xlen = scale_expansion_zeroelim(xlen, det24x, pc[1], h48_1)
        det24y, ylen = scale_expansion_zeroelim(dablen, dab, pc[2], h24)
        det48y, ylen = scale_expansion_zeroelim(ylen, det24y, pc[2], h48_2)
        cdet, clen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h96_3)

        det24x, xlen = scale_expansion_zeroelim(abclen, abc, pd[1], h24)
        det48x, xlen = scale_expansion_zeroelim(xlen, det24x, -pd[1], h48_1)
        det24y, ylen = scale_expansion_zeroelim(abclen, abc, pd[2], h24)
        det48y, ylen = scale_expansion_zeroelim(ylen, det24y, -pd[2], h48_2)
        ddet, dlen = fast_expansion_sum_zeroelim(xlen, det48x, ylen, det48y, h96_4)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h192_1)
        cddet, cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, h192_2)
        deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, h384_1)

        return deter[deterlen]
    end
end

function incircleslow(pa, pb, pc, pd, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h16 = ntuple(_ -> zero(T), Val(16))
        h32 = ntuple(_ -> zero(T), Val(32))

        adx, adxtail = Two_Diff(pa[1], pd[1])
        ady, adytail = Two_Diff(pa[2], pd[2])
        bdx, bdxtail = Two_Diff(pb[1], pd[1])
        bdy, bdytail = Two_Diff(pb[2], pd[2])
        cdx, cdxtail = Two_Diff(pc[1], pd[1])
        cdy, cdytail = Two_Diff(pc[2], pd[2])

        axby7, axby6, axby5, axby4, axby3, axby2, axby1, axby0 = Two_Two_Product(adx, adxtail, bdy, bdytail)
        axby = (axby0, axby1, axby2, axby3, axby4, axby5, axby6, axby7)
        negate = -ady
        negatetail = -adytail
        bxay7, bxay6, bxay5, bxay4, bxay3, bxay2, bxay1, bxay0 = Two_Two_Product(bdx, bdxtail, negate, negatetail)
        bxay = (bxay0, bxay1, bxay2, bxay3, bxay4, bxay5, bxay6, bxay7)
        bxcy7, bxcy6, bxcy5, bxcy4, bxcy3, bxcy2, bxcy1, bxcy0 = Two_Two_Product(bdx, bdxtail, cdy, cdytail)
        bxcy = (bxcy0, bxcy1, bxcy2, bxcy3, bxcy4, bxcy5, bxcy6, bxcy7)
        negate = -bdy
        negatetail = -bdytail
        cxby7, cxby6, cxby5, cxby4, cxby3, cxby2, cxby1, cxby0 = Two_Two_Product(cdx, cdxtail, negate, negatetail)
        cxby = (cxby0, cxby1, cxby2, cxby3, cxby4, cxby5, cxby6, cxby7)
        cxay7, cxay6, cxay5, cxay4, cxay3, cxay2, cxay1, cxay0 = Two_Two_Product(cdx, cdxtail, ady, adytail)
        cxay = (cxay0, cxay1, cxay2, cxay3, cxay4, cxay5, cxay6, cxay7)
        negate = -cdy
        negatetail = -cdytail
        axcy7, axcy6, axcy5, axcy4, axcy3, axcy2, axcy1, axcy0 = Two_Two_Product(adx, adxtail, negate, negatetail)
        axcy = (axcy0, axcy1, axcy2, axcy3, axcy4, axcy5, axcy6, axcy7)

        args = pa, adx, adxtail, ady, adytail, bdx, bdxtail, bdy, bdytail, cdx, cdxtail, cdy, cdytail, axby, bxay, bxcy, cxby, cxay, axcy, cache

        temp16, temp16len = fast_expansion_sum_zeroelim(8, bxcy, 8, cxby, h16)

        detx, xlen = scale_expansion_zeroelim(temp16len, temp16, adx, h32)
        @check_length _incircleslow args detxx, xxlen = scale_expansion_zeroelim(xlen, detx, adx, h32) # detxx, xxlen = scale_expansion_zeroelim(xlen, detx, adx, h64_1)
        detxt, xtlen = scale_expansion_zeroelim(temp16len, temp16, adxtail, h32)
        @check_length _incircleslow args detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, adx, h32) # detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, adx, h64_2)
        detxxt = @. T(2.0 * detxxt)
        @check_length _incircleslow args detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, adxtail, h32) # detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, adxtail, h64_3)
        @check_length _incircleslow args x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, h32) # x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, h128_1)
        @check_length _incircleslow args x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, h32) # x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, h192_1)

        dety, ylen = scale_expansion_zeroelim(temp16len, temp16, ady, h32)
        @check_length _incircleslow args detyy, yylen = scale_expansion_zeroelim(ylen, dety, ady, h32) # detyy, yylen = scale_expansion_zeroelim(ylen, dety, ady, h64_4)
        detyt, ytlen = scale_expansion_zeroelim(temp16len, temp16, adytail, h32)
        @check_length _incircleslow args detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, ady, h32) # detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, ady, h64_5)
        detyyt = @. T(2.0 * detyyt)
        @check_length _incircleslow args detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, adytail, h32) # detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, adytail, h64_6)
        @check_length _incircleslow args y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, h32) # y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, h128_2)
        @check_length _incircleslow args y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, h32) # y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, h192_2)

        @check_length _incircleslow args adet, alen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h32) # adet, alen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h384_1)

        temp16, temp16len = fast_expansion_sum_zeroelim(8, cxay, 8, axcy, temp16)

        detx, xlen = scale_expansion_zeroelim(temp16len, temp16, bdx, detx)
        @check_length _incircleslow args detxx, xxlen = scale_expansion_zeroelim(xlen, detx, bdx, detxx)
        detxt, xtlen = scale_expansion_zeroelim(temp16len, temp16, bdxtail, detxt)
        @check_length _incircleslow args detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, bdx, detxxt)
        detxxt = @. T(2.0 * detxxt)
        @check_length _incircleslow args detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, bdxtail, detxtxt)
        @check_length _incircleslow args x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        @check_length _incircleslow args x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)

        dety, ylen = scale_expansion_zeroelim(temp16len, temp16, bdy, dety)
        @check_length _incircleslow args detyy, yylen = scale_expansion_zeroelim(ylen, dety, bdy, detyy)
        detyt, ytlen = scale_expansion_zeroelim(temp16len, temp16, bdytail, detyt)
        @check_length _incircleslow args detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, bdy, detyyt)
        detyyt = @. T(2.0 * detyyt)
        @check_length _incircleslow args detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, bdytail, detytyt)
        @check_length _incircleslow args y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        @check_length _incircleslow args y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)

        @check_length _incircleslow args bdet, blen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h32) # bdet, blen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h384_2)

        temp16, temp16len = fast_expansion_sum_zeroelim(8, axby, 8, bxay, temp16)

        detx, xlen = scale_expansion_zeroelim(temp16len, temp16, cdx, detx)
        @check_length _incircleslow args detxx, xxlen = scale_expansion_zeroelim(xlen, detx, cdx, detxx)
        @check_length _incircleslow args detxt, xtlen = scale_expansion_zeroelim(temp16len, temp16, cdxtail, detxt)
        @check_length _incircleslow args detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, cdx, detxxt)

        detxxt = @. T(2.0 * detxxt)
        @check_length _incircleslow args detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, cdxtail, detxtxt)
        @check_length _incircleslow args x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        @check_length _incircleslow args x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)

        dety, ylen = scale_expansion_zeroelim(temp16len, temp16, cdy, dety)
        @check_length _incircleslow args detyy, yylen = scale_expansion_zeroelim(ylen, dety, cdy, detyy)
        @check_length _incircleslow args detyt, ytlen = scale_expansion_zeroelim(temp16len, temp16, cdytail, detyt)
        @check_length _incircleslow args detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, cdy, detyyt)
        detyyt = @. T(2.0 * detyyt)
        @check_length _incircleslow args detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, cdytail, detytyt)
        @check_length _incircleslow args y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        @check_length _incircleslow args y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)

        @check_length _incircleslow args cdet, clen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h32) # cdet, clen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h384_3)

        @check_length _incircleslow args abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h32) # abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h768)
        @check_length _incircleslow args deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h32) # deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h1152_1)

        return deter[deterlen]
    end
end
function _incircleslow(pa, adx, adxtail, ady, adytail, bdx, bdxtail, bdy, bdytail, cdx, cdxtail, cdy, cdytail, axby, bxay, bxcy, cxby, cxay, axcy, cache)
    @inbounds begin
        T = eltype(pa)
        h16 = ntuple(_ -> zero(T), Val(16))
        h32 = ntuple(_ -> zero(T), Val(32))
        h64_1, h64_2, h64_3, h64_4, h64_5, h64_6, h128_1, h128_2, h192_1, h192_2, h384_1, h384_2, h384_3, h768, h1152_1 = incircleslow_cache(T, cache)

        temp16, temp16len = fast_expansion_sum_zeroelim(8, bxcy, 8, cxby, h16)

        detx, xlen = scale_expansion_zeroelim(temp16len, temp16, adx, h32)
        detxx, xxlen = scale_expansion_zeroelim(xlen, detx, adx, h64_1)
        detxt, xtlen = scale_expansion_zeroelim(temp16len, temp16, adxtail, h32)
        detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, adx, h64_2)
        for i in 1:xxtlen
            detxxt[i] *= 2.0
        end
        detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, adxtail, h64_3)
        x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, h128_1)
        x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, h192_1)

        dety, ylen = scale_expansion_zeroelim(temp16len, temp16, ady, h32)
        detyy, yylen = scale_expansion_zeroelim(ylen, dety, ady, h64_4)
        detyt, ytlen = scale_expansion_zeroelim(temp16len, temp16, adytail, h32)
        detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, ady, h64_5)
        for i in 1:yytlen
            detyyt[i] *= 2.0
        end
        detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, adytail, h64_6)
        y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, h128_2)
        y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, h192_2)

        adet, alen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h384_1)

        temp16, temp16len = fast_expansion_sum_zeroelim(8, cxay, 8, axcy, temp16)

        detx, xlen = scale_expansion_zeroelim(temp16len, temp16, bdx, detx)
        detxx, xxlen = scale_expansion_zeroelim(xlen, detx, bdx, detxx)
        detxt, xtlen = scale_expansion_zeroelim(temp16len, temp16, bdxtail, detxt)
        detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, bdx, detxxt)
        for i in 1:xxtlen
            detxxt[i] *= 2.0
        end
        detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, bdxtail, detxtxt)
        x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)

        dety, ylen = scale_expansion_zeroelim(temp16len, temp16, bdy, dety)
        detyy, yylen = scale_expansion_zeroelim(ylen, dety, bdy, detyy)
        detyt, ytlen = scale_expansion_zeroelim(temp16len, temp16, bdytail, detyt)
        detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, bdy, detyyt)
        for i in 1:yytlen
            detyyt[i] *= 2.0
        end
        detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, bdytail, detytyt)
        y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)

        bdet, blen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h384_2)

        temp16, temp16len = fast_expansion_sum_zeroelim(8, axby, 8, bxay, temp16)

        detx, xlen = scale_expansion_zeroelim(temp16len, temp16, cdx, detx)
        detxx, xxlen = scale_expansion_zeroelim(xlen, detx, cdx, detxx)
        detxt, xtlen = scale_expansion_zeroelim(temp16len, temp16, cdxtail, detxt)
        detxxt, xxtlen = scale_expansion_zeroelim(xtlen, detxt, cdx, detxxt)
        for i in 1:xxtlen
            detxxt[i] *= 2.0
        end
        detxtxt, xtxtlen = scale_expansion_zeroelim(xtlen, detxt, cdxtail, detxtxt)
        x1, x1len = fast_expansion_sum_zeroelim(xxlen, detxx, xxtlen, detxxt, x1)
        x2, x2len = fast_expansion_sum_zeroelim(x1len, x1, xtxtlen, detxtxt, x2)

        dety, ylen = scale_expansion_zeroelim(temp16len, temp16, cdy, dety)
        detyy, yylen = scale_expansion_zeroelim(ylen, dety, cdy, detyy)
        detyt, ytlen = scale_expansion_zeroelim(temp16len, temp16, cdytail, detyt)
        detyyt, yytlen = scale_expansion_zeroelim(ytlen, detyt, cdy, detyyt)
        for i in 1:yytlen
            detyyt[i] *= 2.0
        end
        detytyt, ytytlen = scale_expansion_zeroelim(ytlen, detyt, cdytail, detytyt)
        y1, y1len = fast_expansion_sum_zeroelim(yylen, detyy, yytlen, detyyt, y1)
        y2, y2len = fast_expansion_sum_zeroelim(y1len, y1, ytytlen, detytyt, y2)

        cdet, clen = fast_expansion_sum_zeroelim(x2len, x2, y2len, y2, h384_3)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h768)
        deter, deterlen = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h1152_1)

        return deter[deterlen]
    end
end

function incircleadapt(pa, pb, pc, pd, permanent, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h16 = ntuple(_ -> zero(T), Val(16))
        h32 = ntuple(_ -> zero(T), Val(32))

        adx = pa[1] - pd[1]
        bdx = pb[1] - pd[1]
        cdx = pc[1] - pd[1]
        ady = pa[2] - pd[2]
        bdy = pb[2] - pd[2]
        cdy = pc[2] - pd[2]

        bdxcdy1, bdxcdy0 = Two_Product(bdx, cdy)
        cdxbdy1, cdxbdy0 = Two_Product(cdx, bdy)
        bc3, bc2, bc1, bc0 = Two_Two_Diff(bdxcdy1, bdxcdy0, cdxbdy1, cdxbdy0)
        bc = (bc0, bc1, bc2, bc3)
        axbc, axbclen = scale_expansion_zeroelim(4, bc, adx, h8)
        axxbc, axxbclen = scale_expansion_zeroelim(axbclen, axbc, adx, h16)
        aybc, aybclen = scale_expansion_zeroelim(4, bc, ady, h8)
        ayybc, ayybclen = scale_expansion_zeroelim(aybclen, aybc, ady, h16)
        adet, alen = fast_expansion_sum_zeroelim(axxbclen, axxbc, ayybclen, ayybc, h32)

        cdxady1, cdxady0 = Two_Product(cdx, ady)
        adxcdy1, adxcdy0 = Two_Product(adx, cdy)
        ca3, ca2, ca1, ca0 = Two_Two_Diff(cdxady1, cdxady0, adxcdy1, adxcdy0)
        ca = (ca0, ca1, ca2, ca3)
        bxca, bxcalen = scale_expansion_zeroelim(4, ca, bdx, h8)
        bxxca, bxxcalen = scale_expansion_zeroelim(bxcalen, bxca, bdx, h16)
        byca, bycalen = scale_expansion_zeroelim(4, ca, bdy, h8)
        byyca, byycalen = scale_expansion_zeroelim(bycalen, byca, bdy, h16)
        bdet, blen = fast_expansion_sum_zeroelim(bxxcalen, bxxca, byycalen, byyca, h32)

        adxbdy1, adxbdy0 = Two_Product(adx, bdy)
        bdxady1, bdxady0 = Two_Product(bdx, ady)
        ab3, ab2, ab1, ab0 = Two_Two_Diff(adxbdy1, adxbdy0, bdxady1, bdxady0)
        ab = (ab0, ab1, ab2, ab3)
        cxab, cxablen = scale_expansion_zeroelim(4, ab, cdx, h8)
        cxxab, cxxablen = scale_expansion_zeroelim(cxablen, cxab, cdx, h16)
        cyab, cyablen = scale_expansion_zeroelim(4, ab, cdy, h8)
        cyyab, cyyablen = scale_expansion_zeroelim(cyablen, cyab, cdy, h16)
        cdet, clen = fast_expansion_sum_zeroelim(cxxablen, cxxab, cyyablen, cyyab, h32)

        args = pa, pb, pc, pd, alen, adet, blen, bdet, clen, cdet, permanent, adx, bdx, cdx, ady, bdy, cdy, bc, ca, ab, cache

        @check_length _incircleadapt args abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h32) # abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h64_1)
        @check_length _incircleadapt args fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h32) # fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h1152_1)

        det = estimate(finlength, fin1)
        errbound = iccerrboundB(T) * permanent
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        adxtail = Two_Diff_Tail(pa[1], pd[1], adx)
        adytail = Two_Diff_Tail(pa[2], pd[2], ady)
        bdxtail = Two_Diff_Tail(pb[1], pd[1], bdx)
        bdytail = Two_Diff_Tail(pb[2], pd[2], bdy)
        cdxtail = Two_Diff_Tail(pc[1], pd[1], cdx)
        cdytail = Two_Diff_Tail(pc[2], pd[2], cdy)

        if iszero(adxtail) && iszero(bdxtail) && iszero(cdxtail) &&
           iszero(adytail) && iszero(bdytail) && iszero(cdytail)
            return det
        end

        errbound = iccerrboundC(T) * permanent + resulterrbound(T) * Absolute(det)
        detadd = ((adx * adx + ady * ady) * ((bdx * cdytail + cdy * bdxtail) -
                                             (bdy * cdxtail + cdx * bdytail)) +
                  2.0 * (adx * adxtail + ady * adytail) * (bdx * cdy - bdy * cdx)) +
                 ((bdx * bdx + bdy * bdy) * ((cdx * adytail + ady * cdxtail) -
                                             (cdy * adxtail + adx * cdytail)) +
                  2.0 * (bdx * bdxtail + bdy * bdytail) * (cdx * ady - cdy * adx)) +
                 ((cdx * cdx + cdy * cdy) * ((adx * bdytail + bdy * adxtail) -
                                             (ady * bdxtail + bdx * adytail)) +
                  2.0 * (cdx * cdxtail + cdy * cdytail) * (adx * bdy - ady * bdx))
        det = T(det + detadd) # Had to change this to match how C handles the 2.0 multiplication with Float32
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        finnow = fin1
        finother = h32 # finother = h1152_2

        if !iszero(bdxtail) || !iszero(bdytail) || !iszero(cdxtail) || !iszero(cdytail)
            adxadx1, adxadx0 = Square(adx)
            adyady1, adyady0 = Square(ady)
            aa3, aa2, aa1, aa0 = Two_Two_Sum(adxadx1, adxadx0, adyady1, adyady0)
            aa = (aa0, aa1, aa2, aa3)
        end
        if !iszero(cdxtail) || !iszero(cdytail) || !iszero(adxtail) || !iszero(adytail)
            bdxbdx1, bdxbdx0 = Square(bdx)
            bdybdy1, bdybdy0 = Square(bdy)
            bb3, bb2, bb1, bb0 = Two_Two_Sum(bdxbdx1, bdxbdx0, bdybdy1, bdybdy0)
            bb = (bb0, bb1, bb2, bb3)
        end
        if !iszero(adxtail) || !iszero(adytail) || !iszero(bdxtail) || !iszero(bdytail)
            cdxcdx1, cdxcdx0 = Square(cdx)
            cdycdy1, cdycdy0 = Square(cdy)
            cc3, cc2, cc1, cc0 = Two_Two_Sum(cdxcdx1, cdxcdx0, cdycdy1, cdycdy0)
            cc = (cc0, cc1, cc2, cc3)
        end

        if !iszero(adxtail)
            axtbc, axtbclen = scale_expansion_zeroelim(4, bc, adxtail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(axtbclen, axtbc, 2adx, h16)

            axtcc, axtcclen = scale_expansion_zeroelim(4, cc, adxtail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(axtcclen, axtcc, bdy, h16)

            axtbb, axtbblen = scale_expansion_zeroelim(4, bb, adxtail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(axtbblen, axtbb, -cdy, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(adytail)
            aytbc, aytbclen = scale_expansion_zeroelim(4, bc, adytail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(aytbclen, aytbc, 2 * ady, h16)

            aytbb, aytbblen = scale_expansion_zeroelim(4, bb, adytail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(aytbblen, aytbb, cdx, h16)

            aytcc, aytcclen = scale_expansion_zeroelim(4, cc, adytail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(aytcclen, aytcc, -bdx, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(bdxtail)
            bxtca, bxtcalen = scale_expansion_zeroelim(4, ca, bdxtail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(bxtcalen, bxtca, 2 * bdx, h16)

            bxtaa, bxtaalen = scale_expansion_zeroelim(4, aa, bdxtail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(bxtaalen, bxtaa, cdy, h16)

            bxtcc, bxtcclen = scale_expansion_zeroelim(4, cc, bdxtail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(bxtcclen, bxtcc, -ady, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(bdytail)
            bytca, bytcalen = scale_expansion_zeroelim(4, ca, bdytail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(bytcalen, bytca, 2 * bdy, h16)

            bytcc, bytcclen = scale_expansion_zeroelim(4, cc, bdytail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(bytcclen, bytcc, adx, h16)

            bytaa, bytaalen = scale_expansion_zeroelim(4, aa, bdytail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(bytaalen, bytaa, -cdx, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(cdxtail)
            cxtab, cxtablen = scale_expansion_zeroelim(4, ab, cdxtail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(cxtablen, cxtab, 2 * cdx, h16)

            cxtbb, cxtbblen = scale_expansion_zeroelim(4, bb, cdxtail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(cxtbblen, cxtbb, ady, h16)

            cxtaa, cxtaalen = scale_expansion_zeroelim(4, aa, cdxtail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(cxtaalen, cxtaa, -bdy, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(cdytail)
            cytab, cytablen = scale_expansion_zeroelim(4, ab, cdytail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(cytablen, cytab, 2 * cdy, h16)

            cytaa, cytaalen = scale_expansion_zeroelim(4, aa, cdytail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(cytaalen, cytaa, bdx, h16)

            cytbb, cytbblen = scale_expansion_zeroelim(4, bb, cdytail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(cytbblen, cytbb, -adx, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end

        if !iszero(adxtail) || !iszero(adytail)
            if !iszero(bdxtail) || !iszero(bdytail) || !iszero(cdxtail) || !iszero(cdytail)
                ti1, ti0 = Two_Product(bdxtail, cdy)
                tj1, tj0 = Two_Product(bdx, cdytail)
                u3, u2, u1, u0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                u = (u0, u1, u2, u3)
                negate = -bdy
                ti1, ti0 = Two_Product(cdxtail, negate)
                negate = -bdytail
                tj1, tj0 = Two_Product(cdx, negate)
                v3, v2, v1, v0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                v = (v0, v1, v2, v3)
                bct, bctlen = fast_expansion_sum_zeroelim(4, u, 4, v, h8)

                ti1, ti0 = Two_Product(bdxtail, cdytail)
                tj1, tj0 = Two_Product(cdxtail, bdytail)
                bctt3, bctt2, bctt1, bctt0 = Two_Two_Diff(ti1, ti0, tj1, tj0)
                bctt = (bctt0, bctt1, bctt2, bctt3)
                bcttlen = 4
            else
                bct = (zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T))
                bctlen = 1
                bctt = (zero(T), zero(T), zero(T), zero(T))
                bcttlen = 1
            end

            if !iszero(adxtail)
                temp16a, temp16alen = scale_expansion_zeroelim(axtbclen, axtbc, adxtail, h16)
                axtbct, axtbctlen = scale_expansion_zeroelim(bctlen, bct, adxtail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(axtbctlen, axtbct, 2adx, h32)
                @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow
                if !iszero(bdytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, cc, adxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, bdytail, h16)
                    @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end
                if !iszero(cdytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, bb, -adxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, cdytail, h16)
                    @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end

                temp32a, temp32alen = scale_expansion_zeroelim(axtbctlen, axtbct, adxtail, h32)
                axtbctt, axtbcttlen = scale_expansion_zeroelim(bcttlen, bctt, adxtail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(axtbcttlen, axtbctt, 2adx, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(axtbcttlen, axtbctt, adxtail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                @check_length _incircleadapt args temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
            if !iszero(adytail)
                temp16a, temp16alen = scale_expansion_zeroelim(aytbclen, aytbc, adytail, h16)
                aytbct, aytbctlen = scale_expansion_zeroelim(bctlen, bct, adytail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(aytbctlen, aytbct, 2ady, h32)
                @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow

                temp32a, temp32alen = scale_expansion_zeroelim(aytbctlen, aytbct, adytail, h32)
                aytbctt, aytbcttlen = scale_expansion_zeroelim(bcttlen, bctt, adytail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(aytbcttlen, aytbctt, 2ady, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(aytbcttlen, aytbctt, adytail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                @check_length _incircleadapt args temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
        end

        if !iszero(bdxtail) || !iszero(bdytail)
            if !iszero(cdxtail) || !iszero(cdytail) || !iszero(adxtail) || !iszero(adytail)
                ti1, ti0 = Two_Product(cdxtail, ady)
                tj1, tj0 = Two_Product(cdx, adytail)
                u3, u2, u1, u0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                u = (u0, u1, u2, u3)
                negate = -cdy
                ti1, ti0 = Two_Product(adxtail, negate)
                negate = -cdytail
                tj1, tj0 = Two_Product(adx, negate)
                v3, v2, v1, v0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                v = (v0, v1, v2, v3)
                cat, catlen = fast_expansion_sum_zeroelim(4, u, 4, v, h8)

                ti1, ti0 = Two_Product(cdxtail, adytail)
                tj1, tj0 = Two_Product(adxtail, cdytail)
                catt3, catt2, catt1, catt0 = Two_Two_Diff(ti1, ti0, tj1, tj0)
                catt = (catt0, catt1, catt2, catt3)
                cattlen = 4
            else
                cat = (zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T))
                catlen = 1
                catt = (zero(T), zero(T), zero(T), zero(T))
                cattlen = 1
            end

            if !iszero(bdxtail)
                temp16a, temp16alen = scale_expansion_zeroelim(bxtcalen, bxtca, bdxtail, h16)
                bxtcat, bxtcatlen = scale_expansion_zeroelim(catlen, cat, bdxtail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(bxtcatlen, bxtcat, 2bdx, h32)
                @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow
                if !iszero(cdytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, aa, bdxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, cdytail, h16)
                    @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end
                if !iszero(adytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, cc, -bdxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, adytail, h16)
                    @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end

                temp32a, temp32alen = scale_expansion_zeroelim(bxtcatlen, bxtcat, bdxtail, h32)
                bxtcatt, bxtcattlen = scale_expansion_zeroelim(cattlen, catt, bdxtail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(bxtcattlen, bxtcatt, 2bdx, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(bxtcattlen, bxtcatt, bdxtail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                @check_length _incircleadapt args temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
            if !iszero(bdytail)
                temp16a, temp16alen = scale_expansion_zeroelim(bytcalen, bytca, bdytail, h16)
                bytcat, bytcatlen = scale_expansion_zeroelim(catlen, cat, bdytail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(bytcatlen, bytcat, 2bdy, h32)
                @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow

                temp32a, temp32alen = scale_expansion_zeroelim(bytcatlen, bytcat, bdytail, h32)
                bytcatt, bytcattlen = scale_expansion_zeroelim(cattlen, catt, bdytail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(bytcattlen, bytcatt, 2bdy, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(bytcattlen, bytcatt, bdytail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                @check_length _incircleadapt args temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
        end

        if !iszero(cdxtail) || !iszero(cdytail)
            if !iszero(adxtail) || !iszero(adytail) || !iszero(bdxtail) || !iszero(bdytail)
                ti1, ti0 = Two_Product(adxtail, bdy)
                tj1, tj0 = Two_Product(adx, bdytail)
                u3, u2, u1, u0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                u = (u0, u1, u2, u3)
                negate = -ady
                ti1, ti0 = Two_Product(bdxtail, negate)
                negate = -adytail
                tj1, tj0 = Two_Product(bdx, negate)
                v3, v2, v1, v0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                v = (v0, v1, v2, v3)
                abt, abtlen = fast_expansion_sum_zeroelim(4, u, 4, v, h8)

                ti1, ti0 = Two_Product(adxtail, bdytail)
                tj1, tj0 = Two_Product(bdxtail, adytail)
                abtt3, abtt2, abtt1, abtt0 = Two_Two_Diff(ti1, ti0, tj1, tj0)
                abtt = (abtt0, abtt1, abtt2, abtt3)
                abttlen = 4
            else
                abt = (zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T))
                abtlen = 1
                abtt = (zero(T), zero(T), zero(T), zero(T))
                abttlen = 1
            end

            if !iszero(cdxtail)
                temp16a, temp16alen = scale_expansion_zeroelim(cxtablen, cxtab, cdxtail, h16)
                cxtabt, cxtabtlen = scale_expansion_zeroelim(abtlen, abt, cdxtail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(cxtabtlen, cxtabt, 2cdx, h32)
                @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow
                if !iszero(adytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, bb, cdxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, adytail, h16)
                    @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end
                if !iszero(bdytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, aa, -cdxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, bdytail, h16)
                    @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end

                temp32a, temp32alen = scale_expansion_zeroelim(cxtabtlen, cxtabt, cdxtail, h32)
                cxtabtt, cxtabttlen = scale_expansion_zeroelim(abttlen, abtt, cdxtail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(cxtabttlen, cxtabtt, 2cdx, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(cxtabttlen, cxtabtt, cdxtail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                @check_length _incircleadapt args temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
            if !iszero(cdytail)
                temp16a, temp16alen = scale_expansion_zeroelim(cytablen, cytab, cdytail, h16)
                cytabt, cytabtlen = scale_expansion_zeroelim(abtlen, abt, cdytail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(cytabtlen, cytabt, 2cdy, h32)
                @check_length _incircleadapt args temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h32) # temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow

                temp32a, temp32alen = scale_expansion_zeroelim(cytabtlen, cytabt, cdytail, h32)
                cytabtt, cytabttlen = scale_expansion_zeroelim(abttlen, abtt, cdytail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(cytabttlen, cytabtt, 2cdy, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(cytabttlen, cytabtt, cdytail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                @check_length _incircleadapt args temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h32) # temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                @check_length _incircleadapt args finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
        end
        return finnow[finlength]
    end
end
function _incircleadapt(pa, pb, pc, pd, alen, adet, blen, bdet, clen, cdet, permanent, adx, bdx, cdx, ady, bdy, cdy, bc, ca, ab, cache)
    @inbounds begin
        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h16 = ntuple(_ -> zero(T), Val(16))
        h32 = ntuple(_ -> zero(T), Val(32))
        h48_1, h64_1, h1152_1, h1152_2 = incircleadapt_cache(T, cache)

        abdet, ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, h64_1)
        fin1, finlength = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, h1152_1)

        det = estimate(finlength, fin1)
        errbound = iccerrboundB(T) * permanent
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        adxtail = Two_Diff_Tail(pa[1], pd[1], adx)
        adytail = Two_Diff_Tail(pa[2], pd[2], ady)
        bdxtail = Two_Diff_Tail(pb[1], pd[1], bdx)
        bdytail = Two_Diff_Tail(pb[2], pd[2], bdy)
        cdxtail = Two_Diff_Tail(pc[1], pd[1], cdx)
        cdytail = Two_Diff_Tail(pc[2], pd[2], cdy)

        if iszero(adxtail) && iszero(bdxtail) && iszero(cdxtail) &&
           iszero(adytail) && iszero(bdytail) && iszero(cdytail)
            return det
        end

        errbound = iccerrboundC(T) * permanent + resulterrbound(T) * Absolute(det)
        detadd = ((adx * adx + ady * ady) * ((bdx * cdytail + cdy * bdxtail) -
                                             (bdy * cdxtail + cdx * bdytail)) +
                  2.0 * (adx * adxtail + ady * adytail) * (bdx * cdy - bdy * cdx)) +
                 ((bdx * bdx + bdy * bdy) * ((cdx * adytail + ady * cdxtail) -
                                             (cdy * adxtail + adx * cdytail)) +
                  2.0 * (bdx * bdxtail + bdy * bdytail) * (cdx * ady - cdy * adx)) +
                 ((cdx * cdx + cdy * cdy) * ((adx * bdytail + bdy * adxtail) -
                                             (ady * bdxtail + bdx * adytail)) +
                  2.0 * (cdx * cdxtail + cdy * cdytail) * (adx * bdy - ady * bdx))
        det = T(det + detadd) # Had to change this to match how C handles the 2.0 multiplication with Float32
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        finnow = fin1
        finother = h1152_2

        if !iszero(bdxtail) || !iszero(bdytail) || !iszero(cdxtail) || !iszero(cdytail)
            adxadx1, adxadx0 = Square(adx)
            adyady1, adyady0 = Square(ady)
            aa3, aa2, aa1, aa0 = Two_Two_Sum(adxadx1, adxadx0, adyady1, adyady0)
            aa = (aa0, aa1, aa2, aa3)
        end
        if !iszero(cdxtail) || !iszero(cdytail) || !iszero(adxtail) || !iszero(adytail)
            bdxbdx1, bdxbdx0 = Square(bdx)
            bdybdy1, bdybdy0 = Square(bdy)
            bb3, bb2, bb1, bb0 = Two_Two_Sum(bdxbdx1, bdxbdx0, bdybdy1, bdybdy0)
            bb = (bb0, bb1, bb2, bb3)
        end
        if !iszero(adxtail) || !iszero(adytail) || !iszero(bdxtail) || !iszero(bdytail)
            cdxcdx1, cdxcdx0 = Square(cdx)
            cdycdy1, cdycdy0 = Square(cdy)
            cc3, cc2, cc1, cc0 = Two_Two_Sum(cdxcdx1, cdxcdx0, cdycdy1, cdycdy0)
            cc = (cc0, cc1, cc2, cc3)
        end

        if !iszero(adxtail)
            axtbc, axtbclen = scale_expansion_zeroelim(4, bc, adxtail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(axtbclen, axtbc, 2adx, h16)

            axtcc, axtcclen = scale_expansion_zeroelim(4, cc, adxtail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(axtcclen, axtcc, bdy, h16)

            axtbb, axtbblen = scale_expansion_zeroelim(4, bb, adxtail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(axtbblen, axtbb, -cdy, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(adytail)
            aytbc, aytbclen = scale_expansion_zeroelim(4, bc, adytail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(aytbclen, aytbc, 2 * ady, h16)

            aytbb, aytbblen = scale_expansion_zeroelim(4, bb, adytail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(aytbblen, aytbb, cdx, h16)

            aytcc, aytcclen = scale_expansion_zeroelim(4, cc, adytail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(aytcclen, aytcc, -bdx, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(bdxtail)
            bxtca, bxtcalen = scale_expansion_zeroelim(4, ca, bdxtail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(bxtcalen, bxtca, 2 * bdx, h16)

            bxtaa, bxtaalen = scale_expansion_zeroelim(4, aa, bdxtail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(bxtaalen, bxtaa, cdy, h16)

            bxtcc, bxtcclen = scale_expansion_zeroelim(4, cc, bdxtail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(bxtcclen, bxtcc, -ady, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(bdytail)
            bytca, bytcalen = scale_expansion_zeroelim(4, ca, bdytail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(bytcalen, bytca, 2 * bdy, h16)

            bytcc, bytcclen = scale_expansion_zeroelim(4, cc, bdytail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(bytcclen, bytcc, adx, h16)

            bytaa, bytaalen = scale_expansion_zeroelim(4, aa, bdytail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(bytaalen, bytaa, -cdx, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(cdxtail)
            cxtab, cxtablen = scale_expansion_zeroelim(4, ab, cdxtail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(cxtablen, cxtab, 2 * cdx, h16)

            cxtbb, cxtbblen = scale_expansion_zeroelim(4, bb, cdxtail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(cxtbblen, cxtbb, ady, h16)

            cxtaa, cxtaalen = scale_expansion_zeroelim(4, aa, cdxtail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(cxtaalen, cxtaa, -bdy, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end
        if !iszero(cdytail)
            cytab, cytablen = scale_expansion_zeroelim(4, ab, cdytail, h8)
            temp16a, temp16alen = scale_expansion_zeroelim(cytablen, cytab, 2 * cdy, h16)

            cytaa, cytaalen = scale_expansion_zeroelim(4, aa, cdytail, h8)
            temp16b, temp16blen = scale_expansion_zeroelim(cytaalen, cytaa, bdx, h16)

            cytbb, cytbblen = scale_expansion_zeroelim(4, bb, cdytail, h8)
            temp16c, temp16clen = scale_expansion_zeroelim(cytbblen, cytbb, -adx, h16)

            temp32a, temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
            temp48, temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, h48_1)
            finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
            finnow, finother = finother, finnow
        end

        if !iszero(adxtail) || !iszero(adytail)
            if !iszero(bdxtail) || !iszero(bdytail) || !iszero(cdxtail) || !iszero(cdytail)
                ti1, ti0 = Two_Product(bdxtail, cdy)
                tj1, tj0 = Two_Product(bdx, cdytail)
                u3, u2, u1, u0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                u = (u0, u1, u2, u3)
                negate = -bdy
                ti1, ti0 = Two_Product(cdxtail, negate)
                negate = -bdytail
                tj1, tj0 = Two_Product(cdx, negate)
                v3, v2, v1, v0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                v = (v0, v1, v2, v3)
                bct, bctlen = fast_expansion_sum_zeroelim(4, u, 4, v, h8)

                ti1, ti0 = Two_Product(bdxtail, cdytail)
                tj1, tj0 = Two_Product(cdxtail, bdytail)
                bctt3, bctt2, bctt1, bctt0 = Two_Two_Diff(ti1, ti0, tj1, tj0)
                bctt = (bctt0, bctt1, bctt2, bctt3)
                bcttlen = 4
            else
                bct = (zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T))
                bctlen = 1
                bctt = (zero(T), zero(T), zero(T), zero(T))
                bcttlen = 1
            end

            if !iszero(adxtail)
                temp16a, temp16alen = scale_expansion_zeroelim(axtbclen, axtbc, adxtail, h16)
                axtbct, axtbctlen = scale_expansion_zeroelim(bctlen, bct, adxtail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(axtbctlen, axtbct, 2adx, h32)
                temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow
                if !iszero(bdytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, cc, adxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, bdytail, h16)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end
                if !iszero(cdytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, bb, -adxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, cdytail, h16)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end

                temp32a, temp32alen = scale_expansion_zeroelim(axtbctlen, axtbct, adxtail, h32)
                axtbctt, axtbcttlen = scale_expansion_zeroelim(bcttlen, bctt, adxtail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(axtbcttlen, axtbctt, 2adx, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(axtbcttlen, axtbctt, adxtail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
            if !iszero(adytail)
                temp16a, temp16alen = scale_expansion_zeroelim(aytbclen, aytbc, adytail, h16)
                aytbct, aytbctlen = scale_expansion_zeroelim(bctlen, bct, adytail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(aytbctlen, aytbct, 2ady, h32)
                temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow

                temp32a, temp32alen = scale_expansion_zeroelim(aytbctlen, aytbct, adytail, h32)
                aytbctt, aytbcttlen = scale_expansion_zeroelim(bcttlen, bctt, adytail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(aytbcttlen, aytbctt, 2ady, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(aytbcttlen, aytbctt, adytail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
        end

        if !iszero(bdxtail) || !iszero(bdytail)
            if !iszero(cdxtail) || !iszero(cdytail) || !iszero(adxtail) || !iszero(adytail)
                ti1, ti0 = Two_Product(cdxtail, ady)
                tj1, tj0 = Two_Product(cdx, adytail)
                u3, u2, u1, u0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                u = (u0, u1, u2, u3)
                negate = -cdy
                ti1, ti0 = Two_Product(adxtail, negate)
                negate = -cdytail
                tj1, tj0 = Two_Product(adx, negate)
                v3, v2, v1, v0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                v = (v0, v1, v2, v3)
                cat, catlen = fast_expansion_sum_zeroelim(4, u, 4, v, h8)

                ti1, ti0 = Two_Product(cdxtail, adytail)
                tj1, tj0 = Two_Product(adxtail, cdytail)
                catt3, catt2, catt1, catt0 = Two_Two_Diff(ti1, ti0, tj1, tj0)
                catt = (catt0, catt1, catt2, catt3)
                cattlen = 4
            else
                cat = (zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T))
                catlen = 1
                catt = (zero(T), zero(T), zero(T), zero(T))
                cattlen = 1
            end 

            if !iszero(bdxtail)
                temp16a, temp16alen = scale_expansion_zeroelim(bxtcalen, bxtca, bdxtail, h16)
                bxtcat, bxtcatlen = scale_expansion_zeroelim(catlen, cat, bdxtail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(bxtcatlen, bxtcat, 2bdx, h32)
                temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow
                if !iszero(cdytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, aa, bdxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, cdytail, h16)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end
                if !iszero(adytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, cc, -bdxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, adytail, h16)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end

                temp32a, temp32alen = scale_expansion_zeroelim(bxtcatlen, bxtcat, bdxtail, h32)
                bxtcatt, bxtcattlen = scale_expansion_zeroelim(cattlen, catt, bdxtail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(bxtcattlen, bxtcatt, 2bdx, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(bxtcattlen, bxtcatt, bdxtail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
            if !iszero(bdytail)
                temp16a, temp16alen = scale_expansion_zeroelim(bytcalen, bytca, bdytail, h16)
                bytcat, bytcatlen = scale_expansion_zeroelim(catlen, cat, bdytail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(bytcatlen, bytcat, 2bdy, h32)
                temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow

                temp32a, temp32alen = scale_expansion_zeroelim(bytcatlen, bytcat, bdytail, h32)
                bytcatt, bytcattlen = scale_expansion_zeroelim(cattlen, catt, bdytail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(bytcattlen, bytcatt, 2bdy, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(bytcattlen, bytcatt, bdytail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
        end

        if !iszero(cdxtail) || !iszero(cdytail)
            if !iszero(adxtail) || !iszero(adytail) || !iszero(bdxtail) || !iszero(bdytail)
                ti1, ti0 = Two_Product(adxtail, bdy)
                tj1, tj0 = Two_Product(adx, bdytail)
                u3, u2, u1, u0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                u = (u0, u1, u2, u3)
                negate = -ady
                ti1, ti0 = Two_Product(bdxtail, negate)
                negate = -adytail
                tj1, tj0 = Two_Product(bdx, negate)
                v3, v2, v1, v0 = Two_Two_Sum(ti1, ti0, tj1, tj0)
                v = (v0, v1, v2, v3)
                abt, abtlen = fast_expansion_sum_zeroelim(4, u, 4, v, h8)

                ti1, ti0 = Two_Product(adxtail, bdytail)
                tj1, tj0 = Two_Product(bdxtail, adytail)
                abtt3, abtt2, abtt1, abtt0 = Two_Two_Diff(ti1, ti0, tj1, tj0)
                abtt = (abtt0, abtt1, abtt2, abtt3)
                abttlen = 4
            else
                abt = (zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T), zero(T))
                abtlen = 1
                abtt = (zero(T), zero(T), zero(T), zero(T))
                abttlen = 1
            end

            if !iszero(cdxtail)
                temp16a, temp16alen = scale_expansion_zeroelim(cxtablen, cxtab, cdxtail, h16)
                cxtabt, cxtabtlen = scale_expansion_zeroelim(abtlen, abt, cdxtail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(cxtabtlen, cxtabt, 2cdx, h32)
                temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow
                if !iszero(adytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, bb, cdxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, adytail, h16)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end
                if !iszero(bdytail)
                    temp8, temp8len = scale_expansion_zeroelim(4, aa, -cdxtail, h8)
                    temp16a, temp16alen = scale_expansion_zeroelim(temp8len, temp8, bdytail, h16)
                    finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother)
                    finnow, finother = finother, finnow
                end

                temp32a, temp32alen = scale_expansion_zeroelim(cxtabtlen, cxtabt, cdxtail, h32)
                cxtabtt, cxtabttlen = scale_expansion_zeroelim(abttlen, abtt, cdxtail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(cxtabttlen, cxtabtt, 2cdx, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(cxtabttlen, cxtabtt, cdxtail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
            if !iszero(cdytail)
                temp16a, temp16alen = scale_expansion_zeroelim(cytablen, cytab, cdytail, h16)
                cytabt, cytabtlen = scale_expansion_zeroelim(abtlen, abt, cdytail, h16)
                temp32a, temp32alen = scale_expansion_zeroelim(cytabtlen, cytabt, 2cdy, h32)
                temp48, temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, h48_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother)
                finnow, finother = finother, finnow

                temp32a, temp32alen = scale_expansion_zeroelim(cytabtlen, cytabt, cdytail, h32)
                cytabtt, cytabttlen = scale_expansion_zeroelim(abttlen, abtt, cdytail, h8)
                temp16a, temp16alen = scale_expansion_zeroelim(cytabttlen, cytabtt, 2cdy, h16)
                temp16b, temp16blen = scale_expansion_zeroelim(cytabttlen, cytabtt, cdytail, h16)
                temp32b, temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, h32)
                temp64, temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, h64_1)
                finother, finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother)
                finnow, finother = finother, finnow
            end
        end

        return finnow[finlength]
    end
end

function incircle(pa, pb, pc, pd, cache=nothing)
    @inbounds begin
        T = eltype(pa)
        adx = pa[1] - pd[1]
        bdx = pb[1] - pd[1]
        cdx = pc[1] - pd[1]
        ady = pa[2] - pd[2]
        bdy = pb[2] - pd[2]
        cdy = pc[2] - pd[2]

        bdxcdy = bdx * cdy
        cdxbdy = cdx * bdy
        alift = adx * adx + ady * ady

        cdxady = cdx * ady
        adxcdy = adx * cdy
        blift = bdx * bdx + bdy * bdy

        adxbdy = adx * bdy
        bdxady = bdx * ady
        clift = cdx * cdx + cdy * cdy

        det = alift * (bdxcdy - cdxbdy) +
              blift * (cdxady - adxcdy) +
              clift * (adxbdy - bdxady)

        permanent = (Absolute(bdxcdy) + Absolute(cdxbdy)) * alift +
                    (Absolute(cdxady) + Absolute(adxcdy)) * blift +
                    (Absolute(adxbdy) + Absolute(bdxady)) * clift
        errbound = iccerrboundA(T) * permanent
        if (det > errbound) || (-det > errbound)
            return det
        end

        return incircleadapt(pa, pb, pc, pd, permanent, cache)
    end
end

incircleexact_cache(_, cache) = cache
incircleexact_cache(::Type{T}, ::Nothing) where {T} = incircleexact_cache(T)
function incircleexact_cache(::Type{T}) where {T}
    cache = Vec{T}(undef, 1408)         # cache_size = (64 + 64) + (128 + 128 + 128 + 128) + (192 + 192) + (384)
    h48_1 = view(cache, 1:48)           # 0 .+ (1:48)
    h48_2 = view(cache, 65:112)         # 64 .+ (1:48)
    h96_1 = view(cache, 129:224)        # 128 .+ (1:96)
    h96_2 = view(cache, 257:352)        # 256 .+ (1:96)
    h96_3 = view(cache, 385:480)        # 384 .+ (1:96)
    h96_4 = view(cache, 513:608)        # 512 .+ (1:96)
    h192_1 = view(cache, 641:832)       # 640 .+ (1:192)
    h192_2 = view(cache, 833:1024)      # 832 .+ (1:192)
    h384_1 = view(cache, 1025:1408)     # 1024 .+ (1:384)
    return h48_1, h48_2, h96_1, h96_2, h96_3, h96_4, h192_1, h192_2, h384_1
end
incircleslow_cache(_, cache) = cache
incircleslow_cache(::Type{T}, ::Nothing) where {T} = incircleslow_cache(T)
function incircleslow_cache(::Type{T}) where {T}
    cache = Vec{T}(undef, 4096)         # cache_size = (64 + 64 + 64 + 64 + 64 + 64) + (128 + 128) + (192 + 192) + (384 + 384 + 384) + (768) + (1152)
    h64_1 = view(cache, 1:64)           # 0 .+ (1:64)
    h64_2 = view(cache, 65:128)         # 64 .+ (1:64)
    h64_3 = view(cache, 129:192)        # 128 .+ (1:64)
    h64_4 = view(cache, 193:256)        # 192 .+ (1:64)
    h64_5 = view(cache, 257:320)        # 256 .+ (1:64)
    h64_6 = view(cache, 321:384)        # 320 .+ (1:64)
    h128_1 = view(cache, 385:512)       # 384 .+ (1:128)
    h128_2 = view(cache, 513:640)       # 512 .+ (1:128)
    h192_1 = view(cache, 641:832)       # 640 .+ (1:192)
    h192_2 = view(cache, 833:1024)      # 832 .+ (1:192)
    h384_1 = view(cache, 1025:1408)     # 1024 .+ (1:384)
    h384_2 = view(cache, 1409:1792)     # 1408 .+ (1:384)
    h384_3 = view(cache, 1793:2176)     # 1792 .+ (1:384)
    h768 = view(cache, 2177:2944)       # 2176 .+ (1:768)
    h1152_1 = view(cache, 2945:4096)    # 2944 .+ (1:1152)
    return h64_1, h64_2, h64_3, h64_4, h64_5, h64_6, h128_1, h128_2, h192_1, h192_2, h384_1, h384_2, h384_3, h768, h1152_1
end
incircleadapt_cache(_, cache) = cache
incircleadapt_cache(::Type{T}, ::Nothing) where {T} = incircleadapt_cache(T)
function incircleadapt_cache(::Type{T}) where {T}
    cache = Vec{T}(undef, 2432)         # cache_size = (64) + (64) + (1152 + 1152)
    h48_1 = view(cache, 1:48)           # 0 .+ (1:48)
    h64_1 = view(cache, 65:128)         # 64 .+ (1:64)
    h1152_1 = view(cache, 129:1280)     # 128 .+ (1:1152)
    h1152_2 = view(cache, 1281:2432)    # 1280 .+ (1:1152)
    return h48_1, h64_1, h1152_1, h1152_2
end

@inline function Absolute(a)
    return abs(a)
end

@inline function Fast_Two_Sum_Tail(a, b, x)
    bvirt = x - a
    y = b - bvirt
    return y
end

@inline function Fast_Two_Sum(a, b)
    x = a + b
    y = Fast_Two_Sum_Tail(a, b, x)
    return x, y
end

@inline function Fast_Two_Diff_Tail(a, b, x)
    bvirt = a - x
    y = bvirt - b
    return y
end

@inline function Fast_Two_Diff(a, b)
    x = a - b
    y = Fast_Two_Diff_Tail(a, b, x)
    return x, y
end

@inline function Two_Sum_Tail(a, b, x)
    bvirt = x - a
    avirt = x - bvirt
    bround = b - bvirt
    around = a - avirt
    y = around + bround
    return y
end

@inline function Two_Sum(a, b)
    x = a + b
    y = Two_Sum_Tail(a, b, x)
    return x, y
end

@inline function Two_Diff_Tail(a, b, x)
    bvirt = a - x
    avirt = x + bvirt
    bround = bvirt - b
    around = a - avirt
    y = around + bround
    return y
end

@inline function Two_Diff(a, b)
    x = a - b
    y = Two_Diff_Tail(a, b, x)
    return x, y
end

@inline function Split(a)
    c = splitter(eltype(a)) * a
    abig = c - a
    ahi = c - abig
    alo = a - ahi
    return ahi, alo
end

@inline function Two_Product_Tail(a, b, x)
    ahi, alo = Split(a)
    bhi, blo = Split(b)
    err1 = x - (ahi * bhi)
    err2 = err1 - (alo * bhi)
    err3 = err2 - (ahi * blo)
    y = (alo * blo) - err3
    return y
end

@inline function Two_Product(a, b)
    x = a * b
    y = Two_Product_Tail(a, b, x)
    return x, y
end

@inline function Two_Product_Presplit(a, b, bhi, blo)
    x = a * b
    ahi, alo = Split(a)
    err1 = x - (ahi * bhi)
    err2 = err1 - (alo * bhi)
    err3 = err2 - (ahi * blo)
    y = (alo * blo) - err3
    return x, y
end

@inline function Two_Product_2Presplit(a, ahi, alo, b, bhi, blo)
    x = a * b
    err1 = x - (ahi * bhi)
    err2 = err1 - (alo * bhi)
    err3 = err2 - (ahi * blo)
    y = (alo * blo) - err3
    return x, y
end

@inline function Square_Tail(a, x)
    ahi, alo = Split(a)
    err1 = x - (ahi * ahi)
    err3 = err1 - ((ahi + ahi) * alo)
    y = (alo * alo) - err3
    return y
end

@inline function Square(a)
    x = a * a
    y = Square_Tail(a, x)
    return x, y
end

@inline function Two_One_Sum(a1, a0, b)
    _i, x0 = Two_Sum(a0, b)
    x2, x1 = Two_Sum(a1, _i)
    return x2, x1, x0
end

@inline function Two_One_Diff(a1, a0, b)
    _i, x0 = Two_Diff(a0, b)
    x2, x1 = Two_Sum(a1, _i)
    return x2, x1, x0
end

@inline function Two_Two_Sum(a1, a0, b1, b0)
    _j, _0, x0 = Two_One_Sum(a1, a0, b0)
    x3, x2, x1 = Two_One_Sum(_j, _0, b1)
    return x3, x2, x1, x0
end

@inline function Two_Two_Diff(a1, a0, b1, b0)
    _j, _0, x0 = Two_One_Diff(a1, a0, b0)
    x3, x2, x1 = Two_One_Diff(_j, _0, b1)
    return x3, x2, x1, x0
end

@inline function Four_One_Sum(a3, a2, a1, a0, b)
    _j, x1, x0 = Two_One_Sum(a1, a0, b)
    x4, x3, x2 = Two_One_Sum(a3, a2, _j)
    return x4, x3, x2, x1, x0
end

@inline function Four_Two_Sum(a3, a2, a1, a0, b1, b0)
    _k, _2, _1, _0, x0 = Four_One_Sum(a3, a2, a1, a0, b0)
    x5, x4, x3, x2, x1 = Four_One_Sum(_k, _2, _1, _0, b1)
    return x5, x4, x3, x2, x1, x0
end

@inline function Four_Four_Sum(a3, a2, a1, a0, b4, b3, b1, b0)
    _l, _2, _1, _0, x1, x0 = Four_Two_Sum(a3, a2, a1, a0, b1, b0)
    x7, x6, x5, x4, x3, x2 = Four_Two_Sum(_l, _2, _1, _0, b4, b3)
    return x7, x6, x5, x4, x3, x2, x1, x0
end

@inline function Eight_One_Sum(a7, a6, a5, a4, a3, a2, a1, a0, b)
    _j, x3, x2, x1, x0 = Four_One_Sum(a3, a2, a1, a0, b)
    x8, x7, x6, x5, x4 = Four_One_Sum(a7, a6, a5, a4, _j)
    return x8, x7, x6, x5, x4, x3, x2, x1, x0
end

@inline function Eight_Two_Sum(a7, a6, a5, a4, a3, a2, a1, a0, b1, b0)
    _k, _6, _5, _4, _3, _2, _1, _0, x0 = Eight_One_Sum(a7, a6, a5, a4, a3, a2, a1, a0, b0)
    x9, x8, x7, x6, x5, x4, x3, x2, x1 = Eight_One_Sum(_k, _6, _5, _4, _3, _2, _1, _0, b1)
    return x9, x8, x7, x6, x5, x4, x3, x2, x1, x0
end

@inline function Eight_Four_Sum(a7, a6, a5, a4, a3, a2, a1, a0, b4, b3, b1, b0)
    _l, _6, _5, _4, _3, _2, _1, _0, x1, x0 = Eight_Two_Sum(a7, a6, a5, a4, a3, a2, a1, a0, b1, b0)
    x11, x10, x9, x8, x7, x6, x5, x4, x3, x2 = Eight_Two_Sum(_l, _6, _5, _4, _3, _2, _1, _0, b4, b3)
    return x11, x10, x9, x8, x7, x6, x5, x4, x3, x2, x1, x0
end

@inline function Two_One_Product(a1, a0, b)
    bhi, blo = Split(b)
    _i, x0 = Two_Product_Presplit(a0, b, bhi, blo)
    _j, _0 = Two_Product_Presplit(a1, b, bhi, blo)
    _k, x1 = Two_Sum(_i, _0)
    x3, x2 = Fast_Two_Sum(_j, _k)
    return x3, x2, x1, x0
end

@inline function Four_One_Product(a3, a2, a1, a0, b)
    bhi, blo = Split(b)
    _i, x0 = Two_Product_Presplit(a0, b, bhi, blo)
    _j, _0 = Two_Product_Presplit(a1, b, bhi, blo)
    _k, x1 = Two_Sum(_i, _0)
    _i, x2 = Fast_Two_Sum(_j, _k)
    _j, _0 = Two_Product_Presplit(a2, b, bhi, blo)
    _k, x3 = Two_Sum(_i, _0)
    _i, x4 = Fast_Two_Sum(_j, _k)
    _j, _0 = Two_Product_Presplit(a3, b, bhi, blo)
    _k, x5 = Two_Sum(_i, _0)
    x7, x6 = Fast_Two_Sum(_j, _k)
    return x7, x6, x5, x4, x3, x2, x1, x0
end

@inline function Two_Two_Product(a1, a0, b1, b0)
    a0hi, a0lo = Split(a0)
    bhi, blo = Split(b0)
    _i, x0 = Two_Product_2Presplit(a0, a0hi, a0lo, b0, bhi, blo)
    a1hi, a1lo = Split(a1)
    _j, _0 = Two_Product_2Presplit(a1, a1hi, a1lo, b0, bhi, blo)
    _k, _1 = Two_Sum(_i, _0)
    _l, _2 = Fast_Two_Sum(_j, _k)
    bhi, blo = Split(b1)
    _i, _0 = Two_Product_2Presplit(a0, a0hi, a0lo, b1, bhi, blo)
    _k, x1 = Two_Sum(_1, _0)
    _j, _1 = Two_Sum(_2, _k)
    _m, _2 = Two_Sum(_l, _j)
    _j, _0 = Two_Product_2Presplit(a1, a1hi, a1lo, b1, bhi, blo)
    _n, _0 = Two_Sum(_i, _0)
    _i, x2 = Two_Sum(_1, _0)
    _k, _1 = Two_Sum(_2, _i)
    _l, _2 = Two_Sum(_m, _k)
    _k, _0 = Two_Sum(_j, _n)
    _j, x3 = Two_Sum(_1, _0)
    _i, _1 = Two_Sum(_2, _j)
    _m, _2 = Two_Sum(_l, _i)
    _i, x4 = Two_Sum(_1, _k)
    _k, x5 = Two_Sum(_2, _i)
    x7, x6 = Two_Sum(_m, _k)
    return x7, x6, x5, x4, x3, x2, x1, x0
end

@inline function Two_Square(a1, a0)
    _j, x0 = Square(a0)
    _0 = a0 + a0
    _k, _1 = Two_Product(a1, _0)
    _l, _2, x1 = Two_One_Sum(_k, _1, _j)
    _j, _1 = Square(a1)
    x5, x4, x3, x2 = Two_Two_Sum(_j, _1, _l, _2)
    return x5, x4, x3, x2, x1, x0
end

function orient2fast(pa, pb, pc)
    @inbounds begin
        acx = pa[1] - pc[1]
        bcx = pb[1] - pc[1]
        acy = pa[2] - pc[2]
        bcy = pb[2] - pc[2]
        return acx * bcy - acy * bcx
    end
end

function orient2exact(pa, pb, pc)
    @inbounds begin
        axby1, axby0 = Two_Product(pa[1], pb[2])
        axcy1, axcy0 = Two_Product(pa[1], pc[2])
        aterms3, aterms2, aterms1, aterms0 = Two_Two_Diff(axby1, axby0, axcy1, axcy0)
        aterms = (aterms0, aterms1, aterms2, aterms3)

        bxcy1, bxcy0 = Two_Product(pb[1], pc[2])
        bxay1, bxay0 = Two_Product(pb[1], pa[2])
        bterms3, bterms2, bterms1, bterms0 = Two_Two_Diff(bxcy1, bxcy0, bxay1, bxay0)
        bterms = (bterms0, bterms1, bterms2, bterms3)

        cxay1, cxay0 = Two_Product(pc[1], pa[2])
        cxby1, cxby0 = Two_Product(pc[1], pb[2])
        cterms3, cterms2, cterms1, cterms0 = Two_Two_Diff(cxay1, cxay0, cxby1, cxby0)
        cterms = (cterms0, cterms1, cterms2, cterms3)

        T = eltype(pa)
        h8 = ntuple(_ -> zero(T), Val(8))
        h12 = ntuple(_ -> zero(T), Val(12))
        v, vlength = fast_expansion_sum_zeroelim(4, aterms, 4, bterms, h8)
        w, wlength = fast_expansion_sum_zeroelim(vlength, v, 4, cterms, h12)
        return w[wlength]
    end
end

function orient2slow(pa, pb, pc)
    @inbounds begin
        acx, acxtail = Two_Diff(pa[1], pc[1])
        acy, acytail = Two_Diff(pa[2], pc[2])
        bcx, bcxtail = Two_Diff(pb[1], pc[1])
        bcy, bcytail = Two_Diff(pb[2], pc[2])

        axby7, axby6, axby5, axby4, axby3, axby2, axby1, axby0 = Two_Two_Product(acx, acxtail, bcy, bcytail)
        axby = (axby0, axby1, axby2, axby3, axby4, axby5, axby6, axby7)
        negate = -acy
        negatetail = -acytail
        bxay7, bxay6, bxay5, bxay4, bxay3, bxay2, bxay1, bxay0 = Two_Two_Product(bcx, bcxtail, negate, negatetail)
        bxay = (bxay0, bxay1, bxay2, bxay3, bxay4, bxay5, bxay6, bxay7)

        T = eltype(pa)
        h16 = ntuple(_ -> zero(T), Val(16))
        deter, deterlen = fast_expansion_sum_zeroelim(8, axby, 8, bxay, h16)
        return deter[deterlen]
    end
end

function orient2adapt(pa, pb, pc, detsum)
    @inbounds begin
        T = eltype(pa)
        acx = pa[1] - pc[1]
        bcx = pb[1] - pc[1]
        acy = pa[2] - pc[2]
        bcy = pb[2] - pc[2]

        detleft, detlefttail = Two_Product(acx, bcy)
        detright, detrighttail = Two_Product(acy, bcx)

        B3, B2, B1, B0 = Two_Two_Diff(detleft, detlefttail, detright, detrighttail)
        B = (B0, B1, B2, B3)

        det = estimate(4, B)
        errbound = ccwerrboundB(T) * detsum
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        acxtail = Two_Diff_Tail(pa[1], pc[1], acx)
        bcxtail = Two_Diff_Tail(pb[1], pc[1], bcx)
        acytail = Two_Diff_Tail(pa[2], pc[2], acy)
        bcytail = Two_Diff_Tail(pb[2], pc[2], bcy)

        if iszero(acxtail) && iszero(acytail) && iszero(bcxtail) && iszero(bcytail)
            return det
        end

        errbound = ccwerrboundC(T) * detsum + resulterrbound(T) * Absolute(det)
        det += (acx * bcytail + bcy * acxtail) - (acy * bcxtail + bcx * acytail)
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        s1, s0 = Two_Product(acxtail, bcy)
        t1, t0 = Two_Product(acytail, bcx)
        u3, u2, u1, u0 = Two_Two_Diff(s1, s0, t1, t0)
        u = (u0, u1, u2, u3)
        h8 = ntuple(_ -> zero(T), Val(8))
        C1, C1length = fast_expansion_sum_zeroelim(4, B, 4, u, h8)

        s1, s0 = Two_Product(acx, bcytail)
        t1, t0 = Two_Product(acy, bcxtail)
        u3, u2, u1, u0 = Two_Two_Diff(s1, s0, t1, t0)
        u = (u0, u1, u2, u3)
        h12 = ntuple(_ -> zero(T), Val(12))
        C2, C2length = fast_expansion_sum_zeroelim(C1length, C1, 4, u, h12)

        s1, s0 = Two_Product(acxtail, bcytail)
        t1, t0 = Two_Product(acytail, bcxtail)
        u3, u2, u1, u0 = Two_Two_Diff(s1, s0, t1, t0)
        u = (u0, u1, u2, u3)
        h16 = ntuple(_ -> zero(T), Val(16))
        D, Dlength = fast_expansion_sum_zeroelim(C2length, C2, 4, u, h16)

        return D[Dlength]
    end
end

function orient2(pa, pb, pc)
    @inbounds begin
        T = eltype(pa)
        detleft = (pa[1] - pc[1]) * (pb[2] - pc[2])
        detright = (pa[2] - pc[2]) * (pb[1] - pc[1])
        det = detleft - detright

        if detleft > 0
            if detright ≤ 0
                return det
            else
                detsum = detleft + detright
            end
        elseif detleft < 0
            if detright ≥ 0
                return det
            else
                detsum = -detleft - detright
            end
        else
            return det
        end

        errbound = ccwerrboundA(T) * detsum
        if (det ≥ errbound) || (-det ≥ errbound)
            return det
        end

        return orient2adapt(pa, pb, pc, detsum)
    end
end

macro check_length(f, args, expr)
    len = expr.args[1].args[2]
    quote
        $(esc(expr))
        $(esc(len)) < 32 || return $(esc(f))($(esc(args))...)
    end
end

include("orient2.jl")
include("orient3.jl")
include("incircle.jl")
include("insphere.jl")

@inline _tup(c::Complex) = (c.re, c.im)
@inline sgn(x) = Int(sign(x))

@inline orient2(pa::Complex, pb::Complex, pc::Complex) = orient2(_tup(pa), _tup(pb), _tup(pc))
@inline incircle(pa::Complex, pb::Complex, pc::Complex, pd::Complex, cache=nothing) = incircle(_tup(pa), _tup(pb), _tup(pc), _tup(pd), cache)

@inline orient2p(pa, pb, pc) = sgn(orient2(pa, pb, pc))
@inline orient3p(pa, pb, pc, pd, cache=nothing) = sgn(orient3(pa, pb, pc, pd, cache))
@inline incirclep(pa, pb, pc, pd, cache=nothing) = sgn(incircle(pa, pb, pc, pd, cache))
@inline inspherep(pa, pb, pc, pd, pe, cache=nothing) = sgn(insphere(pa, pb, pc, pd, pe, cache))

@doc """
    orient2(p, q, r)
    
For three points `p`, `q`, `r` in the plane, returns:

- A positive value if `r` is left of the oriented line defined by `(p, q)`.
- A negative value if `r` is right of the line.
- Zero if the three points are collinear.

Equivalently, the returned value is positive if the triangle `(p, q, r)` is oriented 
counter-clockwise; negative if the triangle is oriented clockwise; and zero if the points 
are collinear.

The inputs can be either all `NTuple`s or all `Complex`, with either all `Float64` or all `Float32` coordinates.

Note that `orient2(p, q, r)/2` is also roughly the signed area of the triangle defined by `(p, q, r)`. 

See also [`orient2p`](@ref).
"""
orient2

@doc """
    incircle(p, q, r, s[, cache=nothing])

For four points `p`, `q`, `r`, `s` in the plane, returns:

- A positive value if `s` is inside the circle through `p`, `q`, and `r`.
- A negative value if `s` is outside the circle.
- Zero if the four points are cocircular.

The points `p`, `q`, and `r` are assumed to be in counter-clockwise order, otherwise 
the sign of the result will be reversed. The optional `cache` argument can be used for 
preallocating memory for intermediate results, passing the argument from `incircleadapt_cache(T)`,
where `T` is the number type of the input points.

See also [`incirclep`](@ref).
"""
incircle

@doc """
    incirclep(p, q, r, s[, cache=nothing]) -> Int 

This function is the same as [`incircle`], except returns the sign of the result,
i.e. `Int(sign(incircle(p, q, r, s)))`. The optional `cache` argument is the same as in `incircle`.
"""
incirclep

@doc """
    insphere(p, q, r, s, t[, cache=nothing])

For five points `p`, `q`, `r`, `s`, `t` in the plane, returns: 

- A positive value if `t` is inside the sphere through `p`, `q`, `r`, and `s`.
- A negative value if `t` is outside the sphere.
- Zero if the five points are cospherical. 

The points `p`, `q`, `r`, and `s` are assumed to be ordered so that they 
have positive oriented (according to [`orient3`](@ref)), otherwise 
the sign of the result will be reversed. The optional `cache` argument can be used for
preallocating memory for intermediate results, passing the argument from `insphereexact_cache(T)`,
where `T` is the number type of the input points.

See also [`inspherep`](@ref).
"""
insphere

@doc """
    inspherep(p, q, r, s, t[, cache=nothing]) -> Int 

This function is the same as [`insphere`], except returns the sign of the result,
i.e. `Int(sign(incircle(p, q, r, s, t)))`. The optional `cache` argument is the same as in `insphere`.
"""
inspherep

@doc """
    orient2p(p, q, r) -> Int
    
This function is the same as [`orient2`], except returns the sign of the result,
i.e. `Int(sign(orient2(p, q, r)))`.
"""
orient2p

@doc """
    orient3(p, q, r, s[, cache=nothing])
    
For four points `p`, `q`, `r`, `s` in space, consider the oriented plane 
on which the triangle `(p, q, r)` is positively oriented. The function returns 

- A positive value if `s` is below this plane.
- A negative value if `s` is below this plane.
- Zero if the four points are coplanar.

The inputs should all be `NTuple`s with either all `Float64` or all `Float32` coordinates. The optional `cache` argument can be used for
preallocating memory for intermediate results, passing the argument from `orient3adapt_cache(T)`,
where `T` is the number type of the input points.

Note that `orient3(p, q, r, s)/2` is also roughly the signed area of the tetrahedron defined by `(p, q, r, s)`. 

The result returned from this predicate can also be interpreted in terms of the orientation of the tetrahedron 
defined by `(p, q, r, s)`, where a positively oriented tetrahedron `(p, q, r, s)` takes the form

                                   z.
                                 .
                               ,/
                             s
                           ,/|'\\
                         ,/  |  '\\
                       ,/    '.   '\\
                     ,/       |     '\\                 
                   ,/         |       '\\              
                  p-----------'.--------q --> x
                   '\\.         |      ,/              
                      '\\.      |    ,/                 
                         '\\.   '. ,/    
                            '\\. |/      
                               'r       
                                 '\\.    
"""
orient3

@doc """
    orient3p(p, q, r, s[, cache=nothing]) -> Int
    
This function is the same as [`orient3`], except returns the sign of the result,
i.e. `Int(sign(orient2(p, q, r, s)))`. The optional `cache` argument is the same as in `orient3`.
"""
orient3p

abstract type Method end
struct MacroMethod <: Method
    f::Symbol
    nargs::Int
end
struct ArithmeticMethod <: Method
    f::Symbol
    nargs::Int
    argdims::Tuple
    # argdims:
    #   d > 0 ⟹ NTuple{d, Float}. If d == 1, just becomes a Float
    #   d < 0 ⟹ random vector of length rand(1:8)
    #   d isa Function ⟹ A function of args such that d(args) returns the dimension, and the result returned if zeros(T, d(args))
    ArithmeticMethod(f, nargs, argdims::Tuple) = (length(argdims) == nargs || throw(ArgumentError("length(argdims) ≠ nargs"))) && return new(f, nargs, argdims)
end
struct PredicateMethod <: Method
    f::Symbol
    nargs::Int
    argdims::Int
end
argdims(method::MacroMethod, i) = 1
argdims(method::ArithmeticMethod, i) = method.argdims[i]
argdims(method::PredicateMethod, i) = method.argdims

function _rand(::Type{T}) where {T}
    if rand() < 1 / 4
        # Generate a float
        s = rand((-1, 1))
        f = rand(T)
        e = T == Float64 ? rand(-100:200) : rand(-24:24)
        return s * (one(f) + f) * T(2)^e # no subnormal normals will be generated here
    else
        # Generate an integer 
        return T(rand(-100:100))
    end
end
const NTESTS = 50000
macro repeat(args...)
    if length(args) == 1
        n = NTESTS
        expr = args[1]
    elseif length(args) == 2
        n, expr = args[1:2]
    else
        throw(ArgumentError("Invalid expression passed to @repeat."))
    end
    quote
        foreach(_ -> $(esc(expr)), 1:$(esc(n)))
    end
end

function genargs(method::Method, ::Type{T}) where {T}
    args = ()
    for i in 1:method.nargs
        argdim = argdims(method, i)
        arg = if argdim == 1
            _rand(T)
        elseif argdim isa Function
            zeros(T, argdim(args))
        elseif argdim > 0
            ntuple(_ -> _rand(T), Val(argdim))
        else
            [_rand(T) for _ in 1:rand(1:8)]
        end
        args = (args..., arg)
    end
    if method isa PredicateMethod
        f = String(method.f)
        if endswith(f, "adapt")
            args = (args..., _rand(T))
        end
        if f ∈ ("incircle", "orient2") && rand() < 1 / 2 # 50% chance we test Complex instead of NTuple{2}
            new_args = ()
            for arg in args
                if arg isa NTuple{2}
                    new_args = (new_args..., Complex(arg[1], arg[2]))
                else
                    new_args = (new_args..., arg)
                end
            end
            args = new_args
        end
    end
    return add_lengths(method, args)
end
function add_lengths(method, args) # adds elen, flen 
    new_args = ()
    for i in eachindex(args)
        if args[i] isa Vector && (i ≠ lastindex(args) || method.f == :estimate)
            new_args = (new_args..., length(args[i]), args[i])
        else
            new_args = (new_args..., args[i])
        end
    end
    return new_args
end
function _retup_complex(args)
    new_args = ()
    for arg in args
        if arg isa Complex
            new_args = (new_args..., (arg.re, arg.im))
        else
            new_args = (new_args..., arg)
        end
    end
    return new_args
end

struct Expansion{T}
    h::Vector{T}
    hlen::Int # not necessarily length(h)
    function Expansion(h::Vector{T}, hlen::Int; check_zero=false) where {T}
        check_zero && @test all(iszero, view(h, hlen+1:length(h))) && hlen ≤ length(h) # For compress, the remaining components don't need to be zero
        return new{T}(h, hlen)
    end
end
Expansion(x::Number; kwargs...) = Expansion([x], 1; kwargs...)
Expansion(x::NTuple{N,<:AbstractFloat}; kwargs...) where {N} = Expansion(collect(x), N; kwargs...)
Expansion(xh::Tuple{NTuple{N,<:AbstractFloat},Int}; kwargs...) where {N} = Expansion(collect(xh[1]), xh[2]; kwargs...)
Expansion(xh::Tuple{<:Vector,Int}; kwargs...) = Expansion(xh[1], xh[2]; kwargs...)

expand(h::Expansion) = view(h.h, 1:h.hlen)
Base.sum(h::Expansion) = sum(expand(h))
function Base.:(==)(e::Expansion, f::Expansion)
    return sum(e) == sum(f)
end

function ⪧(LHS, RHS; kwargs...)
    return Expansion(LHS; kwargs...) == Expansion(RHS; kwargs...)
end

struct FailedTest
    LHSf::Function
    RHSf::Function
    LHSv::Any
    RHSv::Any
    args::Tuple
end

function retry(failures::Vector{FailedTest})
    remaining = Vector{FailedTest}()
    foreach(failures) do failure 
        LHSf = failure.LHSf
        RHSv, args = failure.RHSv, failure.args
        LHSv = LHSf(args...)
        flag = ⪧(LHSv, RHSv; check_zero = nameof(LHSf) ∉ non_check_zeros)
        if !flag
            push!(remaining, failure)
        end
    end
    return remaining
end

const non_check_zeros = (:compress, :expansion_sum_zeroelim2, :expansion_sum_zeroelim1)
function test_f(method::Method; failures)
    return _test_f(method; failures)
end
function test_f(method::PredicateMethod; failures)
    for suffix in (:fast, :exact, :adapt, :slow, Symbol())
        g = Symbol(method.f, suffix)
        _method = PredicateMethod(g, method.nargs, method.argdims)
        _test_f(_method; failures)
    end
    return true
end
function _test_f(method::Method; failures)
    args64 = genargs(method, Float64)
    args32 = genargs(method, Float32)
    LHS = getproperty(AP, method.f)
    cmethod = method isa PredicateMethod ? Symbol(replace(String(method.f), "2" => "2d", "3" => "3d")) : method.f
    RHS = getproperty(C, cmethod)
    LHSf64 = @inferred LHS(args64...)
    LHSf32 = @inferred LHS(args32...)
    RHSf64 = RHS(_retup_complex(args64)...)
    RHSf32 = RHS(_retup_complex(args32)...)
    flag1 = ⪧(LHSf64, RHSf64; check_zero=method.f ∉ non_check_zeros)
    flag2 = ⪧(LHSf32, RHSf32; check_zero=method.f ∉ non_check_zeros)
    !flag1 && push!(failures, FailedTest(LHS, RHS, LHSf64, RHSf64, args64))
    !flag2 && push!(failures, FailedTest(LHS, RHS, LHSf32, RHSf32, args32))
    @test LHSf64 ⪧ RHSf64 check_zero = method.f ∉ non_check_zeros
    @test LHSf32 ⪧ RHSf32 check_zero = method.f ∉ non_check_zeros
    if method isa PredicateMethod
        if method.f ∈ (:orient2, :incircle, :orient3, :insphere)
            LHSp = getproperty(AP, Symbol(method.f, :p))
            LHSf64p::Int = @inferred LHSp(args64...)
            LHSf32p::Int = @inferred LHSp(args32...)
            flag1 = LHSf64p == Int(sign(RHSf64))
            flag2 = LHSf32p == Int(sign(RHSf32))
            !flag1 && push!(failures, FailedTest(LHSp, RHS, LHSf64p, Int(sign(RHSf64)), args64))
            !flag2 && push!(failures, FailedTest(LHSp, RHS, LHSf32p, Int(sign(RHSf32)), args32))
            @test LHSf64p == Int(sign(RHSf64))
            @test LHSf32p == Int(sign(RHSf32))
        end
        @test LHSf64 isa Float64
        @test LHSf32 isa Float32
        # Test concurrency
        if rand() < 100 / NTESTS
            ap64 = Vector{Float64}(undef, 24)
            ap32 = Vector{Float32}(undef, 24)
            Base.Threads.@threads for i in 1:24
                ap64[i] = LHS(args64...)
                ap32[i] = LHS(args32...)
            end
            @test all(==(RHSf64), ap64)
            @test all(==(RHSf32), ap32)
        end
    end
    return true
end

module AdaptivePredicates

@static if isdefined(Base, :Memory)
    const Vec{T} = Memory{T}
else
    const Vec{T} = Vector{T}
end

include("init.jl")
include("macros.jl")
include("arithmetic.jl")
include("predicates.jl")

export orient2, orient3, incircle, insphere
export orient2p, orient3p, incirclep, inspherep
export orient2fast, orient3fast, incirclefast, inspherefast

if VERSION ≥ v"1.11.0-DEV.469"
    eval(Meta.parse("public orient3adapt_cache, incircleadapt_cache, insphereexact_cache"))
end

end # module

module CPredicates
const C64 = joinpath(@__DIR__, "original", "libpredicates64.so")
const C32 = joinpath(@__DIR__, "original", "libpredicates32.so")
const F64 = Float64
const F32 = Float32

for (C, T, F) in ((C64, F64, Cdouble), (C32, F32, Cfloat))
    @eval begin
        function Absolute(a::$T)
            return @ccall $C._Absolute(a::$F)::$F
        end

        function Fast_Two_Sum_Tail(a::$T, b::$T, x::$T)
            return @ccall $C._Fast_Two_Sum_Tail(a::$F, b::$F, x::$F)::$F
        end

        function Fast_Two_Sum(a::$T, b::$T)
            return @ccall $C._Fast_Two_Sum(a::$F, b::$F)::NTuple{2,$F}
        end

        function Fast_Two_Diff_Tail(a::$T, b::$T, x::$T)
            return @ccall $C._Fast_Two_Diff_Tail(a::$F, b::$F, x::$F)::$F
        end

        function Fast_Two_Diff(a::$T, b::$T)
            return @ccall $C._Fast_Two_Diff(a::$F, b::$F)::NTuple{2,$F}
        end

        function Two_Sum_Tail(a::$T, b::$T, x::$T)
            return @ccall $C._Two_Sum_Tail(a::$F, b::$F, x::$F)::$F
        end

        function Two_Sum(a::$T, b::$T)
            return @ccall $C._Two_Sum(a::$F, b::$F)::NTuple{2,$F}
        end

        function Two_Diff_Tail(a::$T, b::$T, x::$T)
            return @ccall $C._Two_Diff_Tail(a::$F, b::$F, x::$F)::$F
        end

        function Two_Diff(a::$T, b::$T)
            return @ccall $C._Two_Diff(a::$F, b::$F)::NTuple{2,$F}
        end

        function Split(a::$T)
            return @ccall $C._Split(a::$F)::NTuple{2,$F}
        end

        function Two_Product_Tail(a::$T, b::$T, x::$T)
            return @ccall $C._Two_Product_Tail(a::$F, b::$F, x::$F)::$F
        end

        function Two_Product(a::$T, b::$T)
            return @ccall $C._Two_Product(a::$F, b::$F)::NTuple{2,$F}
        end

        function Two_Product_Presplit(a::$T, b::$T, bhi::$T, blo::$T)
            return @ccall $C._Two_Product_Presplit(a::$F, b::$F, bhi::$F, blo::$F)::NTuple{2,$F}
        end

        function Two_Product_2Presplit(a::$T, ahi::$T, alo::$T, b::$T, bhi::$T, blo::$T)
            return @ccall $C._Two_Product_2Presplit(a::$F, ahi::$F, alo::$F, b::$F, bhi::$F, blo::$F)::NTuple{2,$F}
        end

        function Square_Tail(a::$T, x::$T)
            return @ccall $C._Square_Tail(a::$F, x::$F)::$F
        end

        function Square(a::$T)
            return @ccall $C._Square(a::$F)::NTuple{2,$F}
        end

        function Two_One_Sum(a1::$T, a0::$T, b::$T)
            return @ccall $C._Two_One_Sum(a1::$F, a0::$F, b::$F)::NTuple{3,$F}
        end

        function Two_One_Diff(a1::$T, a0::$T, b::$T)
            return @ccall $C._Two_One_Diff(a1::$F, a0::$F, b::$F)::NTuple{3,$F}
        end

        function Two_Two_Sum(a1::$T, a0::$T, b1::$T, b0::$T)
            return @ccall $C._Two_Two_Sum(a1::$F, a0::$F, b1::$F, b0::$F)::NTuple{4,$F}
        end

        function Two_Two_Diff(a1::$T, a0::$T, b1::$T, b0::$T)
            return @ccall $C._Two_Two_Diff(a1::$F, a0::$F, b1::$F, b0::$F)::NTuple{4,$F}
        end

        function Four_One_Sum(a3::$T, a2::$T, a1::$T, a0::$T, b::$T)
            return @ccall $C._Four_One_Sum(a3::$F, a2::$F, a1::$F, a0::$F, b::$F)::NTuple{5,$F}
        end

        function Four_Two_Sum(a3::$T, a2::$T, a1::$T, a0::$T, b1::$T, b0::$T)
            return @ccall $C._Four_Two_Sum(a3::$F, a2::$F, a1::$F, a0::$F, b1::$F, b0::$F)::NTuple{6,$F}
        end

        function Four_Four_Sum(a3::$T, a2::$T, a1::$T, a0::$T, b3::$T, b2::$T, b1::$T, b0::$T)
            return @ccall $C._Four_Four_Sum(a3::$F, a2::$F, a1::$F, a0::$F, b3::$F, b2::$F, b1::$F, b0::$F)::NTuple{8,$F}
        end

        function Eight_One_Sum(a7::$T, a6::$T, a5::$T, a4::$T, a3::$T, a2::$T, a1::$T, a0::$T, b::$T)
            return @ccall $C._Eight_One_Sum(a7::$F, a6::$F, a5::$F, a4::$F, a3::$F, a2::$F, a1::$F, a0::$F, b::$F)::NTuple{9,$F}
        end

        function Eight_Two_Sum(a7::$F, a6::$F, a5::$F, a4::$F, a3::$T, a2::$T, a1::$T, a0::$T, b1::$T, b0::$T)
            return @ccall $C._Eight_Two_Sum(a7::$F, a6::$F, a5::$F, a4::$F, a3::$F, a2::$F, a1::$F, a0::$F, b1::$F, b0::$F)::NTuple{10,$F}
        end

        function Eight_Four_Sum(a7::$T, a6::$T, a5::$T, a4::$T, a3::$T, a2::$T, a1::$T, a0::$T, b3::$T, b2::$T, b1::$T, b0::$T)
            return @ccall $C._Eight_Four_Sum(a7::$F, a6::$F, a5::$F, a4::$F, a3::$F, a2::$F, a1::$F, a0::$F, b3::$F, b2::$F, b1::$F, b0::$F)::NTuple{12,$F}
        end

        function Two_One_Product(a1::$T, a0::$T, b::$T)
            return @ccall $C._Two_One_Product(a1::$F, a0::$F, b::$F)::NTuple{4,$F}
        end

        function Four_One_Product(a3::$T, a2::$T, a1::$T, a0::$T, b::$T)
            return @ccall $C._Four_One_Product(a3::$F, a2::$F, a1::$F, a0::$F, b::$F)::NTuple{8,$F}
        end

        function Two_Two_Product(a1::$T, a0::$T, b1::$T, b0::$T)
            return @ccall $C._Two_Two_Product(a1::$F, a0::$F, b1::$F, b0::$F)::NTuple{8,$F}
        end

        function Two_Square(a1::$T, a0::$T)
            return @ccall $C._Two_Square(a1::$F, a0::$F)::NTuple{6,$F}
        end

        function grow_expansion(elen::Int, e::Vector{$T}, b::$T, h::Vector{$T})
            hindex = @ccall $C.grow_expansion(elen::Int, e::Ptr{$F}, b::$F, h::Ptr{$F})::Int
            return h, hindex
        end

        function grow_expansion_zeroelim(elen::Int, e::Vector{$T}, b::$T, h::Vector{$T})
            hindex = @ccall $C.grow_expansion_zeroelim(elen::Int, e::Ptr{$F}, b::$F, h::Ptr{$F})::Int
            return h, hindex
        end

        function expansion_sum(elen::Int, e::Vector{$T}, flen::Int, f::Vector{$T}, h::Vector{$T})
            hindex = @ccall $C.expansion_sum(elen::Int, e::Ptr{$F}, flen::Int, f::Ptr{$F}, h::Ptr{$F})::Int
            return h, hindex
        end

        function expansion_sum_zeroelim1(elen::Int, e::Vector{$T}, flen::Int, f::Vector{$T}, h::Vector{$T})
            hindex = @ccall $C.expansion_sum_zeroelim1(elen::Int, e::Ptr{$F}, flen::Int, f::Ptr{$F}, h::Ptr{$F})::Int
            return h, hindex
        end

        function expansion_sum_zeroelim2(elen::Int, e::Vector{$T}, flen::Int, f::Vector{$T}, h::Vector{$T})
            hindex = @ccall $C.expansion_sum_zeroelim2(elen::Int, e::Ptr{$F}, flen::Int, f::Ptr{$F}, h::Ptr{$F})::Int
            return h, hindex
        end

        function fast_expansion_sum(elen::Int, e::Vector{$T}, flen::Int, f::Vector{$T}, h::Vector{$T})
            hindex = @ccall $C.fast_expansion_sum(elen::Int, e::Ptr{$F}, flen::Int, f::Ptr{$F}, h::Ptr{$F})::Int
            return h, hindex
        end

        function fast_expansion_sum_zeroelim(elen::Int, e::Vector{$T}, flen::Int, f::Vector{$T}, h::Vector{$T})
            hindex = @ccall $C.fast_expansion_sum_zeroelim(elen::Int, e::Ptr{$F}, flen::Int, f::Ptr{$F}, h::Ptr{$F})::Int
            return h, hindex
        end

        function linear_expansion_sum(elen::Int, e::Vector{$T}, flen::Int, f::Vector{$T}, h::Vector{$T})
            hindex = @ccall $C.linear_expansion_sum(elen::Int, e::Ptr{$F}, flen::Int, f::Ptr{$F}, h::Ptr{$F})::Int
            return h, hindex
        end

        function linear_expansion_sum_zeroelim(elen::Int, e::Vector{$T}, flen::Int, f::Vector{$T}, h::Vector{$T})
            hindex = @ccall $C.linear_expansion_sum_zeroelim(elen::Int, e::Ptr{$F}, flen::Int, f::Ptr{$F}, h::Ptr{$F})::Int
            return h, hindex
        end

        function scale_expansion(elen::Int, e::Vector{$T}, b::$T, h::Vector{$T})
            hindex = @ccall $C.scale_expansion(elen::Int, e::Ptr{$F}, b::$F, h::Ptr{$F})::Int
            return h, hindex
        end

        function scale_expansion_zeroelim(elen::Int, e::Vector{$T}, b::$T, h::Vector{$T})
            hindex = @ccall $C.scale_expansion_zeroelim(elen::Int, e::Ptr{$F}, b::$F, h::Ptr{$F})::Int
            return h, hindex
        end

        function compress(elen::Int, e::Vector{$T}, h::Vector{$T})
            hindex = @ccall $C.compress(elen::Int, e::Ptr{$F}, h::Ptr{$F})::Int
            return h, hindex
        end

        function estimate(elen::Int, e::Vector{$T})
            h = @ccall $C.estimate(elen::Int, e::Ptr{$F})::$F
            return h
        end
    end

    for post in (:fast, :exact, :slow, Symbol(""))
        @eval begin
            function $(Symbol("orient2d$post"))(pa::NTuple{2,$T}, pb::NTuple{2,$T}, pc::NTuple{2,$T})
                return @ccall $C.$(Symbol("orient2d$post"))(Ref(pa)::Ptr{$F}, Ref(pb)::Ptr{$F}, Ref(pc)::Ptr{$F})::$F
            end

            function $(Symbol("orient3d$post"))(pa::NTuple{3,$T}, pb::NTuple{3,$T}, pc::NTuple{3,$T}, pd::NTuple{3,$T})
                return @ccall $C.$(Symbol("orient3d$post"))(Ref(pa)::Ptr{$F}, Ref(pb)::Ptr{$F}, Ref(pc)::Ptr{$F}, Ref(pd)::Ptr{$F})::$F
            end

            function $(Symbol("incircle$post"))(pa::NTuple{2,$T}, pb::NTuple{2,$T}, pc::NTuple{2,$T}, pd::NTuple{2,$T})
                return @ccall $C.$(Symbol("incircle$post"))(Ref(pa)::Ptr{$F}, Ref(pb)::Ptr{$F}, Ref(pc)::Ptr{$F}, Ref(pd)::Ptr{$F})::$F
            end

            function $(Symbol("insphere$post"))(pa::NTuple{3,$T}, pb::NTuple{3,$T}, pc::NTuple{3,$T}, pd::NTuple{3,$T}, pe::NTuple{3,$T})
                return @ccall $C.$(Symbol("insphere$post"))(Ref(pa)::Ptr{$F}, Ref(pb)::Ptr{$F}, Ref(pc)::Ptr{$F}, Ref(pd)::Ptr{$F}, Ref(pe)::Ptr{$F})::$F
            end
        end
    end

    @eval begin
        function orient2dadapt(pa::NTuple{2,$T}, pb::NTuple{2,$T}, pc::NTuple{2,$T}, detsum::$T)
            return @ccall $C.orient2dadapt(Ref(pa)::Ptr{$F}, Ref(pb)::Ptr{$F}, Ref(pc)::Ptr{$F}, detsum::$F)::$F
        end

        function orient3dadapt(pa::NTuple{3,$T}, pb::NTuple{3,$T}, pc::NTuple{3,$T}, pd::NTuple{3,$T}, permanent::$T)
            return @ccall $C.orient3dadapt(Ref(pa)::Ptr{$F}, Ref(pb)::Ptr{$F}, Ref(pc)::Ptr{$F}, Ref(pd)::Ptr{$F}, permanent::$F)::$F
        end

        function incircleadapt(pa::NTuple{2,$T}, pb::NTuple{2,$T}, pc::NTuple{2,$T}, pd::NTuple{2,$T}, permanent::$T)
            return @ccall $C.incircleadapt(Ref(pa)::Ptr{$F}, Ref(pb)::Ptr{$F}, Ref(pc)::Ptr{$F}, Ref(pd)::Ptr{$F}, permanent::$F)::$F
        end

        function insphereadapt(pa::NTuple{3,$T}, pb::NTuple{3,$T}, pc::NTuple{3,$T}, pd::NTuple{3,$T}, pe::NTuple{3,$T}, permanent::$T)
            return @ccall $C.insphereadapt(Ref(pa)::Ptr{$F}, Ref(pb)::Ptr{$F}, Ref(pc)::Ptr{$F}, Ref(pd)::Ptr{$F}, Ref(pe)::Ptr{$F}, permanent::$F)::$F
        end
    end
end

const C64_consts = @ccall C64.exactinit2()::NTuple{15,Float64}
const C32_consts = @ccall C32.exactinit2()::NTuple{15,Float32}

function __init__()
    @ccall C64.exactinit()::Cvoid
    @ccall C32.exactinit()::Cvoid
end

end # module CPredicates

struct InitConstants{T}
    epsilon::T
    splitter::T
    resulterrbound::T
    ccwerrboundA::T
    ccwerrboundB::T
    ccwerrboundC::T
    o3derrboundA::T
    o3derrboundB::T
    o3derrboundC::T
    iccerrboundA::T
    iccerrboundB::T
    iccerrboundC::T
    isperrboundA::T
    isperrboundB::T
    isperrboundC::T
end

function InitConstants{T}() where {T}
    every_other = true
    half = one(T) / 2
    epsilon = one(T)
    splitter = one(T)
    check = one(T)
    cond = true
    while cond
        lastcheck = check
        epsilon *= half
        if every_other
            splitter *= 2one(T)
        end
        every_other = !every_other
        check = one(T) + epsilon
        cond = !isone(check) && check ≠ lastcheck
    end
    @assert epsilon == eps(T) / 2
    splitter += one(T)
    resulterrbound = (3 + 8epsilon) * epsilon
    ccwerrboundA = (3 + 16epsilon) * epsilon
    ccwerrboundB = (2 + 12 * epsilon) * epsilon
    ccwerrboundC = (9 + 64epsilon) * epsilon^2
    o3derrboundA = (7 + 56epsilon) * epsilon
    o3derrboundB = (3 + 28epsilon) * epsilon
    o3derrboundC = (26 + 288epsilon) * epsilon^2
    iccerrboundA = (10 + 96epsilon) * epsilon
    iccerrboundB = (4 + 48epsilon) * epsilon
    iccerrboundC = (44 + 576epsilon) * epsilon^2
    isperrboundA = (16 + 224epsilon) * epsilon
    isperrboundB = (5 + 72epsilon) * epsilon
    isperrboundC = (71 + 1408epsilon) * epsilon^2
    return InitConstants{T}(
        epsilon,
        splitter,
        resulterrbound,
        ccwerrboundA,
        ccwerrboundB,
        ccwerrboundC,
        o3derrboundA,
        o3derrboundB,
        o3derrboundC,
        iccerrboundA,
        iccerrboundB,
        iccerrboundC,
        isperrboundA,
        isperrboundB,
        isperrboundC
    )
end

const IC64 = InitConstants{Float64}()
const IC32 = InitConstants{Float32}()
for e in fieldnames(InitConstants)
    @eval @inline $e(::Type{Float64}) = IC64.$e 
    @eval @inline $e(::Type{Float32}) = IC32.$e 
end

@inline setindex!!(tup::Tuple, value, index) = @inbounds index > length(tup) ? tup : Base.setindex(tup, value, index)
@inline setindex!!(vec::AbstractVector, value, index) = @inbounds Base.setindex!(vec, value, index)
@inline safe_getindex(e, eindex, elen) = (eindex ≤ elen && eindex ≤ length(e)) ? @inbounds(e[eindex]) : zero(eltype(e)) # Shewchuk's code is relying on undefined behaviour from out-of-bounds access where we call this. We need to be careful.

function grow_expansion(elen, e, b, h)
    @inbounds begin
        Q = b
        for eindex in 1:elen
            enow = e[eindex]
            Q, hh = Two_Sum(Q, enow)
            h = setindex!!(h, hh, eindex)
        end
        h = setindex!!(h, Q, elen + 1)
        return h, elen + 1
    end
end

function grow_expansion_zeroelim(elen, e, b, h)
    @inbounds begin
        hindex = 1
        Q = b
        for eindex in 1:elen
            enow = e[eindex]
            Q, hh = Two_Sum(Q, enow)
            if !iszero(hh)
                h = setindex!!(h, hh, hindex)
                hindex += 1
            end
        end
        if !iszero(Q) || isone(hindex)
            h = setindex!!(h, Q, hindex)
            hindex += 1
        end
        return h, hindex - 1
    end
end

function expansion_sum(elen, e, flen, f, h)
    @inbounds begin
        Q = f[1]
        for hindex in 1:elen
            hnow = e[hindex]
            Q, hh = Two_Sum(Q, hnow)
            h = setindex!!(h, hh, hindex)
        end
        hindex = elen + 1
        h = setindex!!(h, Q, hindex)
        hlast = hindex
        for findex in 2:flen
            Q = f[findex]
            for hindex in findex:hlast
                hnow = h[hindex]
                Q, hh = Two_Sum(Q, hnow)
                h = setindex!!(h, hh, hindex)
            end
            hlast += 1
            h = setindex!!(h, Q, hlast)
        end
        return h, hlast
    end
end

function expansion_sum_zeroelim1(elen, e, flen, f, h)
    @inbounds begin
        Q = f[1]
        for hindex in 1:elen
            hnow = e[hindex]
            Q, hh = Two_Sum(Q, hnow)
            h = setindex!!(h, hh, hindex)
        end
        hindex = elen + 1
        h = setindex!!(h, Q, hindex)
        hlast = hindex
        for findex in 2:flen
            Q = f[findex]
            for hindex in findex:hlast
                hnow = h[hindex]
                Q, hh = Two_Sum(Q, hnow)
                h = setindex!!(h, hh, hindex)
            end
            hlast += 1
            h = setindex!!(h, Q, hlast)
        end
        hindex = 0
        for index in 1:hlast
            hnow = h[index]
            if !iszero(hnow)
                hindex += 1
                h = setindex!!(h, hnow, hindex)
            end
        end
        if iszero(hindex)
            return h, 1
        else
            return h, hindex
        end
    end
end

function expansion_sum_zeroelim2(elen, e, flen, f, h)
    @inbounds begin
        hindex = 1
        Q = f[1]
        for eindex in 1:elen
            enow = e[eindex]
            Q, hh = Two_Sum(Q, enow)
            if !iszero(hh)
                h = setindex!!(h, hh, hindex)
                hindex += 1
            end
        end
        h = setindex!!(h, Q, hindex)
        hlast = hindex
        for findex in 2:flen
            hindex = 1
            Q = f[findex]
            for eindex in 1:hlast
                enow = h[eindex]
                Q, hh = Two_Sum(Q, enow)
                if !iszero(hh)
                    h = setindex!!(h, hh, hindex)
                    hindex += 1
                end
            end
            h = setindex!!(h, Q, hindex)
            hlast = hindex
        end
        return h, hlast
    end
end

function fast_expansion_sum(elen, e, flen, f, h)
    @inbounds begin
        enow = e[1]
        fnow = f[1]
        eindex = findex = 1
        if (fnow > enow) == (fnow > -enow)
            Q = enow
            eindex += 1
            enow = safe_getindex(e, eindex, elen)
        else
            Q = fnow
            findex += 1
            fnow = safe_getindex(f, findex, flen)
        end
        hindex = 1
        if (eindex ≤ elen) && (findex ≤ flen)
            if (fnow > enow) == (fnow > -enow)
                Q, hh = Fast_Two_Sum(enow, Q)
                h = setindex!!(h, hh, hindex)
                eindex += 1
                enow = safe_getindex(e, eindex, elen)
            else
                Q, hh = Fast_Two_Sum(fnow, Q)
                h = setindex!!(h, hh, hindex)
                findex += 1
                fnow = safe_getindex(f, findex, flen)
            end
            hindex += 1
            while (eindex ≤ elen) && (findex ≤ flen)
                if (fnow > enow) == (fnow > -enow)
                    Q, hh = Two_Sum(Q, enow)
                    h = setindex!!(h, hh, hindex)
                    eindex += 1
                    enow = safe_getindex(e, eindex, elen)
                else
                    Q, hh = Two_Sum(Q, fnow)
                    h = setindex!!(h, hh, hindex)
                    findex += 1
                    fnow = safe_getindex(f, findex, flen)
                end
                hindex += 1
            end
        end
        while eindex ≤ elen
            Q, hh = Two_Sum(Q, enow)
            h = setindex!!(h, hh, hindex)
            eindex += 1
            enow = safe_getindex(e, eindex, elen)
            hindex += 1
        end
        while findex ≤ flen
            Q, hh = Two_Sum(Q, fnow)
            h = setindex!!(h, hh, hindex)
            findex += 1
            fnow = safe_getindex(f, findex, flen)
            hindex += 1
        end
        h = setindex!!(h, Q, hindex)
        return h, hindex
    end
end

function fast_expansion_sum_zeroelim(elen, e, flen, f, h)
    @inbounds begin
        enow = e[1]
        fnow = f[1]
        eindex = findex = 1
        if (fnow > enow) == (fnow > -enow)
            Q = enow 
            eindex += 1 
            enow = safe_getindex(e, eindex, elen)
        else
            Q = fnow
            findex += 1
            fnow = safe_getindex(f, findex, flen)
        end
        hindex = 1
        if (eindex ≤ elen) && (findex ≤ flen)
            if (fnow > enow) == (fnow > -enow)
                Q, hh = Fast_Two_Sum(enow, Q)
                eindex += 1
                enow = safe_getindex(e, eindex, elen)
            else
                Q, hh = Fast_Two_Sum(fnow, Q)
                findex += 1
                fnow = safe_getindex(f, findex, flen)
            end
            if !iszero(hh)
                h = setindex!!(h, hh, hindex)
                hindex += 1
            end
            while (eindex ≤ elen) && (findex ≤ flen)
                if (fnow > enow) == (fnow > -enow)
                    Q, hh = Two_Sum(Q, enow)
                    eindex += 1
                    enow = safe_getindex(e, eindex, elen)
                else
                    Q, hh = Two_Sum(Q, fnow)
                    findex += 1
                    fnow = safe_getindex(f, findex, flen)
                end
                if !iszero(hh)
                    h = setindex!!(h, hh, hindex)
                    hindex += 1
                end
            end
        end
        while eindex ≤ elen
            Q, hh = Two_Sum(Q, enow)
            eindex += 1
            enow = safe_getindex(e, eindex, elen)
            if !iszero(hh)
                h = setindex!!(h, hh, hindex)
                hindex += 1
            end
        end
        while findex ≤ flen
            Q, hh = Two_Sum(Q, fnow)
            findex += 1
            fnow = safe_getindex(f, findex, flen)
            if !iszero(hh)
                h = setindex!!(h, hh, hindex)
                hindex += 1
            end
        end
        if !iszero(Q) || isone(hindex)
            h = setindex!!(h, Q, hindex)
            hindex += 1
        end
        return h, hindex - 1
    end
end

function linear_expansion_sum(elen, e, flen, f, h)
    @inbounds begin
        enow = e[1]
        fnow = f[1]
        eindex = findex = 1
        if (fnow > enow) == (fnow > -enow)
            g0 = enow
            eindex += 1
            enow = safe_getindex(e, eindex, elen)
        else
            g0 = fnow
            findex += 1
            fnow = safe_getindex(f, findex, flen)
        end
        if (eindex ≤ elen) && ((findex > flen) || ((fnow > enow) == (fnow > -enow)))
            Q, q = Fast_Two_Sum(enow, g0)
            eindex += 1
            enow = safe_getindex(e, eindex, elen)
        else
            Q, q = Fast_Two_Sum(fnow, g0)
            findex += 1
            fnow = safe_getindex(f, findex, flen)
        end
        local hindex = 0
        for outer hindex in 1:(elen+flen-2)
            if (eindex ≤ elen) && ((findex > flen) || ((fnow > enow) == (fnow > -enow)))
                R, hh = Fast_Two_Sum(enow, q)
                h = setindex!!(h, hh, hindex)
                eindex += 1
                enow = safe_getindex(e, eindex, elen)
            else
                R, hh = Fast_Two_Sum(fnow, q)
                h = setindex!!(h, hh, hindex)
                findex += 1
                fnow = safe_getindex(f, findex, flen)
            end
            Q, q = Two_Sum(Q, R)
        end
        h = setindex!!(h, q, hindex + 1)
        h = setindex!!(h, Q, hindex + 2)
        return h, hindex + 2
    end
end

function linear_expansion_sum_zeroelim(elen, e, flen, f, h)
    @inbounds begin
        enow = e[1]
        fnow = f[1]
        eindex = findex = hindex = 1
        if (fnow > enow) == (fnow > -enow)
            g0 = enow
            eindex += 1
            enow = safe_getindex(e, eindex, elen)
        else
            g0 = fnow
            findex += 1
            fnow = safe_getindex(f, findex, flen)
        end
        if (eindex ≤ elen) && ((findex > flen) || ((fnow > enow) == (fnow > -enow)))
            Q, q = Fast_Two_Sum(enow, g0)
            eindex += 1
            enow = safe_getindex(e, eindex, elen)
        else
            Q, q = Fast_Two_Sum(fnow, g0)
            findex += 1
            fnow = safe_getindex(f, findex, flen)
        end
        for _ in 3:(elen+flen)
            if (eindex ≤ elen) && ((findex > flen) || ((fnow > enow) == (fnow > -enow)))
                R, hh = Fast_Two_Sum(enow, q)
                eindex += 1
                enow = safe_getindex(e, eindex, elen)
            else
                R, hh = Fast_Two_Sum(fnow, q)
                findex += 1
                fnow = safe_getindex(f, findex, flen)
            end
            Q, q = Two_Sum(Q, R)
            if !iszero(hh)
                h = setindex!!(h, hh, hindex)
                hindex += 1
            end
        end
        if !iszero(q)
            h = setindex!!(h, q, hindex)
            hindex += 1
        end
        if !iszero(Q) || isone(hindex)
            h = setindex!!(h, Q, hindex)
            hindex += 1
        end
        return h, hindex - 1
    end
end

function scale_expansion(elen, e, b, h)
    @inbounds begin
        bhi, blo = Split(b)
        Q, hh = Two_Product_Presplit(e[1], b, bhi, blo)
        h = setindex!!(h, hh, 1)
        hindex = 2
        for eindex in 2:elen
            enow = e[eindex]
            product1, product0 = Two_Product_Presplit(enow, b, bhi, blo)
            sum, hh = Two_Sum(Q, product0)
            h = setindex!!(h, hh, hindex)
            hindex += 1
            Q, hh = Two_Sum(product1, sum)
            h = setindex!!(h, hh, hindex)
            hindex += 1
        end
        h = setindex!!(h, Q, hindex)
        return h, 2elen
    end
end

function scale_expansion_zeroelim(elen, e, b, h)
    @inbounds begin
        bhi, blo = Split(b)
        Q, hh = Two_Product_Presplit(e[1], b, bhi, blo)
        hindex = 1
        if !iszero(hh)
            h = setindex!!(h, hh, hindex)
            hindex += 1
        end
        for eindex in 2:elen
            enow = e[eindex]
            product1, product0 = Two_Product_Presplit(enow, b, bhi, blo)
            sum, hh = Two_Sum(Q, product0)
            if !iszero(hh)
                h = setindex!!(h, hh, hindex)
                hindex += 1
            end
            Q, hh = Fast_Two_Sum(product1, sum)
            if !iszero(hh)
                h = setindex!!(h, hh, hindex)
                hindex += 1
            end
        end
        if !iszero(Q) || isone(hindex)
            h = setindex!!(h, Q, hindex)
            hindex += 1
        end
        return h, hindex - 1
    end
end

function compress(elen, e, h)
    @inbounds begin
        bottom = elen
        Q = e[bottom]
        for eindex in (elen-1):-1:1
            enow = e[eindex]
            Qnew, q = Fast_Two_Sum(Q, enow)
            if !iszero(q)
                h = setindex!!(h, Qnew, bottom)
                bottom -= 1
                Q = q
            else
                Q = Qnew
            end
        end
        top = 1
        for hindex in (bottom+1):elen
            hnow = h[hindex]
            Qnew, q = Fast_Two_Sum(hnow, Q)
            if !iszero(q)
                h = setindex!!(h, q, top)
                top += 1
            end
            Q = Qnew
        end
        h = setindex!!(h, Q, top)
        return h, top
    end
end

function estimate(elen, e)
    @inbounds begin
        Q = e[1]
        for i in 2:elen
            Q += e[i]
        end
        return Q
    end
end

using AdaptivePredicates
using Test
using Supposition
import ExactPredicates: ExactPredicates
using Aqua

@testset "Aqua" begin
    Aqua.test_all(AdaptivePredicates)
end

const AP = AdaptivePredicates
cd("original") do
    include("compile.jl")
end
include("CPredicates.jl")
import .CPredicates as C

include("utils.jl")

@testset "Check exactinit()" begin
    @test AP.InitConstants{Float64}(C.C64_consts...) == AP.IC64
    @test AP.InitConstants{Float32}(C.C32_consts...) == AP.IC32
end

const MACROS = (
    MacroMethod(:Absolute, 1),
    MacroMethod(:Fast_Two_Sum_Tail, 3),
    MacroMethod(:Fast_Two_Sum, 2),
    MacroMethod(:Fast_Two_Diff_Tail, 3),
    MacroMethod(:Fast_Two_Diff, 2),
    MacroMethod(:Two_Sum_Tail, 3),
    MacroMethod(:Two_Sum, 2),
    MacroMethod(:Two_Diff_Tail, 3),
    MacroMethod(:Two_Diff, 2),
    MacroMethod(:Split, 1),
    MacroMethod(:Two_Product_Tail, 3),
    MacroMethod(:Two_Product, 2),
    MacroMethod(:Two_Product_Presplit, 4),
    MacroMethod(:Two_Product_2Presplit, 6),
    MacroMethod(:Square_Tail, 2),
    MacroMethod(:Square, 1),
    MacroMethod(:Two_One_Sum, 3),
    MacroMethod(:Two_One_Diff, 3),
    MacroMethod(:Two_Two_Sum, 4),
    MacroMethod(:Two_Two_Diff, 4),
    MacroMethod(:Four_One_Sum, 5),
    MacroMethod(:Four_Two_Sum, 6),
    MacroMethod(:Four_Four_Sum, 8),
    MacroMethod(:Eight_One_Sum, 9),
    MacroMethod(:Eight_Two_Sum, 10),
    MacroMethod(:Eight_Four_Sum, 12),
    MacroMethod(:Two_One_Product, 3),
    MacroMethod(:Four_One_Product, 5),
    MacroMethod(:Two_Two_Product, 4),
    MacroMethod(:Two_Square, 2)
)
_sum_size(args) = length(args[end])
_grow_size(args) = length(args[end]) + length(args[end-1])
_scale_size(args) = 2length(args[end-1])
const ARITHMETIC = (
    ArithmeticMethod(:grow_expansion, 3, (-1, 1, _grow_size)),
    ArithmeticMethod(:grow_expansion_zeroelim, 3, (-1, 1, _grow_size)),
    ArithmeticMethod(:expansion_sum, 3, (-1, -1, _grow_size)),
    ArithmeticMethod(:expansion_sum_zeroelim1, 3, (-1, -1, _grow_size)),
    ArithmeticMethod(:expansion_sum_zeroelim2, 3, (-1, -1, _grow_size)),
    ArithmeticMethod(:fast_expansion_sum, 3, (-1, -1, _grow_size)),
    ArithmeticMethod(:fast_expansion_sum_zeroelim, 3, (-1, -1, _grow_size)),
    ArithmeticMethod(:linear_expansion_sum, 3, (-1, -1, _grow_size)),
    ArithmeticMethod(:linear_expansion_sum_zeroelim, 3, (-1, -1, _grow_size)),
    ArithmeticMethod(:scale_expansion, 3, (-1, 1, _scale_size)),
    ArithmeticMethod(:scale_expansion_zeroelim, 3, (-1, 1, _scale_size)),
    ArithmeticMethod(:compress, 2, (-1, _sum_size)),
    ArithmeticMethod(:estimate, 1, (-1,))
)
const PREDICATES = (
    PredicateMethod(:orient2, 3, 2),
    PredicateMethod(:orient3, 4, 3),
    PredicateMethod(:incircle, 4, 2),
    PredicateMethod(:insphere, 5, 3)
)

const MACRO_FAILURE = FailedTest[]
const ARITHMETIC_FAILURE = FailedTest[]
const PREDICATE_FAILURE = FailedTest[]

@testset "Exact Equality Tests" begin
    @testset "Macros" begin
        foreach(MACROS) do f
            @repeat test_f(f; failures=MACRO_FAILURE)
        end
    end

    @testset "Arithmetic" begin
        foreach(ARITHMETIC) do f
            @repeat test_f(f; failures=ARITHMETIC_FAILURE)
        end
    end

    @testset "Predicates" begin
        foreach(PREDICATES) do f
            @repeat test_f(f; failures=PREDICATE_FAILURE)
        end
    end
end

check_range(x::Float64) = iszero(x) || exponent(abs(x)) ∈ -142:201 # Ranges are explained in the README
check_range(x::Float32) = iszero(x) || exponent(abs(x)) ∈ -24:24 # Don't know the exact range for Float32, it might be [-3, 24] but ExactPredicates doesn't use Float32 anyway for me to confirm.
@testset "Supposition tests" begin
    for (T, Tn) in ((Float64, 64), (Float32, 32))
        fgen = Data.Floats{T}(infs=false, nans=false)
        cgen = @composed _complex(a=fgen, b=fgen) = a + b * im
        r2gen = @composed _tuple(a=fgen, b=fgen) = (a, b)
        r3gen = @composed _tuple(a=fgen, b=fgen, c=fgen) = (a, b, c)
        igen = Data.Integers(-100, 100)
        i2gen = @composed _ituple(a=igen, b=igen) = (a, b)
        i3gen = @composed _ituple(a=igen, b=igen, c=igen) = (a, b, c)
        # Against C
        ## standard
        @check function _orient2(p=cgen, q=cgen, r=cgen)
            assume!(all(check_range, (p.re, p.im, q.re, q.im, r.re, r.im)))
            ap = orient2(p, q, r)
            c = C.orient2d((p.re, p.im), (q.re, q.im), (r.re, r.im))
            event!("AdaptiveOrient2$(Tn)", ap)
            event!("COrient2$(Tn)", c)
            ap == c
        end

        @check function _orient3(p=r3gen, q=r3gen, r=r3gen, s=r3gen)
            assume!(all(check_range, (p..., q..., r..., s...)))
            ap = orient3(p, q, r, s)
            c = C.orient3d(p, q, r, s)
            event!("AdaptiveOrient3$(Tn)", ap)
            event!("COrient3$(Tn)", c)
            ap == c
        end

        @check function _incircle(p=r2gen, q=r2gen, r=r2gen, s=r2gen)
            assume!(all(check_range, (p..., q..., r..., s...)))
            ap = incircle(p, q, r, s)
            c = C.incircle(p, q, r, s)
            event!("AdaptiveIncircle$(Tn)", ap)
            event!("CIncircle$(Tn)", c)
            ap == c
        end

        @check function _insphere(p=r3gen, q=r3gen, r=r3gen, s=r3gen, t=r3gen)
            assume!(all(check_range, (p..., q..., r..., s..., t...)))
            ap = insphere(p, q, r, s, t)
            c = C.insphere(p, q, r, s, t)
            event!("AdaptiveInsphere$(Tn)", ap)
            event!("CInsphere$(Tn)", c)
            ap == c
        end

        # Against ExactPredicates
        if T ≠ Float32
            @check function _orient2p(p=cgen, q=cgen, r=cgen)
                assume!(all(check_range, (p.re, p.im, q.re, q.im, r.re, r.im)))
                ap = orient2p(p, q, r)
                c = ExactPredicates.orient((p.re, p.im), (q.re, q.im), (r.re, r.im))
                event!("AdaptiveOrient2$(Tn)", ap)
                event!("ExactPredicatesOrient2$(Tn)", c)
                ap == c
            end

            @check function _orient3p(p=r3gen, q=r3gen, r=r3gen, s=r3gen)
                assume!(all(check_range, (p..., q..., r..., s...)))
                ap = orient3p(p, q, r, s)
                c = ExactPredicates.orient(p, q, r, s)
                event!("AdaptiveOrient3$(Tn)", ap)
                event!("ExactPredicatesOrient3$(Tn)", c)
                ap == c
            end

            @check function _incirclep(p=r2gen, q=r2gen, r=r2gen, s=r2gen)
                assume!(all(check_range, (p..., q..., r..., s...)))
                ap = incirclep(p, q, r, s)
                c = ExactPredicates.incircle(p, q, r, s)
                event!("AdaptiveIncircle$(Tn)", ap)
                event!("ExactPredicatesIncircle$(Tn)", c)
                ap == c
            end

            @check function _inspherep(p=r3gen, q=r3gen, r=r3gen, s=r3gen, t=r3gen)
                assume!(all(check_range, (p..., q..., r..., s..., t...)))
                ap = inspherep(p, q, r, s, t)
                c = ExactPredicates.insphere(p, q, r, s, t)
                event!("AdaptiveInsphere$(Tn)", ap)
                event!("ExactPredicatesInsphere$(Tn)", c)
                ap == c
            end

            # integers 

            @check function _intorient2p(p=i2gen, q=i2gen, r=i2gen)
                assume!(all(check_range, (T.(p)..., T.(q)..., T.(r)...)))
                ap = orient2p(T.(p), T.(q), T.(r))
                c = ExactPredicates.orient(T.(p), T.(q), T.(r))
                event!("AdaptiveOrient2Int$(Tn)", ap)
                event!("ExactPredicatesOrient2Int$(Tn)", c)
                ap == c
            end

            @check function _intorient3p(p=i3gen, q=i3gen, r=i3gen, s=i3gen)
                assume!(all(check_range, (T.(p)..., T.(q)..., T.(r)..., T.(s)...)))
                ap = orient3p(T.(p), T.(q), T.(r), T.(s))
                c = ExactPredicates.orient(T.(p), T.(q), T.(r), T.(s))
                event!("AdaptiveOrient3Int$(Tn)", ap)
                event!("ExactPredicatesOrient3Int$(Tn)", c)
                ap == c
            end

            @check function _intincirclep(p=i2gen, q=i2gen, r=i2gen, s=i2gen)
                assume!(all(check_range, (T.(p)..., T.(q)..., T.(r)..., T.(s)...)))
                ap = incirclep(T.(p), T.(q), T.(r), T.(s))
                c = ExactPredicates.incircle(T.(p), T.(q), T.(r), T.(s))
                event!("AdaptiveIncircleInt$(Tn)", ap)
                event!("ExactPredicatesIncircleInt$(Tn)", c)
                ap == c
            end

            @check function _intinspherep(p=i3gen, q=i3gen, r=i3gen, s=i3gen, t=i3gen)
                assume!(all(check_range, (T.(p)..., T.(q)..., T.(r)..., T.(s)..., T.(t)...)))
                ap = inspherep(T.(p), T.(q), T.(r), T.(s), T.(t))
                c = ExactPredicates.insphere(T.(p), T.(q), T.(r), T.(s), T.(t))
                event!("AdaptiveInsphereInt$(Tn)", ap)
                event!("ExactPredicatesInsphereInt$(Tn)", c)
                ap == c
            end
        end
    end
end

@testset "Caches" begin
    function check_non_overlapping(args...)
        ranges = first.(parentindices.(args))
        flag = !issorted(ranges)
        flag && return false
        for i in 1:(length(ranges)-1)
            rᵢ, rᵢ₊₁ = ranges[i], ranges[i+1]
            !isdisjoint(rᵢ, rᵢ₊₁) && return false
        end
        return true
    end
    function check_gaps(args...)
        ranges = first.(parentindices.(args))
        firstdiffs = diff(collect(first.(ranges)))
        boundaries = firstdiffs .% 64
        return all(iszero, boundaries)
    end
    v = zeros(100)
    v1, v2, v3 = view(v, 1:3), view(v, 2:4), view(v, 7:100)
    @test !check_non_overlapping(v1, v2, v3)
    @test !check_gaps(v1, v2, v3)

    function test_cache(f, lengths)
        for T in (Float64, Float32)
            args1 = f(T)
            args2 = f(T, nothing)
            for args in (args1, args2)
                @test check_non_overlapping(args...)
                @test all(lengths .== length.(args))
                @test all(Base.Fix1(===, parent(args[1])), parent.(args))
                @test all(x -> eltype(x) === T, args)
                @test check_gaps(args...)
                @test f(T, args) === args
            end
        end
    end
    test_cache(AP.incircleexact_cache, (48, 48, 96, 96, 96, 96, 192, 192, 384))
    test_cache(AP.incircleslow_cache, (64, 64, 64, 64, 64, 64, 128, 128, 192, 192, 384, 384, 384, 768, 1152))
    test_cache(AP.incircleadapt_cache, (48, 64, 1152, 1152))
    test_cache(AP.insphereslow_cache, (64, 64, 64, 128, 192, 384, 384, 384, 384, 384, 384, 768, 768, 768, 768, 768, 768, 768, 768, 768, 1536, 1536, 1536, 2304, 2304, 2304, 4608, 6912, 6912, 6912, 6912, 13824, 13824, 27648))
    test_cache(AP.insphereexact_cache, (48, 48, 96, 96, 96, 96, 96, 192, 288, 288, 288, 288, 384, 384, 384, 576, 576, 768, 1152, 1152, 1152, 1152, 1152, 2304, 2304, 3456, 5760))
    test_cache(AP.orient3exact_cache, (48, 48, 96))
    test_cache(AP.orient3slow_cache, (64, 64, 64, 128, 192))
    test_cache(AP.orient3adapt_cache, (192, 192))
end


@testset "@check_length" begin
    function test_macro(_val)
        args = (2.0, -2.0, 3.0)
        AP.@check_length test_return args val, len = test_call(_val)
        return val, _val, len
    end
    function test_call(x)
        return 15.0, x > 2 ? 17 : 50
    end
    function test_return(x, y, z)
        return x + y + z
    end
    @test test_macro(5.0) == (15.0, 5.0, 17)
    @test test_macro(1.0) == 3.0
    expr = @macroexpand function test_macro(_val)
        args = (2.0, -2.0, 3.0)
        AP.@check_length test_return args val, len = test_call(_val)
        return val, _val, len
    end
    Base.remove_linenums!(expr)
    @test sprint(show, expr) == ":(function test_macro(_val)\n      args = (2.0, -2.0, 3.0)\n      begin\n          (val, len) = test_call(_val)\n          len < 32 || return test_return(args...)\n      end\n      return (val, _val, len)\n  end)"
end
